//Air spin ability - Cube Hammer

sfxinfo[freeslot("sfx_wscub1")].caption = "Hammer swing"
sfxinfo[freeslot("sfx_wscub2")].caption = "Hammer slam"
sfxinfo[freeslot("sfx_wscub3")].caption = "Hammer charge"

sfxinfo[freeslot("sfx_wsfrz1")].caption = "Cube-ified"
sfxinfo[freeslot("sfx_wsfrz2")].caption = "Un-cube-ified"
sfxinfo[freeslot("sfx_wsfrz3")].caption = "Cube ring"

//Whisper Ring
function A_WhisperRing(mobj, var1, var2)
	P_TryMove(mobj, mobj.x, mobj.y, true)
	P_ButteredSlope(mobj)
		
	if mobj.fuse
		A_AttractChase(mobj, var1, var2)
		if mobj.tracer
			if not (mobj.flags & MF_NOGRAVITY)
				mobj.flags = $ | MF_NOGRAVITY
			end
		elseif mobj.flags & MF_NOGRAVITY
			mobj.flags = $ &~ MF_NOGRAVITY
		end
	end
	
	if P_IsObjectOnGround(mobj)
		mobj.z = $ + P_MobjFlip(mobj)
		if maptol & TOL_NIGHTS
			mobj.momz = -FixedDiv(mobj.reactiontime, 10*FRACUNIT)
		else
			mobj.momz = -FixedMul(mobj.reactiontime, FixedDiv(17*FRACUNIT,20*FRACUNIT))
		end
		
		mobj.momx = $*3/4
		mobj.momy = $*3/4
	else
		mobj.reactiontime = mobj.momz
	end
	
	if not mobj.fuse
		mobj.shadowscale = 2*FRACUNIT/3
		mobj.fuse = TICRATE*8
	elseif mobj.fuse < TICRATE*2
		if mobj.fuse & 1
			mobj.flags2 = $ &~ MF2_DONTDRAW
		else
			mobj.flags2 = $ | MF2_DONTDRAW
		end
	end
end

function A_WhisperColor(mobj, var1, var2)
	mobj.color = var1
	if var2 then mobj.colorized = true
	else mobj.colorized = false end
end

freeslot("MT_WHISPER_RING", "SPR_WSRN", "S_WHISPER_RING", "S_WHISPER_RING2")
states[S_WHISPER_RING] = {SPR_WSRN, FF_ANIMATE|FF_GLOBALANIM, 1, A_WhisperRing, X, 1, S_WHISPER_RING}
states[S_WHISPER_RING2] = {SPR_WSRN, 0, 0, A_WhisperColor, SKINCOLOR_SUPERCUBE2, 1, S_SPRK1}

mobjinfo[MT_WHISPER_RING] = {
	spawnstate = S_WHISPER_RING,
	deathstate = S_WHISPER_RING2,
	deathsound = sfx_wsfrz3,
	spawnhealth = 1000,
	speed = 38*FRACUNIT,
	radius = 15*FRACUNIT,
	height = 24*FRACUNIT,
	damage = 0,
	mass = 100,
	flags = MF_SLIDEME|MF_SPECIAL,
}

addHook("TouchSpecial", function(mobj, mo)
	local player = mo.player
	if not player
	or not P_CanPickupItem(player, false) and not (mobj.flags2 & MF2_NIGHTSPULL)
		return true
	end

	A_ForceStop(mobj)
	P_GivePlayerRings(player, 1)
	
	S_StartSound(mo, mobj.info.deathsound)
	mobj.colorized = true
	
	P_KillMobj(mobj, nil, mo, 0)
	mobj.shadowscale = 0
	
	return true
end, MT_WHISPER_RING)

//Cube effect
freeslot("SPR_WSHM", "S_WHISPER_CUBE")
function A_WhisperCube(mobj, var1, var2)
    mobj.momz = $*var1/var2
	
	if ((mobj.frame & FF_TRANSMASK) >> FF_TRANSSHIFT) < (NUMTRANSMAPS-1) - (2*mobj.fuse)/3
		// fade out when nearing the end of fuse...
		mobj.frame = (mobj.frame & ~FF_TRANSMASK) | (((NUMTRANSMAPS-1) - (2*mobj.fuse)/3) << FF_TRANSSHIFT)
	end
end
states[S_WHISPER_CUBE] = {SPR_WSHM, E, 1, A_WhisperCube, 7, 8, S_WHISPER_CUBE}

//No more cube, get uncubified
rawset(_G, "WhisperUnCube", function(mobj)
	if not mobj or not mobj.whispercubed then return end

	//Effect
	WhisperCircle(mobj, MT_GHOST, 16, mobj.scale, 0,
	mobj.scale/2, 1, SKINCOLOR_BLUE)
	
	local thok = P_SpawnMobj(mobj.x, mobj.y, mobj.z + mobj.height/2, MT_THOK)
	thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	thok.blendmode = AST_ADD
	thok.color = SKINCOLOR_COBALT
	
	thok.state = S_WHISPER_CIRCLE
	thok.angle = mobj.angle + ANGLE_90
	
	thok.scale = mobj.scale
	thok.scalespeed = FixedMul($, thok.scale)
	thok.destscale = INT32_MAX
	
	//Set hitbox
	mobj.radius = mobj.whisperradius or $
	mobj.height = mobj.whisperheight or $
	
	//Set breath
	if mobj.player
		if mobj.whisperwater != nil and mobj.player.powers[pw_underwater]
			mobj.player.powers[pw_underwater] = mobj.whisperwater
		end
		mobj.whisperwater = nil
		
		if mobj.whisperspace != nil and mobj.player.powers[pw_spacetime]
			mobj.player.powers[pw_spacetime] = mobj.whisperspace
		end
		mobj.whisperspace = nil
	end
	
	//Set flags
	mobj.flags = mobj.whispercubed
	mobj.whispercubed = nil
	
	//Set state
	if mobj.player and (mobj.player.panim == PA_PAIN or P_PlayerInPain(mobj.player))
		mobj.state = S_PLAY_FALL
	end
	
	//Remove solid
	if mobj.whispersolid and mobj.whispersolid.valid
		P_RemoveMobj(mobj.whispersolid)
	end
end)

//Cube wall
freeslot("MT_WHISPER_CUBEWALL", "S_WHISPER_CUBEWALL")
states[S_WHISPER_CUBEWALL] = {SPR_WSHM, F|FF_PAPERSPRITE, -1, nil, 0, 0, S_NULL}
mobjinfo[MT_WHISPER_CUBEWALL] = {
	spawnstate = S_WHISPER_CUBEWALL,
	spawnhealth = 1000,
	height = 1,
	radius = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY,
}

//Cube wall death prevention
addHook("MobjCollide", function(mobj, mo)
	if mo and mo.valid and mo.player
	and mobj and mobj.valid and mobj.threshold == 7
	and mobj.z - mobj.scale <= mo.z + mo.height
	and mobj.z + mobj.height + mobj.scale >= mo.z
		mo.whispernocrush = 2
	end
end, MT_WHISPER_CUBEWALL)

addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if mo.whispernocrush and dmgtype == DMG_CRUSHED then return false end
end, MT_PLAYER)

//Cube wall thinker
addHook("MobjThinker", function(mobj)
	if not mobj.threshold then return end
	local tracer = mobj.tracer
	
	if not (tracer and tracer.valid and tracer.whispercubed)
		P_RemoveMobj(mobj)
		return
	elseif not tracer.health
		S_StartSound(tracer, sfx_wsfrz1)
		WhisperUnCube(tracer)
		
		P_RemoveMobj(mobj)
		return
	end
	
	A_CapeChase(mobj,1,0)
	if not (mobj and mobj.valid) then return end
	
	mobj.scale = tracer.scale
	if not mobj.reactiontime
		mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		mobj.blendmode = AST_ADD
		
		if mobj.threshold == 7
			mobj.flags = MF_SCENERY|MF_NOGRAVITY|MF_SOLID|MF_NOCLIPHEIGHT
			mobj.state = S_INVISIBLE
		elseif mobj.threshold > 4
			mobj.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD
			mobj.frame = $ + (mobj.threshold & 1) + 1
		end
	end
	mobj.reactiontime = $ + 1
	
	if mobj.threshold == 7
		mobj.radius = tracer.radius
		mobj.height = tracer.height
		A_CapeChase(mobj,1,0)
		
		if tracer.player
			tracer.state = S_PLAY_STUN
			tracer.tics = -1
		end
		
		if P_IsObjectOnGround(mobj)
			local oldtracer = tracer.tracer
			tracer.tracer = mobj
			if P_MobjFlip(mobj) > 0
				mobj.z = max($, P_FloorzAtPos(mobj.x, mobj.y, mobj.z, mobj.height))
			else
				mobj.z = min($, P_CeilingzAtPos(mobj.x, mobj.y, mobj.z, mobj.height) - mobj.height)
			end
			A_CapeChase(tracer,1,0)
			tracer.tracer = oldtracer
		end
		
		if mobj.reactiontime >= TICRATE*15
		or (tracer.flags & MF_BOSS and mobj.reactiontime >= TICRATE*2)
			S_StartSound(tracer, sfx_wsfrz1)
			WhisperUnCube(tracer)
		end
	elseif mobj.threshold > 4
		mobj.spritexscale = FixedDiv(tracer.radius, mobj.scale)/31
		mobj.spriteyscale = mobj.spritexscale
		
		mobj.spriteyoffset = -31*FRACUNIT
		mobj.angle = 0
		
		if mobj.threshold & 1 and tracer.threshold <= 1
			mobj.shadowscale = FRACUNIT*2
		else
			mobj.z = $ + tracer.height*P_MobjFlip(mobj)
		end
	else
		mobj.angle = mobj.movedir
		local angle = mobj.angle - ANGLE_90
		local thrust = tracer.radius
		P_TeleportMove(mobj, mobj.x + P_ReturnThrustX(nil, angle, thrust),
		mobj.y + P_ReturnThrustY(nil, angle, thrust), mobj.z)
		
		thrust = FixedDiv($, tracer.scale)
		mobj.spritexscale = thrust/31
		mobj.spriteyscale = FixedDiv(tracer.height, tracer.scale)/61
	end
end, MT_WHISPER_CUBEWALL)

//No damaging cubed objects
addHook("ShouldDamage", function(mobj)
	if mobj.whispercubed then return false end
end)

//Physically damage other players with the hammer even without BattleMod
addHook("MobjMoveCollide", function(mo, target)
	if not CBW_Battle and mo.player and target.player and mo.skin == "whisper"
	and mo.player.panim == PA_ABILITY2
	and target.z - target.scale <= mo.z + mo.height
	and target.z + target.height + target.scale >= mo.z
	and P_PlayerCanDamage(mo.player, target)
		P_DamageMobj(target, mo, mo)
	end
end, MT_PLAYER)

//Cube hammer landing (done in this hook so we can override the vanilla landing)
addHook("ThinkFrame", do for player in players.iterate
	if WhisperCantMove(player) then continue end
	local mo = player.mo
	
	if mo.state == S_PLAY_MELEE_LANDING and not mo.whisperslam
		S_StopSoundByID(mo, sfx_s3k8b)
		S_StartSoundAtVolume(mo, sfx_wscub2, 192)
		
		//Quake
		if player == displayplayer or player == secondarydisplayplayer
		or (displayplayer and displayplayer.mo
		and P_AproxDistance(mo.x - displayplayer.mo.x,
		mo.y - displayplayer.mo.y) < FixedMul(3*RING_DIST, mo.scale))
			P_StartQuake(24*mo.scale, 7)
		end
		
		//Circle/Cube effect
		local dust = P_SpawnMobjFromMobj(mo,
		P_ReturnThrustX(nil, player.drawangle, mo.height),
		P_ReturnThrustY(nil, player.drawangle, mo.height),
		0, MT_DUST)
		
		dust.state = S_INVISIBLE
		dust.tics = 1
		
		dust.radius = mo.radius
		dust.height = mo.radius
		dust.flags = $ &~ MF_NOCLIPHEIGHT
		dust.z = $
		
		WhisperCircle(dust, MT_GHOST, 16, mo.scale, 0,
		mo.scale/2, 1, SKINCOLOR_BLUE)
		
		WhisperCircle(dust, MT_GHOST, 16, 16*mo.scale*(player.powers[pw_super] and 2 or 1), 0,
		mo.scale/4, 1, SKINCOLOR_BLUE)
		
		for i = 1, 2
			local thok = P_SpawnMobj(dust.x, dust.y, dust.z, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_COBALT
			
			thok.scale = dust.scale*i*(player.powers[pw_super] and 2 or 1)
			thok.height = thok.scale
			thok.z = $ + 4*thok.scale*P_MobjFlip(mo)
			thok.state = S_WHISPER_CIRCLE
			thok.scalespeed = FixedMul($, thok.scale*2)
			thok.destscale = INT32_MAX
		end
		
		//Don't slam more than once
		mo.whisperslam = true
		
		//Do the cube-ifying
		local maxdist = FixedMul(RING_DIST*2/3, mo.scale)
		if player.powers[pw_super] then maxdist = $*2 end
		local cubed = false
		local uncubed = false
		searchBlockmap("objects",function(refmobj,mobj)
			if mobj == mo or mobj.flags2 & MF2_FRET or mobj.health <= 0
			or (mobj.flags & MF_NOCLIPTHING and not mobj.whispercubed)
			or (not P_IsObjectOnGround(mobj) and not mobj.whispercubed and not player.powers[pw_super])
			or not (mobj.flags & MF_SHOOTABLE or mobj.whispercubed
			or mobj.type == MT_ROSY or mobj.type == MT_EGGGUARD
			or mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
			or (mobj.type == MT_METALSONIC_BATTLE and mobj.state == mobj.info.spawnstate))
			or (mobj.player and mobj.player.powers[pw_flashing] and not mobj.whispercubed)
			or P_AproxDistance(P_AproxDistance(mobj.x - refmobj.x,
			mobj.y - refmobj.y), mobj.z - refmobj.z) >= maxdist
			then return end
			
			//Friendly players
			if mobj.player
			and ((gametyperules & GTR_FRIENDLY and not CV_FindVar("friendlyfire").value)
			or (G_GametypeHasTeams() and player.ctfteam == mobj.player.ctfteam)
			or (G_TagGametype() and player.pflags & PF_TAGIT == mobj.player.pflags & PF_TAGIT))
			then return end
			
			//Ugh, Metal
			if mobj.type == MT_METALSONIC_BATTLE and not mobj.whispercubed
			and not (mobj.flags2 & MF2_CLASSICPUSH) and mobj.state == mobj.info.spawnstate
				mobj.flags2 = $ | MF2_CLASSICPUSH
				
			//Spikes
			elseif mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
				P_KillMobj(mobj, mo, mo)
			
			//Cube-ify!
			elseif not mobj.whispercubed
			and (mobj.flags & (MF_ENEMY/*|MF_BOSS|MF_MONITOR*/)
			or (mobj.player and (not mobj.player.guard or mobj.player.guard < 0)))
				//Set hitbox
				mobj.whisperradius = mobj.radius
				mobj.whisperheight = mobj.height
				mobj.radius = max($*3/2, mobj.height/2)
				mobj.height = mobj.radius*2
				
				//Set flags
				mobj.whispercubed = mobj.flags
				mobj.flags = MF_NOTHINK | MF_NOGRAVITY | MF_SCENERY | MF_NOCLIPTHING | ($ & MF_BOSS)
				
				//Effect
				cubed = true
				WhisperCircle(mobj, MT_GHOST, 16, mo.scale, 0,
				mo.scale/2, 1, SKINCOLOR_BLUE)
				
				local thok = P_SpawnMobj(mobj.x, mobj.y, mobj.z + mobj.height/2, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_COBALT
				
				thok.state = S_WHISPER_CIRCLE
				thok.angle = mobj.angle + ANGLE_90
				
				thok.scale = mobj.scale
				thok.scalespeed = FixedMul($, thok.scale)
				thok.destscale = INT32_MAX
				
				//Stun players
				if mobj.player
					P_ResetPlayer(mobj.player)
					mobj.state = S_PLAY_STUN
					mobj.tics = -1
					
					if mobj.player.powers[pw_underwater]
						mobj.whisperwater = mobj.player.powers[pw_underwater]
						mobj.player.powers[pw_underwater] = -1
					end
					
					if mobj.player.powers[pw_spacetime]
						mobj.whisperspace = mobj.player.powers[pw_spacetime]
						mobj.player.powers[pw_spacetime] = -1
					end
				end
				
				//Make monitors not flicker
				if mobj.state == S_BOX_FLICKER
					mobj.state = mobj.info.spawnstate
				end
				
				//Create cube
				for i = 1, 7
					local wall = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_WHISPER_CUBEWALL)
					wall.tracer = mobj
					wall.movedir = ANGLE_90 * i
					wall.threshold = i
					
					if i == 7
						mobj.whispersolid = wall
					end
				end
				
			//Un-cube-ify!
			elseif mobj.whispercubed
				WhisperUnCube(mobj)
				
				//Remove shield
				if mobj.type == MT_EGGGUARD and mobj.tracer
					P_KillMobj(mobj.tracer, mo, mo)
				end
				
				//Damage
				local damaged = P_DamageMobj(mobj, mo, mo)
				if not (mobj and mobj.valid)
					if damaged
						//Create rings
						uncubed = true
						if not (ultimatemode
						or gametype == GT_UCOOP or gametype == GT_TUCOOP)
							WhisperCircle(refmobj, MT_WHISPER_RING, 3, mo.scale,
							player.height/2, mo.scale)
						end
					else
						cubed = true
					end
					return
				elseif not damaged and mobj.player
					cubed = true
					P_DoJump(mobj.player, false)
					mobj.state = S_PLAY_JUMP
					if not (mobj.player.cmd.buttons & BT_JUMP)
						mobj.player.pflags = $ &~ PF_STARTJUMP
					end
				elseif damaged or mobj.type == MT_EGGGUARD
					//Create rings
					uncubed = true
					if not (ultimatemode
					or gametype == GT_UCOOP or gametype == GT_TUCOOP)
						WhisperCircle(mobj, MT_WHISPER_RING, mobj.info.spawnhealth and 3 or 1, mo.scale,
						FixedDiv(mobj.height, mobj.scale*2), mo.scale)
					end
				else
					cubed = true
					return
				end
				mobj.z = $ + P_MobjFlip(mobj)
				
			//Just damage, bruh
			elseif P_DamageMobj(mobj, mo, mo)
				cubed = true
				
				if mobj and mobj.valid
					WhisperCircle(mobj, MT_GHOST, 16, mo.scale, 0,
					mo.scale/2, 1, SKINCOLOR_BLUE)
				end
			end
		end,dust,dust.x-maxdist,dust.x+maxdist,dust.y-maxdist,dust.y+maxdist)
		
		//Cubed sounds
		if cubed S_StartSound(mo, sfx_wsfrz1) end
		if uncubed S_StartSoundAtVolume(mo, sfx_wsfrz2, 192) end
	elseif mo.whisperslam and mo.state != S_PLAY_MELEE_LANDING
		mo.whisperslam = nil
	end
end end)