//Code for Whisper's followmobjs

freeslot("SPR2_SHIT")
sfxinfo[freeslot("sfx_wstrns")].caption = "/"
local GUNREACTIONTIME = TICRATE*5 + 5 //Time before color goes out

local diff = 0
local turnto = function(curangle, tarangle, factor)
	//Let's see how much we'll turn
	diff = (tarangle - curangle)
	
	//Apply it!
	if not diff
		//
	elseif (diff > ANGLE_180)
		diff = InvAngle(InvAngle(diff)/factor)
	else
		diff = $/factor
	end
	
	return curangle + diff
end

//Follower wisp
freeslot("MT_WHISPER_WISP", "S_WHISPER_WISP", "S_WHISPER_WISP2", "SPR_WSWS")
states[S_WHISPER_WISP] = {SPR_WSWS, A|FF_ANIMATE, (F+1)*2, nil, F, 2, S_INVISIBLE}
states[S_WHISPER_WISP2] = {SPR_WSWS, V|FF_ANIMATE, (F+1)*2, nil, F, 2, S_NULL}
mobjinfo[MT_WHISPER_WISP] = {
	spawnstate = S_WHISPER_WISP,
	deathstate = S_WHISPER_WISP2,
	spawnhealth = 1000,
	radius = 12*FRACUNIT,
	height = 12*FRACUNIT,
	dispoffset = 2,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

//Wisp thinker
addHook("MobjThinker", function(mobj)
	local mo = mobj.target
	local player = mo and mo.player
	
	//First person
	if player and ((player == displayplayer and camera and not camera.chase)
	or (player == secondarydisplayplayer and camera2 and not camera2.chase))
		mobj.flags2 = $ | MF2_SHADOW
	elseif mobj.flags2 & MF2_SHADOW
		mobj.flags2 = $ &~ MF2_SHADOW
	end
	
	//Color timer
	mobj.color = SKINCOLOR_SUPERLASER1 + abs( ( (mobj.cusval / 4) % 9) - 4) + mobj.threshold*5
	mobj.cusval = $ + 2
	
	//Death
	if not mobj.health
		if mo
			A_ForceStop(mobj)
			P_TeleportMove(mobj, mobj.x + (mo.x + P_ReturnThrustX(mo, player.drawangle, mo.height*2/3) - mobj.x)/4,
			mobj.y + (mo.y + P_ReturnThrustY(mo, player.drawangle, mo.height*2/3) - mobj.y)/4,
			mobj.z + ((mo.z + (P_MobjFlip(mo) > 0 and mo.height or 0)) - (mobj.z + mobj.height))/4)
		end
		mobj.shadowscale = 0
		
		return
		
	elseif not player or player.whisperwisp != mobj
	or not player.whisperwisptoggle or mo.skin != "whisper"
	or player.powers[pw_super] or player.powers[pw_carry] == CR_NIGHTSMODE
	or (player.followmobj and player.followmobj.reactiontime > GUNREACTIONTIME*6)
		P_KillMobj(mobj)
		return
	end
	
	//Movement variables
	local momx = mo.momx
	local momy = mo.momy
	local momz = mo.momz
	if player.whispersaw and player.whispersaw.valid
		momx = player.whispersaw.momx
		momy = player.whispersaw.momy
		momz = player.whispersaw.momz
	end
	
	local hdiff = mo.radius*2
	local targetx = mo.x + momx/2 - P_ReturnThrustX(mo, player.drawangle, hdiff)
	local targety = mo.y + momy/2 - P_ReturnThrustY(mo, player.drawangle, hdiff)
	local targetz = mo.z + momz/2 + (P_MobjFlip(mo) > 0 and mo.height or 0)
	
	local hdist = R_PointToDist2(mobj.x, mobj.y, targetx, targety)
	local zdist = (mobj.z + mobj.height/2) - targetz
	
	local dist = FixedHypot(hdist, zdist)
	local maxdist = mo.radius*4

	local speed = max(FixedHypot(FixedHypot(momx, momy), momz) + dist/64, 2*mo.scale)
	
	//Visuals
	mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	mobj.scale = mo.scale
	if P_MobjFlip(mo) > 0
		mobj.flags2 = $ &~ MF2_OBJECTFLIP
		mobj.eflags = $ &~ MFE_VERTICALFLIP
	else
		mobj.flags2 = $ | MF2_OBJECTFLIP
		mobj.eflags = $ | MFE_VERTICALFLIP
	end
	
	//Go to main state early so we aren't invisible for one frame
	if mobj.state == S_WHISPER_WISP and mobj.tics == 1
		mobj.state = S_INVISIBLE
		mobj.shadowscale = FRACUNIT/2
	end
	
	//Main state
	if mobj.state == S_INVISIBLE
		//Sprite
		mobj.sprite = SPR_WSWS
		mobj.frame = G + mobj.threshold*3
		
		//Sad and happy
		if P_PlayerInPain(player) and mobj.extravalue1 >= 0
			mobj.extravalue1 = -TICRATE*3/2
		elseif mobj.extravalue1 < 0 or not mo.health
			mobj.frame = $ + 2
			speed = 0
			
			mobj.cusval = $ - 1
			mobj.extravalue1 = min($ + 1, 0)
			
		elseif player.exiting or mobj.extravalue1 > 0
			mobj.frame = $ + 1
			speed = max($, 8*mo.scale)
			maxdist = 0
			
			mobj.cusval = $ + 2
			mobj.extravalue1 = max(0, $ - 1)
		end
		
		mobj.spriteyoffset = sin(ANG1*4*mobj.cusval)*8
		
	//Not in main state
	else
		mobj.movedir = R_PointToAngle2(0,0, hdist, momz)
		mobj.angle = R_PointToAngle2(0,0, momx, momy)
		mobj.movefactor = speed
		return
	end
	
	//Only move if we're too far away
	if dist > maxdist
		mobj.movefactor = max(speed, $*31/32) //Speed change
		local div = max(8 - mobj.movefactor/8/mobj.scale, 4) //Angle change
		
		//Vertical change
		mobj.movedir = turnto($, R_PointToAngle2(0,0, hdist, zdist), div)
		mobj.momz = FixedMul(-mobj.movefactor, sin(mobj.movedir))
		
		//Horizontal change
		mobj.angle = turnto($, R_PointToAngle2(mobj.x, mobj.y, targetx, targety), div)
		P_InstaThrust(mobj, mobj.angle, FixedMul(mobj.movefactor, cos(mobj.movedir)))
		
	//Slow down!
	else
		mobj.movefactor = $*7/8 //Speed change
		mobj.momx = $*7/8
		mobj.momy = $*7/8
		mobj.momz = $*7/8
		
		mobj.movedir = turnto($, R_PointToAngle2(0,0, hdist, zdist), 16)
		mobj.angle = turnto($, player.drawangle, 16)
	end
end, MT_WHISPER_WISP)

//Happiness with murder
addHook("MobjDeath", function(target, inf, mo)
	if mo and mo.player
	and mo.player.whisperwisp and mo.player.whisperwisp.valid
		if target.flags & (MF_SHOOTABLE|MF_MONITOR|MF_ENEMY|MF_BOSS)
			mo.player.whisperwisp.extravalue1 = TICRATE
		else
			mo.player.whisperwisp.extravalue1 = TICRATE/4
		end
	end
end)

//The actual followmobj
freeslot("MT_WHISPER_GUN")
mobjinfo[MT_WHISPER_GUN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	reactiontime = GUNREACTIONTIME + 1,
	dispoffset = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

freeslot("S_WHISPER_GHOST")
function A_WhisperGhost(mobj, var1, var2)
    A_CapeChase(mobj)
	if not (mobj and mobj.valid) then return end
	local mo = mobj.target
	
	mobj.skin = mo.skin
	mobj.scale = mo.scale
	mobj.radius = mo.radius
	mobj.height = mo.height
	if mo.player
		mobj.angle = mo.player.drawangle
	else
		mobj.angle = mo.angle
	end
	
	mobj.rollangle = mo.rollangle
	mobj.mirrored = mo.mirrored
	mobj.spritexscale = mo.spritexscale
	mobj.spriteyscale = mo.spriteyscale
	mobj.spritexoffset = mo.spritexoffset
	mobj.spriteyoffset = mo.spriteyoffset
	mobj.blendmode = mo.blendmode
	mobj.flags2 = mo.flags2 & (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT)
	
	mobj.sprite = mo.sprite
	mobj.sprite2 = mo.sprite2
	mobj.frame = mo.frame
	
	if ((mobj.frame & FF_TRANSMASK) >> FF_TRANSSHIFT) < (NUMTRANSMAPS-1) - mobj.fuse / 2
		// fade out when nearing the end of fuse...
		mobj.frame = ($ & ~FF_TRANSMASK) | (((NUMTRANSMAPS-1) - mobj.fuse / 2) << FF_TRANSSHIFT)
	end
end
states[S_WHISPER_GHOST] = {SPR_NULL, 0, 2, A_WhisperGhost, 0, 0, S_NULL}

//Which sprite2s the gun uses for each of the main sprite2s
local GUNSPRITE2S = {
	//Idle
	[SPR2_STND] = SPR2_TAL0,
	[SPR2_FIRE] = SPR2_TAL0|FF_SPR2SUPER,
	[SPR2_WAIT] = SPR2_TAL1,

	//Walk
	[SPR2_WALK] = SPR2_TAL2,
	[SPR2_FLY] = SPR2_TAL3,

	//Run
	[SPR2_RUN] = SPR2_TAL4,
	[SPR2_TIRE] = SPR2_TAL5,
	
	//Legs out
	[SPR2_GLID] = SPR2_TAL6,
	[SPR2_RIDE] = SPR2_TAL7,
	[SPR2_SKID] = SPR2_TAL8,

	//Hammer
	[SPR2_MLEE] = SPR2_TAL9,
	[SPR2_MLEL] = SPR2_TAL9|FF_SPR2SUPER,

	//Say AAAAAAA
	[SPR2_PAIN] = SPR2_TALA,
	[SPR2_GASP] = SPR2_TALA|FF_SPR2SUPER,

	//Jumping
	[SPR2_SPNG] = SPR2_TAL7|FF_SPR2SUPER,
	[SPR2_FALL] = SPR2_TALB,
	[SPR2_BNCE] = SPR2_TALC,
	
	//Dying
	[SPR2_SHIT] = SPR2_XTRA|FF_SPR2SUPER,
	[SPR2_CNT1] = SPR2_XTRA|FF_SPR2SUPER,
	
	//Unfortunately no better sprite2s for these
	[SPR2_SPIN] = SPR2_CLNG,
	[SPR2_ROLL] = SPR2_CNT4, //Super-only since it's only the mask eye and no gun
	[SPR2_TRNS] = SPR2_CLMB,
}

local function FixedSquare(n) -- Lach: shortcut used below
	return FixedMul(n, n)
end

local function FV3_Rotate(rotVecX, rotVecY, rotVecZ, axisVecX, axisVecY, axisVecZ, angle) -- Lach: vector rotation function I ported from source for Chrispy's Arcade
	local ux, uy, uz = FixedMul(axisVecX, rotVecX), FixedMul(axisVecX, rotVecY), FixedMul(axisVecX, rotVecZ)
	local vx, vy, vz = FixedMul(axisVecY, rotVecX), FixedMul(axisVecY, rotVecY), FixedMul(axisVecY, rotVecZ)
	local wx, wy, wz = FixedMul(axisVecZ, rotVecX), FixedMul(axisVecZ, rotVecY), FixedMul(axisVecZ, rotVecZ)
	local sa, ca = sin(angle), cos(angle)
	local ua = ux + vy + wz
	local ax, ay, az = FixedMul(axisVecX, ua), FixedMul(axisVecY, ua), FixedMul(axisVecZ, ua)
	local xs, ys, zs = FixedSquare(axisVecX), FixedSquare(axisVecY), FixedSquare(axisVecZ)
	local bx, by, bz = FixedMul(rotVecX, ys + zs), FixedMul(rotVecY, xs + zs), FixedMul(rotVecZ, xs + ys)
	local cx, cy, cz = FixedMul(axisVecX, vy + wz), FixedMul(axisVecY, ux + wz), FixedMul(axisVecZ, ux + vy)
	local dx, dy, dz = FixedMul(bx - cx, ca), FixedMul(by - cy, ca), FixedMul(bz - cz, ca)
	local ex, ey, ez = FixedMul(vz - wy, sa), FixedMul(wx - uz, sa), FixedMul(uy - vx, sa)
	
	return ax + dx + ex, ay + dy + ey, az + dz + ez
end

local function GetNiGHTSCameraAngle(player) -- Lach: NiGHTS camera angle code block I ported from source for DeltaChars
	if player.pflags & PF_TRANSFERTOCLOSEST
		local axis1, axis2 = player.axis1, player.axis2
		if axis1 and axis2
			return R_PointToAngle2(axis1.x, axis1.y, axis2.x, axis2.y) + ANGLE_90
		end
	end
	
	local mo = player.mo
	local target = mo.target
	if mo.target
		if target.flags2 & MF2_AMBUSH
			return R_PointToAngle2(target.x, target.y, mo.x, mo.y)
		end
		return R_PointToAngle2(mo.x, mo.y, target.x, target.y)
	end
	
	return mo.angle + ANGLE_90
end

rawset(_G, "DoWhisperOverlay", function(player, gun)
	local mo = player and player.mo
	if not gun
		return true
	elseif not mo
		gun.state = gun.info.spawnstate
		A_CapeChase(gun,1,0)
		return true
	end
	A_CapeChase(gun,1,0)
	if not (gun and gun.valid) then return end
	
	//Set it up
	gun.skin = mo.skin
	gun.scale = mo.scale
	gun.radius = mo.radius
	gun.height = mo.height
	gun.angle = player.drawangle
	
	gun.rollangle = mo.rollangle
	gun.mirrored = mo.mirrored
	gun.spritexscale = mo.spritexscale
	gun.spriteyscale = mo.spriteyscale
	gun.spritexoffset = mo.spritexoffset
	gun.spriteyoffset = mo.spriteyoffset
	gun.blendmode = mo.blendmode
	gun.flags2 = mo.flags2 & (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT)
	
	//Color stuff
	local superduper = player.powers[pw_super] or player.powers[pw_carry] == CR_NIGHTSMODE
	if player.whisperguncolor == nil
		player.whisperguncolor = SKINCOLOR_SUPERLASER1
	elseif player.whispernewgun
		//If the wisp we have out matches, let's put it back in the gun
		if player.whisperwisp and player.whisperwisp.valid
		and player.whisperwisp.health
		and player.whisperwisp.guncolor == player.whisperguncolor
			P_KillMobj(player.whisperwisp)
		end
			
		//New color!
		if gun.threshold != player.whisperguncolor
		or (gun.reactiontime >= GUNREACTIONTIME and not superduper)
			if superduper and not (mo.color == player.skincolor
			and (mo.sprite2 &~ FF_SPR2SUPER) == SPR2_TRNS)
				mo.color = gun.color
			end
			
			//Spawn gun color transition
			local target = superduper and mo or gun or mo
			player.whisperghost = P_SpawnGhostMobj(target)
			player.whisperghost.fuse = $*2
			player.whisperghost.renderflags = target.renderflags
			if player.whisperghost.tracer
				player.whisperghost.tracer.fuse = $*2
				if player.whisperghost.tracer.target
					player.whisperghost.tracer.renderflags = player.whisperghost.tracer.target.renderflags
				end
			end
		end
		gun.reactiontime = 0
		gun.cusval = 0
	end
	gun.threshold = player.whisperguncolor
	
	//Wear out after a while
	if gun.reactiontime >= GUNREACTIONTIME and not superduper
		if gun.reactiontime == GUNREACTIONTIME
			//Spawn gun color transition
			local target = superduper and mo or gun or mo
			player.whisperghost = P_SpawnGhostMobj(target)
			player.whisperghost.fuse = $*2
			player.whisperghost.renderflags = target.renderflags
			if player.whisperghost.tracer
				player.whisperghost.tracer.fuse = $*2
				if player.whisperghost.tracer.target
					player.whisperghost.tracer.renderflags = player.whisperghost.tracer.target.renderflags
				end
			end
			
			//Spawn new wisp if we don't have one out
			if player.whisperwisptoggle and not player.powers[pw_super]
			and not (player.whisperwisp and player.whisperwisp.valid)
				local wisp = P_SpawnMobjFromMobj(mo,
				P_ReturnThrustX(mo, player.drawangle, player.height*2/3),
				P_ReturnThrustY(mo, player.drawangle, player.height*2/3),
				player.height*2/3, MT_WHISPER_WISP)
				player.whisperwisp = wisp
				
				wisp.angle = player.drawangle
				if player.whispersaw and player.whispersaw.valid
					wisp.momx = player.whispersaw.momx/2
					wisp.momy = player.whispersaw.momy/2
					wisp.momz = player.whispersaw.momz/2
				else
					wisp.momx = mo.momx
					wisp.momy = mo.momy
					wisp.momz = mo.momz
				end
				
				wisp.target = mo
				wisp.guncolor = player.whisperguncolor
				wisp.threshold = (player.whisperguncolor - SKINCOLOR_SUPERLASER1)/5
			end
		end
		gun.reactiontime = $ + 1
		gun.color = SKINCOLOR_LASER
		gun.renderflags = mo.renderflags
		
	//Set it!
	else
		if player.powers[pw_super] and (mo.color < skins[player.skin].supercolor
		or mo.color > skins[player.skin].supercolor + 4)
			gun.color = mo.color
		else
			gun.color = player.whisperguncolor + abs( ( (gun.cusval >> 1) % 9) - 4)
		end
		gun.renderflags = mo.renderflags | RF_FULLBRIGHT | RF_NOCOLORMAPS
		gun.cusval = $ + 1
		
		//Copy colors to player while super
		if superduper and not (mo.color == player.skincolor
		and (mo.sprite2 &~ FF_SPR2SUPER) == SPR2_TRNS)
			mo.color = gun.color
		end
		
		//Wear out only when not holding any buttons
		if player.cmd.buttons & BT_JUMP or player.cmd.buttons & BT_SPIN
			gun.reactiontime = 0
		else
			gun.reactiontime = $ + 1
		end
	end
	
	//Do the sprite2 stuff
	//Super sprite2s in GUNSPRITE2S force the last frame, and aren't actually super
	local gunsprite2 = GUNSPRITE2S[mo.sprite2 &~ FF_SPR2SUPER]
	if gunsprite2
		local superduper = gunsprite2 & FF_SPR2SUPER
		gunsprite2 = ($ &~ FF_SPR2SUPER) | (mo.sprite2 & FF_SPR2SUPER)
		local numframes = skins[mo.skin].sprites[gunsprite2].numframes
		if numframes
			numframes = $ - 1
			
			gun.sprite = mo.sprite
			gun.sprite2 = gunsprite2
			if superduper
				gun.frame = (mo.frame &~ FF_FRAMEMASK) + numframes
			else
				gun.frame = (mo.frame &~ FF_FRAMEMASK) + min(mo.frame & FF_FRAMEMASK, numframes)
			end
		else
			gun.state = gun.info.spawnstate
		end
	else
		gun.state = gun.info.spawnstate
	end
	
	//Dumb ghost
	if player.whisperghost and player.whisperghost.valid
		player.whisperghost.state = S_WHISPER_GHOST
		if player.whisperghost and player.whisperghost.valid
		and player.whisperghost.tracer
			player.whisperghost.tracer.state = S_WHISPER_GHOST
		end
	end
	
	//Mega super dumb super form wisps hack
	//Why put extra behavior in the wisp object when I can just constantly
	//spawn a bunch of thok look-a-likes every single frame?
	if not player.whisperwisptoggle then superduper = false end
	if superduper or gun.extravalue1
		if superduper
			if not gun.extravalue1
				S_StartSound(mo, sfx_wstrns)
			end
			gun.extravalue1 = $ + 1
		else
			gun.extravalue1 = max(min($ - 5, TICRATE), 0)
		end
		gun.extravalue2 = $ + 1
		
		local inNights = player.powers[pw_carry] == CR_NIGHTSMODE -- Lach: shortcut variables
		local rollAngle = 0
		local angleOffset = 0
		local rotAxis, rotAxisCos, rotAxisSin
		if inNights
			rollAngle = mo.rollangle
			rotAxis = GetNiGHTSCameraAngle(player) + ANGLE_180
			angleOffset = rotAxis - mo.angle
			rotAxisCos, rotAxisSin = cos(rotAxis), sin(rotAxis)
		end
		
		//Spawn them
		for i = 0, 4
			local backdist = -min(mo.info.radius*2, gun.extravalue1*mo.scale)
			/*if player.powers[pw_carry] == CR_NIGHTSMODE
				backdist = FixedMul($, abs(cos(mo.rollangle)))
			end*/ -- Lach: handled by the rotation now
			
			local x = P_ReturnThrustX(mo, player.drawangle, backdist)
			local y = P_ReturnThrustY(mo, player.drawangle, backdist)
			local z = 0--player.height/2 -- Lach: we don't want the height to be included in the rotation, we want to offset the pivot point by the height, so we'll add it back later
			
			local angle = ANG10*gun.extravalue2 + (ANGLE_90 - ANG2*9)*i
				+ angleOffset -- Lach: add an angle offset so the Wisps don't jump from side to side when Whisper flips
			local sidedist = min(player.height*2/3, gun.extravalue1*mo.scale)
			local hdist = FixedMul(sidedist, cos(angle))
			local zdist = FixedMul(sidedist, sin(angle))
			
			x = $ + P_ReturnThrustX(mo, player.drawangle + ANGLE_90, hdist)
			y = $ + P_ReturnThrustY(mo, player.drawangle + ANGLE_90, hdist)
			z = $ + zdist
			
			if inNights -- Lach: rotation time
				x, y, z = FV3_Rotate(x, y, z, rotAxisCos, rotAxisSin, 0, rollAngle)
			end
			z = $ + (player.height >> 1) -- Lach: adding the height back lol
			
			local thok = P_SpawnMobjFromMobj(mo, x,y,z, MT_THOK)
			thok.state = S_INVISIBLE
			thok.tics = 1
			
			thok.sprite = SPR_WSWS
			thok.frame = G + i*3
			thok.angle = player.drawangle
			
			thok.color = SKINCOLOR_SUPERLASER1 + abs( ( (gun.extravalue2 >> 1) % 9) - 4) + i*5
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.shadowscale = FRACUNIT*3/16
			
			thok.rollangle = rollAngle -- Lach: match rollangle with NiGHTS Whisper
			
			P_TeleportMove(thok, thok.x, thok.y, thok.z) //Uncapped hack
			
			if (player == displayplayer and camera and not camera.chase)
			or (player == secondarydisplayplayer and camera2 and not camera2.chase)
				thok.flags2 = $ | MF2_DONTDRAW
			end
			
			if gun.extravalue1 % 5 == i
				local ghost = P_SpawnGhostMobj(thok)
				ghost.renderflags = thok.renderflags
				ghost.flags2 = $ | (thok.flags2 & MF2_DONTDRAW)
			end
		end
	elseif gun.extravalue1 or gun.extravalue2
		gun.extravalue1 = 0
		gun.extravalue2 = 0
	end
end)