//Spin ability - Hover Float

sfxinfo[freeslot("sfx_wshov1")].caption = "/"
sfxinfo[freeslot("sfx_wshov2")].caption = "/"
sfxinfo[freeslot("sfx_wshov3")].caption = "Bump"

sfxinfo[freeslot("sfx_wsflt1")].caption = "Hovering"
sfxinfo[freeslot("sfx_wsflt2")].caption = "/"
sfxinfo[freeslot("sfx_wsflt3")].caption = "/"

freeslot("S_WHISPER_HOVER1", "S_WHISPER_HOVER2")
states[S_WHISPER_HOVER1] = {SPR_WSHV, E|FF_ANIMATE, 2*3, nil, 1, 3, S_WHISPER_HOVER2}
states[S_WHISPER_HOVER2] = {SPR_WSHV, G|FF_ANIMATE, 1, nil, 5, 3, S_NULL}

//Jump ability - Hover
addHook("AbilitySpecial", function(player)
	local mo = player.mo
	if WhisperCantMove(player) return end
	if player.glidetime > 2 or player.secondjump
	or (player.whispersaw and player.whispersaw.valid)
	or (mo.state == S_PLAY_MELEE and not (mo.frame & FF_FRAMEMASK) and mo.tics > 2)
	then return true end
	
	//Start which flight?
	if player.pflags & PF_THOKKED and not player.powers[pw_super]
		player.whisperfloat = 2
	else
		S_StartSound(mo, sfx_wshov1)
		player.whisperfloat = 1
	end
	S_StartSound(mo, sfx_wshov2)
	
	//Hammer cancel
	if (mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH)
	and player.glidetime & 1
		mo.momx = player.whispermomx
		mo.momy = player.whispermomy
		mo.momz = player.whispermomz/4
		player.glidetime = $ + 1
		
		//Hard speed cap, don't abuse those slopes too hard!
		local speedcap = FixedMul(player.actionspd, mo.scale)
		if not player.powers[pw_super]
		and FixedHypot(mo.momx, mo.momy) > speedcap
			P_InstaThrust(mo, R_PointToAngle2(0,0, mo.momx, mo.momy), speedcap)
		end
		
		if not S_SoundPlaying(mo, sfx_wscub1)
			S_StartSoundAtVolume(mo, sfx_wscub1, 128)
		end
	end
	
	mo.state = S_PLAY_GLIDE
	player.pflags = $ | PF_THOKKED | PF_JUMPED | PF_NOJUMPDAMAGE | PF_CANCARRY &~ PF_SPINNING
	player.fly1 = 0
	
	player.whisperguncolor = SKINCOLOR_SUPERHOVER1
	player.whispernewgun = true
	
	//Effect
	WhisperCircle(mo, MT_THOK, 8, 4*mo.scale, FRACUNIT*96, mo.scale/8, -1, SKINCOLOR_EMERALD)
	
	player.whisperhover = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
	player.whisperhover.target = mo
	
	player.whisperhover.state = S_WHISPER_HOVER1
	player.whisperhover.spriteyoffset = FRACUNIT*80
	
	player.whisperhover.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	player.whisperhover.blendmode = AST_ADD
	
	A_CapeChase(player.whisperhover)
	
	return true
end)

//Hover bounce
addHook("MobjMoveBlocked", function(mo)
	if mo and mo.skin == "whisper" and mo.state == S_PLAY_GLIDE
		P_BounceMove(mo)
		if FixedHypot(mo.momx, mo.momy) > mo.scale
			S_StartSoundAtVolume(mo, sfx_wshov3, 128)
			WhisperCircle(mo, MT_THOK, 8, 4*mo.scale, 0,
			mo.scale/8, false, SKINCOLOR_EMERALD, true, R_PointToAngle2(mo.momx, mo.momy, 0,0))
		end
		return true
	end
end, MT_PLAYER)