//Code for Whisper's FPS sprite

if srb2p return end

//whisperfpshud command
local whisperfpshud = CV_RegisterVar({
	name = "whisperfpshud",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

local GUNSPEED = 2
local GUNFRAMES = 4

local WhisperHUD = {[0] = {}, [1] = {}}

WhisperHUD[0].shoot = GUNSPEED*GUNFRAMES
WhisperHUD[1].shoot = GUNSPEED*GUNFRAMES

WhisperHUD[0].bob = FRACUNIT
WhisperHUD[1].bob = FRACUNIT

WhisperHUD[0].cock = 0
WhisperHUD[1].cock = 0

WhisperHUD[0].ringslinger = false
WhisperHUD[1].ringslinger = false

hud.add(function(v, player, cam)
	local id = player == secondarydisplayplayer and 1 or 0
	local wshud = WhisperHUD[id]
	
	local mo = player.mo
	local whisper = mo and mo.skin == "whisper"
	
	//Disable ringslinger hud as Whisper
	if whisper and not splitscreen
		if hud.enabled("weaponrings")
			hud.disable("weaponrings")
			wshud.ringslinger = true
		end
	elseif wshud.ringslinger
		hud.enable("weaponrings")
		wshud.ringslinger = false
	end
	
	local gun = not cam.chase and whisper and mo.health
	and not (twodlevel or mo.flags2 & MF2_TWOD) and not player.climbing
	and not player.playerstate and player.followmobj
	
	if not gun or not whisperfpshud.value
		wshud.shoot = GUNSPEED*GUNFRAMES
		wshud.bob = 0
		wshud.cock = 0
		
		if player.secondjump == 1 or player.whisperfloat
			wshud.float = 10
		else
			wshud.float = 0
		end
		return
	end
	
	local flags = V_SNAPTOBOTTOM|V_PERPLAYER
	local x = 0
	local y = FixedDiv(player.viewheight, mo.scale) //Account for scale because SRB2 doesn't!
	y = $ - 46*FRACUNIT //Offset by default viewheight value
	local gunframe = 1
	
	//Apply positioning offset
	local bob = FixedDiv(player.bob/4, mo.scale) //Account for scale because SRB2 doesn't!
	if P_IsObjectOnGround(mo)
		wshud.bob = min($*2 or 1, FRACUNIT)
	else
		wshud.bob = $/2
	end
	
	bob = FixedMul($, wshud.bob)
	x = $ + FixedMul(bob, cos(INT32_MAX/20*leveltime))
	y = $ + FixedMul(bob, sin(INT32_MAX/10*leveltime))
	
	//Cock offset
	if player.whispercharge
		wshud.cock = min($ + FRACUNIT, FRACUNIT*4)
	elseif wshud.cock
		wshud.cock = $/2
	end
	x = $ + wshud.cock
	y = $ + wshud.cock
	
	//Find out what gun sprites we should be using
	
	//Melee swing
	if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEE
		local frame = mo.frame & FF_FRAMEMASK
		if frame == 0
			gunframe = 7
		elseif frame == 1
			gunframe = 6
		else
			gunframe = 5
		end
		
		wshud.shoot = 0
		wshud.float = 0
		
	//Melee land
	elseif mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
		gunframe = 5
		
		wshud.shoot = 0
		wshud.float = 0
		
	//Floating
	elseif player.secondjump == 1 or player.whisperfloat
	or wshud.float
		gunframe = min(8 + wshud.float/2, 10)
		if player.secondjump == 1 or player.whisperfloat
			wshud.float = $ + 1
		else
			wshud.float = min($ - 1, 4)
		end
		
	//Shooting
	elseif player.weapondelay > 2
	or (player.whispersaw and player.whispersaw.valid)
		wshud.shoot = $ + 1
		wshud.float = 0
		
		if wshud.shoot < GUNSPEED*GUNFRAMES
			gunframe = $ + wshud.shoot/GUNSPEED
		end
		
	//Idle
	else
		wshud.shoot = 0
		wshud.float = 0
	end
	
	//Calculate shadow darkness
	local sector = mo.subsector and mo.subsector.sector
	local lightlevel = sector and sector.lightlevel
	local shadow = true
	
	//Find fofs that cast shadows and light blocks
	//This isn't 100% accurate since it doesn't seem to notice underwater casted
	//shadows, but it's close enough.
	local shadowfof = -1
	local shadowtop = nil
	local shadowbottom = nil
	if sector
		for fof in sector.ffloors()
			if not (fof and fof.valid and not (fof.flags & FF_NOSHADE)) then continue end
			
			//Find top and bottom
			local top = fof.topheight
			if fof.t_slope then shadowtop = P_GetZAt(fof.t_slope, mo.x, mo.y) end
			
			local bottom = fof.bottomheight
			if fof.b_slope then bottom = P_GetZAt(fof.b_slope, mo.x, mo.y) end
			
			//Light block
			if fof.flags & FF_DOUBLESHADOW
				if P_InsideANonSolidFFloor(mo, fof)
					shadowfof = fof.toplightlevel
					shadowtop = top
					shadowbottom = bottom
				end
			
			//Casted shadow
			elseif (shadowbottom == nil or bottom < shadowbottom
			or (shadowtop != nil and top < shadowtop))
			and top > mo.z + mo.height/2
				shadowfof = fof.toplightlevel
				shadowtop = top
				shadowbottom = bottom
			end
		end
	end
	
	//Apply fof shadow lightlevel
	if shadowfof >= 0
		lightlevel = shadowfof
	end
	//v.drawNum(x/FRACUNIT, y/FRACUNIT, lightlevel, flags)
	
	//Convert to trans flags
	if lightlevel == nil or lightlevel == false
		lightlevel = 0
		shadow = false
	else
		lightlevel = $ / (255/NUMTRANSMAPS)
		if lightlevel <= 0
			lightlevel = 0
		elseif lightlevel < 10
			lightlevel = $ << FF_TRANSSHIFT
		else
			shadow = false
			lightlevel = 0
		end
	end
	
	//Get our cropping values
	//We do cropping so that, in splitscreen, the hud doesn't leak between players
	local patch = v.cachePatch("W2GUN"..gunframe)
	local width = patch.width*FRACUNIT
	local height = patch.height
	height = ($ + patch.topoffset - ($ - v.height()/v.dupy()))*FRACUNIT - y
	
	//Draw non-colored gun part and its shadow
	v.drawCropped(x, y, FRACUNIT, FRACUNIT, patch, flags, nil, 0,0, width, height)
	if shadow
		v.drawCropped(x, y, FRACUNIT, FRACUNIT, v.cachePatch("W4GUN"..gunframe),
		flags | lightlevel, nil, 0,0, width, height)
	end
	
	//Draw colored gun part and its shadow
	v.drawCropped(x, y, FRACUNIT, FRACUNIT, v.cachePatch("WSGUN"..gunframe),
	flags, v.getColormap(0, gun.color), 0,0, width, height)
	if shadow and not (gun.renderflags & RF_FULLBRIGHT)
	and not (gun.frame & FF_FULLBRIGHT)
		v.drawCropped(x, y, FRACUNIT, FRACUNIT, v.cachePatch("W3GUN"..gunframe),
		flags | lightlevel, nil, 0,0, width, height)
	end
	
	//Draw the gun transitioning to another color and its shadow
	if player.whisperghost and player.whisperghost.valid
		local trans = player.whisperghost.frame & FF_TRANSMASK
		v.drawCropped(x, y, FRACUNIT, FRACUNIT, v.cachePatch("WSGUN"..gunframe),
		flags | trans, v.getColormap(0, player.whisperghost.color), 0,0, width, height)
		
		shadow = true
		lightlevel = ($ >> FF_TRANSSHIFT) + (trans >> FF_TRANSSHIFT)
		if lightlevel <= 0
			lightlevel = 0
		elseif lightlevel < 10
			lightlevel = $ << FF_TRANSSHIFT
		else
			shadow = false
			lightlevel = 0
		end
		
		if shadow and not (player.whisperghost.renderflags & RF_FULLBRIGHT)
		and not (player.whisperghost.frame & FF_FULLBRIGHT)
			v.drawCropped(x, y, FRACUNIT, FRACUNIT, v.cachePatch("W3GUN"..gunframe),
			flags | lightlevel, nil, 0,0, width, height)
		end
	end
end)