//Spin ability - Laser Gun

sfxinfo[freeslot("sfx_wslsr1")].caption = "Laser shoot"
sfxinfo[sfx_wslsr1].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wslsr2")].caption = "Laser bounce"
sfxinfo[sfx_wslsr2].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wslsr3")].caption = "Laser hit"
sfxinfo[sfx_wslsr3].flags = $|SF_X2AWAYSOUND

local LASERTRAIL = 16
freeslot("MT_WHISPER_LASER", "S_WHISPER_SHOCK", "SPR_WSPT",
"S_WHISPER_CIRCLE", "S_WHISPER_CIRCLE2", "S_WHISPER_CIRCLE3", "SPR_WSHV")
states[S_WHISPER_SHOCK] = {SPR_WSPT, B|FF_ANIMATE, K, nil, K - 1, 1, S_BIGMINE_BLAST5}
states[S_WHISPER_CIRCLE] = {SPR_NULL, FF_PAPERSPRITE, 1, nil, 0, 0, S_WHISPER_CIRCLE2}
states[S_WHISPER_CIRCLE2] = {SPR_WSHV, FF_PAPERSPRITE|FF_ANIMATE, D*2, nil, D, 2, S_WHISPER_CIRCLE3}
states[S_WHISPER_CIRCLE3] = {SPR_WSHV, FF_PAPERSPRITE|D, 8, A_SetFuse, 8, 0, S_NULL}
mobjinfo[MT_WHISPER_LASER] = {
	spawnstate = S_INVISIBLE,
	deathstate = S_WHISPER_SHOCK,
	xdeathstate = S_WHISPER_SHOCK,
	seesound = sfx_wslsr1,
	painsound = sfx_wslsr2,
	deathsound = sfx_wslsr3,
	spawnhealth = 1000,
	speed = 120*FRACUNIT/LASERTRAIL,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	damage = 1,
	flags = MF_MISSILE|MF_BOUNCE|MF_NOGRAVITY|MF_GRENADEBOUNCE,
}

//Make bounce noise
addHook("MobjMoveBlocked", function(mobj, thing, line)
	if not (mobj.flags & MF_MISSILE) then return end
	if thing == mobj.target then return end
	
	//Delete on sky
	if line and (line.special == 41
	or (line.backsector and line.backsector.ceilingpic == "F_SKY1"
	and line.frontsector and line.frontsector.ceilingpic == "F_SKY1"
	and (mobj.z >= line.frontsector.ceilingheight
	or mobj.z >= line.backsector.ceilingheight)))
		P_ExplodeMissile(mobj)
		S_StopSoundByID(mobj, mobj.info.deathsound)
		mobj.state = S_BIGMINE_BLAST5
		return
	end
	
	A_Pain(mobj)
	
	local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
	thok.state = S_WHISPER_SHOCK
	
	thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	thok.blendmode = AST_ADD
	thok.color = mobj.color
	
	if mobj.fuse > 5
		mobj.fuse = $ - 5
	end
end, MT_WHISPER_LASER)

//Ignore friendly players
addHook("MobjMoveCollide", function(mobj, mo)
	if mo.player and gametyperules & GTR_FRIENDLY
	and not CV_FindVar("friendlyfire").value
		return false
	end
end, MT_WHISPER_LASER)

//Explode on fuse
addHook("MobjFuse", function(mobj)
	if mobj.flags & MF_MISSILE then P_KillMobj(mobj) end
	return true
end, MT_WHISPER_LASER)

//Laser Death
addHook("MobjDeath", function(mobj)
	S_StopSound(mobj)
	P_ExplodeMissile(mobj)
end, MT_WHISPER_LASER)

//Laser Removal
addHook("MobjRemoved", function(mobj)
	if not mobj.laserlist return end
	for i, thok in pairs(mobj.laserlist) do
		if not thok.valid then continue end
		P_RemoveMobj(thok)
	end
end, MT_WHISPER_LASER)

//Laser Thinker
addHook("MobjThinker", function(mobj)
	//MobjSpawn hook
	if not mobj.laserlist
		mobj.laserlist = {}
		mobj.fuse = TICRATE*4
		
		mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		mobj.blendmode = AST_ADD
		mobj.color = SKINCOLOR_TEAL
		if mobj.target and mobj.target.player
		and not (gametyperules & (GTR_FRIENDLY | GTR_RACE))
			mobj.color = mobj.target.color
		end
		
		mobj.blockable = 1
		mobj.block_hthrust = mobjinfo[mobj.type].speed/FRACUNIT
		mobj.block_vthrust = 1
		mobj.block_stun = 0
		
		/*local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
		thok.state = S_WHISPER_SHOCK
		
		thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		thok.blendmode = AST_ADD
		thok.color = mobj.color*/
	
		//WhisperCircle(mobj, MT_THOK, 8, 4*mobj.scale, 0,
		//mobj.scale/2, false, mobj.color, true, mobj.angle)
	end
	mobj.threshold = $ + 1
	
	//Decrease Laser Trail scale
	for i, thok in pairs(mobj.laserlist) do
		if not thok.valid then table.remove(mobj.laserlist, i) return end
		P_SetScale(thok, thok.scale - thok.scalespeed)
		thok.threshold = $ - 1
		if not thok.threshold
			P_RemoveMobj(thok)
			table.remove(mobj.laserlist, i)
		end
	end
		
	if mobj.flags & MF_MISSILE
	
		//Hit floor
		if (mobj.prevmomz != nil and abs(mobj.prevmomz - mobj.momz) > mobj.scale)
		or mobj.eflags & MFE_JUSTHITFLOOR
			if not mobj.floorsound
				A_Pain(mobj)
		
				local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
				thok.state = S_WHISPER_SHOCK
				
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				thok.blendmode = AST_ADD
				thok.color = mobj.color
				
				if mobj.fuse > 5
					mobj.fuse = $ - 5
				end
				
				mobj.floorsound = true
			end
		elseif mobj.floorsound
			mobj.floorsound = false
		end
		mobj.prevmomz = mobj.momz
		
		//Create Laser Trail
		local circles = 1
		for i = 0, (LASERTRAIL - 1)
			//Hack to make it explode on ceiling sky in the below code
			if mobj.momz*P_MobjFlip(mobj) > 0
			and mobj.subsector and mobj.subsector.sector
			and ((not (mobj.eflags & MFE_VERTICALFLIP)
			and mobj.subsector.sector.ceilingpic == "F_SKY1"
			and mobj.subsector.sector.ceilingheight == mobj.ceilingz
			and mobj.ceilingz <= mobj.z + mobj.height + mobj.momz)
			or (mobj.eflags & MFE_VERTICALFLIP
			and mobj.subsector.sector.floorpic == "F_SKY1"
			and mobj.subsector.sector.floorheight == mobj.floorz
			and mobj.floorz >= mobj.z + mobj.momz))
				mobj.flags = $ &~ MF_GRENADEBOUNCE
			end
			
			//Super fast!
			local momz = mobj.momz
			P_RailThinker(mobj)
			if not (mobj and mobj.valid and mobj.health
			and mobj.flags & MF_MISSILE) then return end
			
			mobj.flags = $ | MF_GRENADEBOUNCE //Hack over
			
			//Extended hitbox (for the fans)
			P_RadiusAttack(mobj, mobj.target or mobj, mobj.info.radius*2, mobj.info.mass, true)
			if not (mobj and mobj.valid and mobj.health
			and mobj.flags & MF_MISSILE) then return end
		
			local ghost = P_SpawnMobj(mobj.x, mobj.y, mobj.z + mobj.height/2, MT_CANDLE)
			
			ghost.scale = mobj.scale
			ghost.scalespeed = FixedMul($, ghost.scale*2/3)
			ghost.destscale = 1
			ghost.spriteyscale = FRACUNIT/2
			
			ghost.threshold = 14
			ghost.sprite = SPR_WSPT
			
			ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			ghost.blendmode = AST_ADD
			ghost.color = mobj.color
			
			local newi = LASERTRAIL - 1 - i
			if newi
				P_SetScale(ghost, ghost.scale - ghost.scalespeed*newi/LASERTRAIL)
			end
			
			//First fire stuff
			if mobj.threshold == 1
				if not i
					P_SetScale(ghost, ghost.scale*5/4)
				end
				
				if not (i % (LASERTRAIL*2/5))
					local thok = P_SpawnMobj(mobj.x, mobj.y, mobj.z + mobj.height*2/3, MT_THOK)
					thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
					thok.blendmode = AST_ADD
					thok.color = mobj.color
					
					thok.state = S_WHISPER_CIRCLE
					thok.tics = $ - 1 + circles*2
					thok.angle = R_PointToAngle2(0,0, mobj.momx, mobj.momy) + ANGLE_90
					
					thok.scale = mobj.scale/(circles*2)
					thok.scalespeed = FixedMul($, thok.scale)
					thok.destscale = INT32_MAX
					circles = $*2
				end
			end
			
			table.insert(mobj.laserlist, ghost)
		end
		
		//Face our momentum angle
		if mobj.momx or mobj.momy
			mobj.angle = R_PointToAngle2(0,0, mobj.momx, mobj.momy)
		end
		
		//Consistent speed
		if FixedHypot(FixedHypot(mobj.momx, mobj.momy), mobj.momz) < FixedMul(mobj.info.speed, mobj.scale)
			local vangle = R_PointToAngle2(0,0, FixedHypot(mobj.momx, mobj.momy), mobj.momz)
			P_InstaThrust(mobj, mobj.angle,
			FixedMul(FixedMul(mobj.info.speed, cos(vangle)), mobj.scale))
			mobj.momz = FixedMul(FixedMul(mobj.info.speed, sin(vangle)), mobj.scale)
		end
	elseif mobj.flags != mobjinfo[MT_THOK].flags
		mobj.flags = mobjinfo[MT_THOK].flags
		A_ForceStop(mobj)
	end
end, MT_WHISPER_LASER)