//Whisper code by SMS Alfredo for Lightdasher
--
//Code snippets borrowed from sloperollangle by Golden
//https://mb.srb2.org/threads/sloperollangle-character-rotation-on-slopes.27164/
--
//As well as Fang Popgun Modifications by CobaltBW
//https://mb.srb2.org/addons/fang-popgun-modifications.1347/

sfxinfo[freeslot("sfx_wschg1")].caption = "Gun cock"
sfxinfo[freeslot("sfx_wschg2")].caption = "Charged"

sfxinfo[freeslot("sfx_wsmask")].caption = "/"

local WHISPERSTARTLAG = 7
local WHISPERCHARGE = TICRATE*7/10
local WHISPERENDLAG = TICRATE/2

local GUNSPRITES = {
	[SPR2_STND] = SPR2_FIRE,
	[SPR2_WAIT] = SPR2_FIRE,
	
	[SPR2_EDGE] = SPR2_FIRE,
	[SPR2_SKID] = SPR2_SPIN,
	
	[SPR2_SPNG] = SPR2_BNCE,
	[SPR2_FALL] = SPR2_BNCE,
	
	[SPR2_WALK] = SPR2_FLY,
	[SPR2_RUN_] = SPR2_TIRE,
}

//whisperbattleaim command
local whisperbattleaim = CV_RegisterVar({
	name = "whisperbattleaim",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

//I/O saving
local function SaveWhisperConfig(player, save)
	if io and player == consoleplayer and save != "0"
		local file = io.openlocal("client/Whisper.dat", "w+")
		if file
			file:write(player.whisperswap.."\n"..player.whisperwisptoggle.."\n"..player.whispercamera.."\n"..player.whisperaim)
			file:close()
		end
	end
end

//whisperswap command
local function whisperswap(player, arg, save)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "disabled" or arg == "off"
			player.whisperswap = 0
			SaveWhisperConfig(player, save)
		elseif arg == "1" or arg == "enabled" or arg == "on"
			player.whisperswap = 1
			SaveWhisperConfig(player, save)
		else
			CONS_Printf(player, "whisperswap [on/off] - Swaps the inputs for Whisper's Spike Saw and Cube Hammer around.")
		end
	else
		CONS_Printf(player, "whisperswap [on/off] - Swaps the inputs for Whisper's Spike Saw and Cube Hammer around.")
	end
	
	if save != "0"
		if player.whisperswap
			CONS_Printf(player, "Turned on, Whisper's Saw requires holding jump.")
		else
			CONS_Printf(player, "Turned off, Whisper's Hammer requires holding jump.")
		end
	end
end
COM_AddCommand("whisperswap", whisperswap)
COM_AddCommand("whisperswap2", whisperswap, COM_SPLITSCREEN)

//whisperwisp command
local function whisperwisp(player, arg, save)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "disabled" or arg == "off"
			player.whisperwisptoggle = 0
			SaveWhisperConfig(player, save)
		elseif arg == "1" or arg == "enabled" or arg == "on"
			player.whisperwisptoggle = 1
			SaveWhisperConfig(player, save)
		else
			CONS_Printf(player, "whisperwisp [on/off] - When off, prevents Whisper's wisps from spawning.")
		end
	else
		CONS_Printf(player, "whisperwisp [on/off] - When off, prevents Whisper's wisps from spawning.")
	end
	
	if save != "0"
		if player.whisperwisptoggle
			CONS_Printf(player, "Whisper's wisps are allowed to spawn.")
		else
			CONS_Printf(player, "Wisper's wisps are not allow to spawn.")
		end
	end
end
COM_AddCommand("whisperwisp", whisperwisp)
COM_AddCommand("whisperwisp2", whisperwisp, COM_SPLITSCREEN)

//whispercamera command
local function whispercamera(player, arg, save)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "disabled" or arg == "off"
			player.whispercamera = 0
			SaveWhisperConfig(player, save)
		elseif arg == "1" or arg == "enabled" or arg == "on"
			player.whispercamera = 1
			SaveWhisperConfig(player, save)
		else
			CONS_Printf(player, "whispercamera [on/off] - When on, makes all of Whisper's abilities face the camera.")
		end
	else
		CONS_Printf(player, "whispercamera [on/off] - When on, makes all of Whisper's abilities face the camera.")
	end
	
	if save != "0"
		if player.whispercamera
			CONS_Printf(player, "Turned on, Whisper's abilities face the camera.")
		else
			CONS_Printf(player, "Turned off, Whisper's abilities follow your gameplay style, except for Cube.")
		end
	end
end
COM_AddCommand("whispercamera", whispercamera)
COM_AddCommand("whispercamera2", whispercamera, COM_SPLITSCREEN)

//whisperaim command
local function whisperaim(player, arg, save)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "disabled" or arg == "off"
			player.whisperaim = 0
			SaveWhisperConfig(player, save)
		elseif arg == "1" or arg == "enabled" or arg == "on"
			player.whisperaim = 1
			SaveWhisperConfig(player, save)
		else
			CONS_Printf(player, "whisperaim [on/off] - When on, allows aiming Laser and Rocket vertically using the camera. Note that whisperbattleaim overrides this command.")
		end
	else
		CONS_Printf(player, "whisperaim [on/off] - When on, allows aiming Laser and Rocket vertically using the camera. Note that whisperbattleaim overrides this command.")
	end
	
	if save != "0"
		if player.whisperaim
			CONS_Printf(player, "Turned on, you can aim Laser and Rocket vertically.")
		else
			CONS_Printf(player, "Turned off, you cannot aim Laser and Rocket vertically.")
		end
	end
end
COM_AddCommand("whisperaim", whisperaim)
COM_AddCommand("whisperaim2", whisperaim, COM_SPLITSCREEN)

//Spawns objects in a circle
rawset(_G, "WhisperCircle", function(mo, mobjtype, amount, ns, zoffset, scale, keepmom, color, vertical, vertangle, reversed)
	if not amount or not mo then return end
	if vertangle == nil
		vertangle = mo.player and mo.player.drawangle or mo.angle
	end
	
	local i = 0	while i < amount
		local fa = i*(ANGLE_180/max(amount/2, 1)) + (vertangle or 0)
		local mobj = P_SpawnMobjFromMobj(mo,0,0,zoffset,mobjtype)
		if mobj and mobj.valid
			local height = mobj.height
			mobj.scale = scale
			
			if mobj.flags & MF_MISSILE
				mobj.target = mo
			end
			
			if mobjtype == MT_MINECARTSPARK
			or mobjtype == MT_GHOST or mobjtype == MT_THOK
				mobj.fuse = TICRATE/4
				
				if mobjtype != MT_MINECARTSPARK
					mobj.flags = mobjinfo[MT_THOK].flags
					mobj.flags2 = $ | MF2_BOSSNOTRAP
					
					if mobjtype == MT_THOK
						mobj.sprite = SPR_WSPT
						mobj.tics = -1
						
						mobj.flags = $ &~ MF_NOGRAVITY
					else
						mobj.state = S_WHISPER_CUBE
						mobj.fuse = $*4
						
						mobj.spritexscale = P_RandomFixed() + FRACUNIT/2
						mobj.spriteyscale = P_RandomFixed() + FRACUNIT/2
					end
					
					mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
					mobj.blendmode = AST_ADD
				end
			elseif mobjtype == MT_FLINGRING
				mobj.fuse = TICRATE*8
			end
			
			if mo.eflags&MFE_VERTICALFLIP
				mobj.z = $ - (mobj.height-height)
				if not (mobj and mobj.valid) then i = $ + 1 continue end
			end
			
			if color
				mobj.color = color
				if mobjtype != MT_GHOST and mobjtype != MT_THOK
					mobj.colorized = true
				end
			end
			
			if vertical
				mobj.momz = FixedMul(sin(fa),ns)
				P_InstaThrust(mobj, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				mobj.momx = FixedMul(cos(fa),ns)
				mobj.momy = FixedMul(sin(fa),ns)
				mobj.angle = fa
			end
			
			if mobjtype == MT_GHOST or mobjtype == MT_THOK
			or mobjtype == MT_FLINGRING or mobjtype == MT_WHISPER_RING
				mobj.momx = $ + P_RandomRange(-24, 24)*mobj.scale/6
				mobj.momy = $ + P_RandomRange(-24, 24)*mobj.scale/6
				mobj.momz = $ + P_RandomRange(2, 24)*mobj.scale/3*P_MobjFlip(mobj)
				if not vertical
					P_SetObjectMomZ(mobj, 4*FRACUNIT, true)
					if mobjtype == MT_GHOST
						mobj.momz = $*4
					end
				end
			end
			
			if reversed
				P_TeleportMove(mobj, mobj.x + mobj.momx*reversed,
				mobj.y + mobj.momy*reversed, mobj.z + mobj.momz*reversed)
				
				mobj.momx = -$
				mobj.momy = -$
				mobj.momz = -$
				
				mobj.flags = $ | MF_NOGRAVITY
				
			end
			
			if keepmom == -1
				mobj.momx = $ + mo.momx*2/3
				mobj.momy = $ + mo.momy*2/3
				mobj.momz = $ + P_GetMobjGravity(mo)*8
			elseif keepmom
				if keepmom == true then keepmom = 1 end
				mobj.momx = $ + mo.momx/keepmom
				mobj.momy = $ + mo.momy/keepmom
				mobj.momz = $ + mo.momz/keepmom
			end
		end
		i = $ + 1
	end
end)

//Gun frames and RSNEO support
local rs_loaded = false
addHook("PreThinkFrame", do
	if RingSlinger and not rs_loaded
        rs_loaded = true
        
        print("Loaded RingSlinger support for Whisper")
		
		RingSlinger.AddWeapon({
			name = "None",
			hudsprite = "NONEIND",
			viewsprite = "NONEIND",
			viewoffset = -16*FRACUNIT,
			mt = MT_EGGMOBILE_TARGET,
			delay = 0,
			cost = 0
		})
        
        --Define RS NEO stuff here.
        RingSlinger.Skins["whisper"] = {
            ammo = 0,--Maximum ammo.
            weapons = {RSWPN_NONE, RSWPN_NONE}--Main, offhand
        }
    end
	
	for player in players.iterate
		local mo = player.mo
		if not mo then continue end
		
		//Gun frames
		if mo.whispersavedstate
			if mo.skin == "whisper" and mo.state == mo.whispersavedstate
				mo.sprite2 = mo.whispersavedsprite2
				mo.frame = mo.whispersavedframe
			end
			mo.whispersavedstate = nil
		end
		
		//Jumping out of being cubed
		if mo.whispercubed and (player.airdodge
		or (CBW_Battle and CBW_Battle.ButtonCheck(player,player.battleconfig_guard) == 1)
		or (player.cmd.buttons & BT_JUMP and not (player.pflags & PF_JUMPDOWN)))
			WhisperUnCube(mo)
			
			//Escape
			S_StartSound(mo, sfx_wsfrz1)
			A_ForceStop(mo)
			P_DoJump(player, false)
			mo.state = S_PLAY_JUMP
			if player.cmd.buttons & BT_JUMP
				S_StartSound(mo, sfx_jump)
				player.pflags = $ | PF_JUMPDOWN
			else
				player.pflags = $ &~ PF_STARTJUMP
			end
			
			WhisperCircle(mo, MT_GHOST, 16, mo.scale, 0,
			mo.scale/2, 1, SKINCOLOR_BLUE)
			
			local thok = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_COBALT
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = mo.scale
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
		end
	end
end)

//Gun frames part 2
freeslot("S_WHISPER_GUN", "S_WHISPER_MASK")
function A_WhisperGun(mobj, var1, var2)
	if not mobj.threshold
		mobj.flags = $ | MF_BOUNCE &~ MF_NOGRAVITY &~ MF_NOCLIP &~ MF_NOCLIPHEIGHT &~ MF_SCENERY
		mobj.threshold = 1
	end
	mobj.rollangle = $ - FixedAngle(FixedHypot(R_PointToDist2(0,0, mobj.momx, mobj.momy), mobj.momz))*2
	
	if P_CheckDeathPitCollide(mobj) and not (mobj.flags & MF_NOCLIPHEIGHT)
		mobj.flags = $ | MF_NOCLIPHEIGHT | MF_NOCLIP
		mobj.momz = mobj.lastlook
		mobj.shadowscale = 0
	elseif P_IsObjectOnGround(mobj) and not (mobj.flags & MF_NOCLIPHEIGHT)
		mobj.momz = mobj.lastlook*2/-3
		if abs(mobj.momz) < mobj.scale
			mobj.momz = 0
		end
	else
		if mobj.eflags & MFE_UNDERWATER
			mobj.momz = $ - P_GetMobjGravity(mobj)*5/4
			mobj.momx = $*63/64
			mobj.momy = $*63/64
		end
		mobj.lastlook = mobj.momz
	end
	
	if not mobj.fuse
		mobj.fuse = TICRATE*10
	elseif ((mobj.frame & FF_TRANSMASK) >> FF_TRANSSHIFT) <= (NUMTRANSMAPS-1) - mobj.fuse / 2
		mobj.tics = -1
	end
end
states[S_WHISPER_GUN] = {SPR_WSPT, L, 1, A_WhisperGun, 0, 0, S_WHISPER_GUN}
states[S_WHISPER_MASK] = {SPR_WSPT, M, 1, A_WhisperGun, 0, 0, S_WHISPER_MASK}

addHook("PostThinkFrame", do for player in players.iterate
	local mo = player.mo
	if not (mo and mo.skin == "whisper") then continue end
	
	//Gun sprites
	if player.weapondelay
		local sprite2 = mo.sprite2 &~ FF_SPR2SUPER
		if GUNSPRITES[sprite2]
			mo.whispersavedstate = mo.state
			mo.whispersavedsprite2 = mo.sprite2
			mo.whispersavedframe = mo.frame
			
			mo.sprite2 = GUNSPRITES[sprite2] | ($ & FF_SPR2SUPER)
			mo.frame = mo.whispersavedframe &~ FF_FRAMEMASK
			mo.frame = $ + min(mo.whispersavedframe & FF_FRAMEMASK, skins[mo.skin].sprites[mo.sprite2].numframes - 1)
		end
	end
	
	//Hammer effect
	if player.whisperhammer and player.whisperhammer.valid
	and (mo.state == S_PLAY_MELEE_LANDING
	or mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH)
		player.whisperhammer.frame = mo.frame
		if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
			player.whisperhammer.frame = mo.frame + 3
		end
		player.whisperhammer.tics = $ + 1
		
		local ghost = P_SpawnGhostMobj(player.whisperhammer)
		ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		ghost.blendmode = AST_ADD
		
		ghost.scalespeed = FixedMul($, ghost.scale)
		ghost.destscale = INT32_MAX
		
		ghost.flags2 = $ | MF2_BOSSNOTRAP
		ghost.frame = $ &~ FF_TRANSMASK
	end
	
	//Dead Whisper
	if player.deadtimer == 1
		local angle = player.cmd.angleturn<<16 + ANGLE_180
		local gun = P_SpawnMobjFromMobj(mo, 16*cos(angle), 16*sin(angle),
		player.height/2, MT_GHOST)
		
		if not (mo.eflags & MFE_UNDERWATER)
			P_SetObjectMomZ(gun, 14*FRACUNIT, false)
		end
		P_InstaThrust(gun, angle + ANGLE_90, 4*mo.scale)
		
		gun.state = S_WHISPER_GUN
		gun.shadowscale = FRACUNIT
		
		if mo.whisperwassuper
			mo.whisperwassuper = false
			
			local mask = P_SpawnMobjFromMobj(mo, 16*cos(angle), 16*sin(angle),
			player.height*2/3, MT_GHOST)
			
			if not (mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(mask, 18*FRACUNIT, false)
			else
				P_SetObjectMomZ(mask, FRACUNIT, false)
			end
			P_InstaThrust(mask, angle - ANGLE_90, 2*mo.scale)
			
			mask.state = S_WHISPER_MASK
			mask.shadowscale = FRACUNIT
		end
	elseif (player.powers[pw_super] and not player.whispermask)
	or (player.whispermask and not player.powers[pw_super])
		mo.whisperwassuper = true
	elseif mo.whisperwassuper
		mo.whisperwassuper = false
	end
	
	//Followmobj
	DoWhisperOverlay(player, player.followmobj)
	player.whispernewgun = nil
end end)

//Can't move conditions
rawset(_G, "WhisperCantMove", function(player)
	local mo = player.mo
	return not (mo and mo.valid and mo.skin == "whisper")
	or P_PlayerInPain(player)
	or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
	or player.pflags & PF_SLIDING
	or (player.powers[pw_carry] and player.powers[pw_carry] != CR_ROLLOUT
	and player.powers[pw_carry] != CR_MINECART)
	or player.spectator
	or player.playerstate
	or not mo.health
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
end)

//Spin abilities - Laser and Rocket
local whisperspin = function(player)
	if srb2p return end
	local mo = player.mo
	if WhisperCantMove(player)
	or player.pflags & PF_STASIS//|PF_SPINDOWN)
	or player.exiting
	or player.airdodge
	or player.glidetime == 69
	or player.secondjump or player.whisperfloat
	or not player.panim //or player.panim == PA_DASH
	or (not P_IsObjectOnGround(mo) and not player.powers[pw_carry]
	and not (G_RingSlingerGametype()
	and (player.rs_buttons or player.cmd.buttons) & (BT_ATTACK|BT_FIRENORMAL)))
	then return end
	
	if player.weapondelay or player.whispercharge
	or player.panim == PA_PAIN or player.panim > PA_FALL
	then return true end
	
	player.weapondelay = max($, 2)
		
	if player.pflags & PF_JUMPED
		player.pflags = $ | PF_NOJUMPDAMAGE
	end
	player.pflags = $ &~ PF_SPINNING
	
	if not GUNSPRITES[mo.sprite2 &~ FF_SPR2SUPER]
		mo.state = S_PLAY_FALL
	end
	player.whispercharge = 1
	S_StartSound(mo, sfx_wschg1)
	
	player.whisperguncolor = SKINCOLOR_SUPERLASER1
	player.whispernewgun = true
	
	return true
end
addHook("SpinSpecial", whisperspin)

//Now let's do the jump spin abilities
addHook("JumpSpinSpecial", function(player)
	if srb2p return end
	local mo = player.mo
	if WhisperCantMove(player)
	or player.pflags & (PF_STASIS|PF_SPINDOWN)
	or player.panim == PA_ABILITY2
	or player.exiting
	or player.glidetime == 69
	or P_IsObjectOnGround(mo)
	or (player.whispersaw and player.whispersaw.valid)
	then return end
	
	//Do the saw instead of the hammer
	if player.whisperswap ^^ ((not (player.cmd.buttons & BT_JUMP)
	and not player.whisperfloat and player.secondjump != 1) and 1 or 0)
		player.whisperfloat = 0
		player.secondjump = 0
		player.fly1 = 0
		player.glidetime = 69
		
		A_ForceStop(mo)
		player.weapondelay = TICRATE
		player.pflags = $ | PF_THOKKED | PF_NOJUMPDAMAGE &~ PF_SPINNING
		
		local angle = mo.angle
		if player.whispercamera and player.pflags & PF_ANALOGMODE
			angle = player.cmd.angleturn<<16
		end
		
		player.whispersaw = P_SpawnMobjFromMobj(mo, 0,0, player.height/2, MT_WHISPER_SAW)
		player.whispersaw.target = mo
		player.whispersaw.angle = angle
		P_InstaThrust(player.whispersaw, angle, FixedMul(mobjinfo[MT_WHISPER_SAW].speed, mo.scale))
		S_StartSound(mo, mobjinfo[MT_WHISPER_SAW].seesound)
		
		if player.powers[pw_super]
			player.whispersaw.scale = mo.scale*2
			player.whispersaw.momx = $*2
			player.whispersaw.momy = $*2
			player.whispersaw.momz = $*2
		end
		
		if mo.eflags & MFE_UNDERWATER
			player.whispersaw.momx = $/2
			player.whispersaw.momy = $/2
			player.whispersaw.momz = $/2
		end
		
		mo.state = S_PLAY_FALL
		player.whisperguncolor = SKINCOLOR_SUPERSPIKE1
		player.whispernewgun = true
		
		return
	end
	
	//Do the hammer instead of the saw
	
	player.whisperfloat = 0
	player.secondjump = 0
	player.fly1 = 0
	player.glidetime = player.powers[pw_super] and 1 or $ + 1
	
	S_StartSound(mo, sfx_wscub3)
	mo.state = S_PLAY_MELEE
	mo.tics = $*4
	
	player.whisperguncolor = SKINCOLOR_SUPERCUBE1
	player.whispernewgun = true
	
	player.pflags = $ | PF_THOKKED | PF_NOJUMPDAMAGE &~ PF_SPINNING
	if twodlevel or mo.flags2 & MF2_TWOD
		player.drawangle = mo.angle
	elseif player.whispercamera and player.pflags & PF_ANALOGMODE
		player.drawangle = player.cmd.angleturn<<16
	elseif (player.cmd.forwardmove or player.cmd.sidemove)
	and not player.whispercamera
		player.drawangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	else
		player.drawangle = mo.angle
	end
	
	local speed = max(FixedHypot(mo.momx, mo.momy)*2, 16*mo.scale)
	speed = min($, FixedMul(player.actionspd, mo.scale))
	if player.powers[pw_super] then speed = $*2 end
	
	P_InstaThrust(mo, player.drawangle, speed)
	mo.momz = -speed*P_MobjFlip(mo)*2
	
	player.whispermomx = mo.momx
	player.whispermomy = mo.momy
	player.whispermomz = mo.momz
	A_ForceStop(mo)
	
	//Effect
	player.whisperhammer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
	player.whisperhammer.target = mo
	
	player.whisperhammer.state = S_INVISIBLE
	player.whisperhammer.sprite = SPR_WSHM
	player.whisperhammer.tics = 2
	
	player.whisperhammer.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	player.whisperhammer.blendmode = AST_ADD
	
	A_CapeChase(player.whisperhammer)
end)

//Reset Whisper
local function ResetWhisper(player)
	player.whispercharge = 0
	player.whispermomx = 0
	player.whispermomy = 0
	player.whispermomz = 0
	
	if player.whisperfloat
		player.whisperfloat = 0
		if player.secondjump == 1
			player.secondjump = 0
		end
	end
	
	if player.whisperrollangle and player.mo
		player.mo.rollangle = 0
	end
	player.whisperrollangle = 0
	player.whisperprevdrawangle = player.drawangle
	
	if player.mo and player.mo.state == S_PLAY_GLIDE
		player.mo.state = S_PLAY_FALL
	end
	
	player.whisperreset = true
end
addHook("PlayerSpawn", function(player)
	ResetWhisper(player)
	
	//I/O maybe
	if player.whisperswap == nil
		player.whisperswap = 0
		player.whisperwisptoggle = 1
		player.whispercamera = 0
		player.whisperaim = 1
		
		if io and player == consoleplayer
			local file = io.openlocal("client/Whisper.dat")
			if file
				local num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "whisperswap "..num.." 0")
				end
				
				num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "whisperwisp "..num.." 0")
				end
				
				num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "whispercamera "..num.." 0")
				end
				
				num = file:read("*l")
				if num != nil
					COM_BufInsertText(consoleplayer, "whisperaim "..num.." 0")
				end
				
				file:close()
			end
		end
	end
end)
for player in players.iterate ResetWhisper(player) end

//Main thinker
addHook("PlayerThink", function(player)
	local mo = player.mo
	
	//Mask Button
	if player.cmd.buttons & BT_CUSTOM1 and player.whispercustom != nil
		player.whispercustom = $ + 1
	else
		player.whispercustom = 0
	end
	
	if not mo then return end
	if mo.whispernocrush then mo.whispernocrush = $ - 1 end
	
	if mo.skin == "whisper"
		//Skid animation
		if mo.state == S_PLAY_SKID
			local tics = mo.tics
			if not (tics%4)
				mo.state = S_PLAY_SKID
				mo.tics = tics
			end
		end
		
		//Only transform during hammer or saw
		if not player.powers[pw_super] and not player.powers[pw_invulnerability]
		and not player.powers[pw_tailsfly] and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_shield] & SH_NOSTACK)
		and not (maptol & TOL_NIGHTS) and All7Emeralds(emeralds)
		and player.rings >= 50 and not player.climbing and not player.exiting
		and not player.powers[pw_carry] and not P_PlayerInPain(player)
		and not (player.pflags & (PF_GLIDING|PF_SLIDING|PF_SHIELDABILITY|PF_SPINDOWN|PF_JUMPSTASIS))
			if mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH
			or player.glidetime == 69
				player.charflags = $ | SF_SUPER
			elseif player.charflags & SF_SUPER
				player.charflags = $ &~ SF_SUPER
			end
		elseif not (player.charflags & SF_SUPER)
			player.charflags = $ | SF_SUPER
		end
		
		//Ringslinger Neo weapon delay
		if mo.ringslinger
			mo.ringslinger.weapondelay = player.weapondelay + 2
		end
			
	//Revert mask
	elseif mo.whispermask
		mo.eflags = $ &~ MFE_REVERSESUPER
		mo.whispermask = nil
		mo.state = $
	end
	
	if mo.skin == "whisper" and player.whisperfloat
	
		//Circle effect
		if not (player.fly1 % 7)
			local thok = P_SpawnMobjFromMobj(mo, 0,0,
			P_MobjFlip(mo) > 0 and player.height*2 or player.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			thok.momx = mo.momx*8/9
			thok.momy = mo.momy*8/9
			//thok.momz = mo.momz*8/9
			
			thok.height = thok.scale
			thok.state = S_WHISPER_CIRCLE
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
		end
		player.fly1 = $ + 1
		
		//Main effect
		if player.whisperhover and player.whisperhover.valid
			if player.whisperhover.state == S_WHISPER_HOVER2
				player.whisperhover.tics = $ + 1
			end
			
			if player.fly1 & 1
				local ghost = P_SpawnGhostMobj(player.whisperhover)
				ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				ghost.blendmode = AST_ADD
				ghost.spritexoffset = player.whisperhover.spritexoffset
				ghost.spriteyoffset = player.whisperhover.spriteyoffset
				
				ghost.scalespeed = FixedMul($, ghost.scale)
				ghost.destscale = INT32_MAX
				
				ghost.momx = mo.momx*8/9
				ghost.momy = mo.momy*8/9
				ghost.momz = mo.momz*8/9 - FixedMul(ghost.spriteyoffset, ghost.scalespeed)*P_MobjFlip(mo)
			end
		end
		
		//Float sounds
		if not S_SoundPlaying(mo, sfx_wsflt1)
			S_StartSound(mo, sfx_wsflt1)
		end
		if not S_SoundPlaying(mo, sfx_wsflt2)
			S_StartSound(mo, sfx_wsflt2)
		end
		
		//No autobrake
		player.powers[pw_noautobrake] = max($, 2)
		
	//Kill sounds
	elseif S_SoundPlaying(mo, sfx_wsflt1)
	or S_SoundPlaying(mo, sfx_wsflt2)
	or S_SoundPlaying(mo, sfx_wshov1)
		S_StopSoundByID(mo, sfx_wsflt1)
		S_StopSoundByID(mo, sfx_wsflt2)
		S_StopSoundByID(mo, sfx_wshov1)
		
		S_StartSound(mo, sfx_wsflt3)
	end
	
	//
	//Prevent the rest of the code
	//
	if WhisperCantMove(player)
		if not player.whisperreset
			ResetWhisper(player)
		end
		return
	end
	player.whisperreset = false
	
	//Allow hyper whisper
	if player.mrce and skins[player.skin] == "whisper"
		player.mrce.hyperimages = true
		player.mrce.canhyper = true
		player.mrce.ultrastar = false
	end
	
	//Mask
	
	//Retain between levels
	if player.whispermask and player.whispermask != mo.eflags & MFE_REVERSESUPER
		mo.eflags = ($ &~ MFE_REVERSESUPER) | (player.whispermask)
		mo.whispermask = mo.eflags & MFE_REVERSESUPER
		mo.state = $
		
	//Press button
	elseif player.whispercustom == 1
	and (player.panim == PA_IDLE or player.panim == PA_EDGE)
		if mo.eflags & MFE_REVERSESUPER
			mo.eflags = $ &~ MFE_REVERSESUPER
		else
			mo.eflags = ($ &~ MFE_REVERSESUPER) | MFE_REVERSESUPER
		end
		player.whispermask = mo.eflags & MFE_REVERSESUPER
		mo.whispermask = mo.eflags & MFE_REVERSESUPER
		
		mo.state = $
		S_StartSound(mo, sfx_wsmask)
	end
	
	//Fix detransformation
	if player.powers[pw_super] and mo.eflags & MFE_REVERSESUPER
		mo.whisperdetransform = true
	elseif mo.whisperdetransform
		if mo.state == S_PLAY_GLIDE
			mo.state = S_PLAY_TWINSPIN
		else
			mo.state = $
		end
		mo.whisperdetransform = false
	end
	
	//SpinSpecial for minecarts, and also using the gun in ringslinger
	if G_RingSlingerGametype() then player.pflags = $ | PF_ATTACKDOWN end
	if (G_RingSlingerGametype() and (player.rs_buttons or player.cmd.buttons) & (BT_ATTACK|BT_FIRENORMAL))
	or (player.powers[pw_carry] == CR_MINECART and player.cmd.buttons & BT_SPIN)
		whisperspin(player)
	end
	
	//Charging
	if player.whispercharge
		player.weapondelay = max($, 2)
		player.whispercharge = $ + 1
		
		//Charged
		if player.whispercharge == WHISPERCHARGE
			S_StartSound(mo, sfx_wschg2)
			player.whisperguncolor = SKINCOLOR_SUPERROCKET1
			player.whispernewgun = true
			
			local thok = P_SpawnMobj(mo.x + P_ReturnThrustX(mo, player.drawangle, mo.radius*2),
			mo.y + P_ReturnThrustY(mo, player.drawangle, mo.radius*2), mo.z + mo.height*2/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_RUST
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = player.drawangle + ANGLE_90
			
			thok.momx = mo.momx/2
			thok.momy = mo.momy/2
			thok.momz = mo.momz/2
			
			thok.scale = mo.scale/2
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
		end
		
		//Cancel charge
		if not player.panim //or player.panim == PA_DASH
		or player.panim == PA_PAIN or player.panim > PA_FALL
		or player.secondjump or player.whisperfloat
		or player.airdodge //or mo.eflags & MFE_SPRUNG
			player.whispercharge = 0
			
		//Shoot a laser or a rocket
		elseif not ((player.rs_buttons or player.cmd.buttons) & (BT_SPIN|BT_ATTACK|BT_FIRENORMAL))
		and player.whispercharge > WHISPERSTARTLAG
			if P_IsObjectOnGround(mo) or player.powers[pw_carry]
				mo.state = S_PLAY_GLIDE_LANDING
			else
				mo.state = S_PLAY_MELEE_FINISH
			end
			mo.sprite2 = SPR2_FALL | ($ & FF_SPR2SUPER)
			player.panim = PA_DASH
			mo.tics = 7
			
			if player.whispercamera and player.pflags & PF_ANALOGMODE
				player.drawangle = player.cmd.angleturn<<16
			elseif not (player.powers[pw_carry] == CR_ROLLOUT
			and player.pflags & PF_ANALOGMODE
			and not player.cmd.forwardmove and not player.cmd.sidemove)
				player.drawangle = mo.angle
			end
			player.weapondelay = WHISPERENDLAG
			player.powers[pw_justsprung] = player.weapondelay
			
			//Is it a laser? Or is it a rocket?
			local laser = player.whispercharge < WHISPERCHARGE
			local type = laser and MT_WHISPER_LASER or MT_WHISPER_ROCKET
			if laser
				P_Thrust(mo, player.drawangle, -8*mo.scale)
				if player.powers[pw_carry] == CR_ROLLOUT and mo.tracer
					P_Thrust(mo.tracer, player.drawangle, -8*mo.scale)
				end
				
				//Kill the laser already out
				if player.whisperlaser and player.whisperlaser.valid
				and player.whisperlaser.flags & MF_MISSILE
					P_KillMobj(player.whisperlaser)
				end
			else
				P_InstaThrust(mo, player.drawangle, -(P_IsObjectOnGround(mo) and 8 or 16)*mo.scale)
				if player.powers[pw_carry] == CR_ROLLOUT and mo.tracer
					P_InstaThrust(mo.tracer, player.drawangle, -(P_IsObjectOnGround(mo.tracer) and 8 or 16)*mo.scale)
				end
			end
			player.whispercharge = 0
				
			//Bruh why doesn't P_SPMAngle let me do anything
			//with a missile spawned in a wall
			local speed = mobjinfo[type].speed
			local aiming = player.aiming
			if not player.whisperaim or (CBW_Battle
			and CBW_Battle.BattleGametype() and not whisperbattleaim.value)
				aiming = 0
			end
			local x = mo.x
			local y = mo.y
			local z = mo.z
			if P_MobjFlip(mo) < 0
				z = $ + 2*mo.height/3 - FixedMul(mobjinfo[type].height, mo.scale)
				if type == MT_WHISPER_ROCKET and player.powers[pw_super]
					z = $ + FixedMul(mobjinfo[type].height, mo.scale)
				end
			else
				z = $ + mo.height/3
			end
			
			//Calculate speed
			local momx = FixedMul(speed, cos(player.drawangle))
			local momy = FixedMul(speed, sin(player.drawangle))
			momx = FixedMul($,cos(aiming))
			momy = FixedMul($,cos(aiming))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)

			local momz = FixedMul(speed, sin(aiming))
			momz = FixedMul($, mo.scale)
			
			//Add speed to position
			local factor = laser and 3 or 32
			x = $ + momx*factor + mo.momx
			y = $ + momy*factor + mo.momy
			z = $ + momz*factor + mo.momz
			
			//Spawn missile
			local th = P_SpawnMobj(x, y, z, type)
			if P_MobjFlip(mo) < 0
				th.flags2 = $ | MF2_OBJECTFLIP
			end
			th.scale = mo.scale
			th.target = mo
			th.angle = player.drawangle
			if type == MT_WHISPER_ROCKET and player.powers[pw_super]
				th.scale = $*2
			end
			
			//Missile momentum
			th.momx = momx
			th.momy = momy
			th.momz = momz
			
			//Explode missile at wall
			if P_TryMove(th, th.x, th.y, true) and P_CheckSight(mo, th)
				S_StartSound(mo, th.info.seesound)
				if laser then player.whisperlaser = th end
			else
				P_ExplodeMissile(th)
				th.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT
				P_TeleportMove(th, x, y, z)
			end
			
		//Face your aiming angle
		elseif not (player.pflags & PF_ANALOGMODE and not player.whispercamera)
		or (player.powers[pw_carry]
		and (player.cmd.forwardmove or player.cmd.sidemove))
			player.powers[pw_justsprung] = max($, 2)
			
			local diff = mo.angle - player.drawangle
			local factor = 4
			
			if player.pflags & PF_ANALOGMODE
				diff = player.cmd.angleturn<<16 - player.drawangle
			end
			
			if diff
				if diff > ANGLE_180
					diff = InvAngle(InvAngle(diff)/factor)
				else
					diff = $ / factor
				end
				player.drawangle = $ + diff
			end
		end
	end
	
	//Slow fall even on ground
	if player.secondjump == 1 and not player.whisperfloat
		player.secondjump = 0
	elseif player.whisperfloat == 3
		//Cancel
		if not (player.cmd.buttons & BT_JUMP) or player.powers[pw_carry]
		or (mo.eflags & MFE_SPRUNG and not (player.pflags & PF_THOKKED))
		or not player.panim or player.gotflag or player.exiting
		or (player.panim > PA_DASH and mo.state != S_PLAY_GLIDE)
			player.whisperfloat = 0
			if player.secondjump == 1
				player.secondjump = 0
			end
			
			if mo.state == S_PLAY_GLIDE or mo.state == S_PLAY_FALL
				mo.state = S_PLAY_TWINSPIN
			end
			
			if P_IsObjectOnGround(mo)
				player.pflags = $ &~ PF_JUMPED &~ PF_NOJUMPDAMAGE &~ PF_THOKKED
			end
			
		//Main
		else
			if not P_IsObjectOnGround(mo)
				player.secondjump = $ or 1
				player.pflags = $ | PF_JUMPED | PF_NOJUMPDAMAGE | PF_THOKKED
			end
			
			if mo.state != S_PLAY_GLIDE
				mo.state = S_PLAY_GLIDE
			end
			
			//Float on ground
			local z = mo.z
			local floorz = mo.floorz
			//Reverse gravity (values are negative to make the later checks easier)
			if P_MobjFlip(mo) < 0
				z = -(mo.z + mo.height)
				floorz = -mo.ceilingz
				//Stupid water detection
				if mo.subsector and mo.subsector.sector
					for fof in mo.subsector.sector.ffloors()
						if fof.flags & FF_SWIMMABLE and z > -(fof.bottomheight + mo.height)
							floorz = max($, -fof.bottomheight)
						end
					end
				end
			//Stupid water detection
			elseif mo.subsector and mo.subsector.sector
				for fof in mo.subsector.sector.ffloors()
					if fof.flags & FF_SWIMMABLE and z > fof.topheight - mo.height
						floorz = max($, fof.topheight)
					end
				end
			end
			
			//Test for pit
			local ray = P_SpawnMobjFromMobj(mo, 0,0,0, MT_RAY)
			ray.z = floorz*P_MobjFlip(mo)
			if P_CheckDeathPitCollide(ray)
				//There's a pit
			
			//Do the actual ground floating
			elseif P_IsObjectOnGround(mo) or z - floorz < mo.height/2
				mo.momz = $ + abs(P_GetMobjGravity(mo)*5/3)*P_MobjFlip(mo)
				player.secondjump = 0 //Disable slow fall for better float
			elseif z - floorz < mo.height*2/3
				player.secondjump = 0 //Disable slow fall for better float
			end
			mo.friction = FRACUNIT
		end
		
	//Flying float, uses regular slow fall
	elseif player.whisperfloat
		//End flight, hit spring
		if (mo.eflags & MFE_SPRUNG and not (player.pflags & PF_THOKKED))
		or player.powers[pw_carry] or player.gotflag or player.exiting
			player.whisperfloat = 0
			
		//Do the flight for when we hold jump or until it's over
		elseif player.cmd.buttons & BT_JUMP
		and not (P_MobjFlip(mo) > 0 and mo.z + mo.height >= mo.ceilingz)
		and not (P_MobjFlip(mo) < 0 and mo.z <= mo.floorz)
		and mo.momz*P_MobjFlip(mo) < (player.whisperfloat == 1 and 9*mo.scale or FixedMul(gravity, -4*mo.scale))
			//Is division or addition more effective here?
			local divmomz = mo.momz*7/8
			P_SetObjectMomZ(mo, FRACUNIT*3/2, true)
			if divmomz * P_MobjFlip(mo) > mo.momz * P_MobjFlip(mo)
				mo.momz = divmomz
			end
			
			if not P_IsObjectOnGround(mo)
				player.pflags = $ | PF_JUMPED | PF_NOJUMPDAMAGE | PF_THOKKED
			end
			
		//End flight, transition to vanilla slow fall
		elseif not player.powers[pw_super] or not (player.cmd.buttons & BT_JUMP)
			player.whisperfloat = 3
			player.secondjump = $ or 1
		end
	end
	
	//Float state and rollangle
	if mo.state == S_PLAY_GLIDE and player.whisperfloat
		player.panim = PA_DASH
		
		//Calculate angle
		local diff = player.whisperprevdrawangle - player.drawangle
		local limit = max(ANGLE_22h, abs(diff)/4)
		if abs(diff) > ANG1
			local change = ANG2
			if diff > 0 then change = -$ end
			player.whisperrollangle = min(max($ + change, -limit), limit)
		else
			player.whisperrollangle = FixedMul($, FRACUNIT*7/8)
		end
		
		//Calculate angle to rollangle (thanks Golden for sloperollangle)
		if not splitscreen
			if player.whisperrollangle
				local cameraangle = R_PointToAngle(mo.x, mo.y)
				local diff = cameraangle - player.drawangle
				mo.rollangle = FixedMul(player.whisperrollangle, cos(diff))
			else
				mo.rollangle = 0
			end
		end
		
		//Apply to effect too
		if player.whisperhover and player.whisperhover.valid
			player.whisperhover.rollangle = mo.rollangle
			player.whisperhover.spritexoffset = player.whisperhover.rollangle/256
		end
	elseif player.whisperrollangle
		player.whisperrollangle = 0
		mo.rollangle = 0
		if mo.state == S_PLAY_GLIDE
			mo.state = S_PLAY_FALL
		end
	end
	player.whisperprevdrawangle = player.drawangle
	
	//Cube hammer
	//Switch to hammer out of bounce state
	if mo.state == S_PLAY_MELEE
	and mo.frame & FF_FRAMEMASK < skins[mo.skin].sprites[mo.sprite2].numframes - 2
		//Backpedal
		A_ForceStop(mo)
		P_TryMove(mo, mo.x - player.whispermomx/16, mo.y - player.whispermomy/16, true)
		mo.z = $ - player.whispermomz/32

		//Restore momentum
		if mo.frame & FF_FRAMEMASK
			if mo.tics == 1
				mo.momx = player.whispermomx
				mo.momy = player.whispermomy
				mo.momz = player.whispermomz
				player.glidetime = $ + 1
			end
		elseif mo.tics == 1
			S_StartSoundAtVolume(mo, sfx_wscub1, 128)
		end
		
	//Lack of movement and higher gravity
	elseif mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH
	or mo.state == S_PLAY_MELEE_LANDING
		player.pflags = $ | PF_SPINDOWN
		if not P_IsObjectOnGround(mo) and mo.state != S_PLAY_MELEE_LANDING
			mo.momz = $ + P_GetMobjGravity(mo)
		end
		
		//Go forward to simulate the hitbox
		local x = mo.x
		local y = mo.y
		local z = mo.z
		local momx = mo.momx
		local momy = mo.momy
		local momz = mo.momz
		local flags = mo.flags
		local godmode = player.pflags & PF_GODMODE
		local flashing = player.powers[pw_flashing]
		mo.flags = $ | MF_NOCLIPTHING | MF_NOCLIPHEIGHT
		player.pflags = $ | PF_GODMODE
		player.powers[pw_flashing] = TICRATE
		mo.radius = $*2
		mo.flags = flags
		if srb2p then player.dashmode = 10*TICRATE end
		P_TryMove(mo, mo.x + mo.momx + P_ReturnThrustX(nil, player.drawangle, mo.height),
		mo.y + mo.momy + P_ReturnThrustY(nil, player.drawangle, mo.height), true)
		local grounded = P_IsObjectOnGround(mo)
		
		//Go back
		mo.flags = $ | MF_NOCLIPTHING | MF_NOCLIPHEIGHT
		mo.radius = $/2
		if srb2p then player.dashmode = 0 end
		if not (mo.eflags & MFE_SPRUNG)
			P_TryMove(mo, x, y, true)
			mo.z = z
			if grounded and not P_IsObjectOnGround(mo)
				mo.momx = momx
				mo.momy = momy
				mo.momz = momz
			end
		end
		mo.flags = flags
		player.pflags = ($ &~ PF_GODMODE) | godmode
		player.powers[pw_flashing] = flashing
	end
end)