//Spin ability - Rocket Launcher

sfxinfo[freeslot("sfx_wsrck1")].caption = "/"
sfxinfo[sfx_wsrck1].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wsrck2")].caption = "Rocket hit"
sfxinfo[sfx_wsrck2].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wsrck3")].caption = "Rocket explode"
sfxinfo[sfx_wsrck3].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wsrck4")].caption = "Rocket shoot"
sfxinfo[sfx_wsrck4].flags = $|SF_X2AWAYSOUND
sfxinfo[freeslot("sfx_wslock")].caption = "Locked on"
sfxinfo[sfx_wslock].flags = $|SF_X2AWAYSOUND

//EnemyLookDeluxe isn't treating me kindly...
//so I'm just gonna use the one from Fang Popgun Modifications by CobaltBW
local function newRocketLook(player, mobj, ringdist, span, prevtarget) 
	local twod = (twodlevel or mobj.flags2 & MF2_TWOD)
	ringdist = $ or RING_DIST*2
	if not(twod)
		span = $ or ANG30
	else
		span = ANG20
	end

	local maxdist = FixedMul(ringdist, mobj.scale)
	local closestdist = 0
	local closestmo = nil
	local nonenemiesdisregard = MF_SPRING
	searchBlockmap("objects",function(refmobj,mo)
		if (mo.flags & MF_NOCLIPTHING) return end
		if (mo.health <= 0) return end -- dead
		if (mo == refmobj or mo == player.mo or mo == prevtarget) return end

		if not(mo.player)
		and not(mo.type == MT_SALOONDOORCENTER and mobj.type == MT_WHISPER_ROCKET)
		and (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
		and (mo.flags & MF_SHOOTABLE)) or (mo.flags & MF_SPRING)) == !(mo.flags2 & MF2_INVERTAIMABLE)) -- allows if it has the flags desired XOR it has the invert aimable flag
			return -- not a valid target
		end
		//CTF monitor 
		if mo.type == MT_RING_REDBOX and not(G_GametypeHasTeams() and player.ctfteam == 1) then return end
		if mo.type == MT_RING_BLUEBOX and not(G_GametypeHasTeams() and player.ctfteam == 2) then return end

		if (mo == player.mo or mo == mobj) return end
		if (mo.flags2 & MF2_FRET) return end
		if (mo.flags & nonenemiesdisregard) return end
		if mo.player and 
			(
			mo.player.spectator
			or (gametyperules & GTR_FRIENDLY and not CV_FindVar("friendlyfire").value)
			or (G_GametypeHasTeams() and mo.player.ctfteam == player.ctfteam)
			or (G_TagGametype() and mo.player.pflags & PF_TAGIT == player.pflags & PF_TAGIT)
			)
		then return end //Disallow targeting teammates


		//Do angle/distance checks
		local zdist = (mobj.z + mobj.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(mobj.x-mo.x, mobj.y-mo.y)
		//CBW: 	Made the angle checks their own locals, for readability purposes
		//		I also unsigned the angle checks, which appears to correct failed OutOfBounds checks above the player.
		local xyz_angle = abs(R_PointToAngle2(0, 0, dist, zdist))
		local xy_angle = abs(R_PointToAngle2(
				mobj.x + P_ReturnThrustX(mobj, mobj.angle, mobj.radius),
				mobj.y + P_ReturnThrustY(mobj, mobj.angle, mobj.radius),
				mo.x, mo.y
			) - mobj.angle)
			
			
		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist)
			return -- out of range
		end
		if (xyz_angle > span and span > 0)
			return -- Don't home outside of desired angle!
		end


		if (twod
		and abs(mobj.y-mo.y) > mobj.radius)
			return -- not in your 2d plane
		end

		if ((closestmo and closestmo.valid) and (dist > closestdist))
			return
		end
		if (xy_angle > span and span > 0)
			return -- behind back
		end

		if not (P_CheckSight(mobj, mo))
			return -- out of sight
		end

		closestmo = mo
		closestdist = dist
	end,mobj,mobj.x-maxdist,mobj.x+maxdist,mobj.y-maxdist,mobj.y+maxdist)
	return closestmo
end

local STARTINGSPEED = FRACUNIT
freeslot("MT_WHISPER_ROCKET", "SPR_WSEX", "S_WHISPER_ROCKET", "S_WHISPER_EXPLODE")
states[S_WHISPER_ROCKET] = {SPR_WSEX, Z, 1, A_SmokeTrailer, MT_ARIDDUST, 0, S_WHISPER_ROCKET}
states[S_WHISPER_EXPLODE] = {SPR_WSEX, FF_ANIMATE, X + 1, A_PlayAttackSound, X, 1, S_BIGMINE_BLAST5}
mobjinfo[MT_WHISPER_ROCKET] = {
	spawnstate = S_WHISPER_ROCKET,
	deathstate = S_WHISPER_EXPLODE,
	xdeathstate = S_WHISPER_EXPLODE,
	seesound = sfx_wsrck4,
	painchance = sfx_wsrck1,
	attacksound = sfx_wsrck2,
	painsound = sfx_wsrck3,
	spawnhealth = 1000,
	speed = STARTINGSPEED, //Starting speed
	raisestate = 60, //Top speed
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	damage = 1,
	flags = MF_MISSILE|MF_NOGRAVITY,
}

//Rocket lockon
freeslot("MT_WHISPER_TARGET", "S_WHISPER_TARGET")
states[S_WHISPER_TARGET] = {SPR_WSEX, Y|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
mobjinfo[MT_WHISPER_TARGET] = {
	spawnstate = S_WHISPER_TARGET,
	spawnhealth = 1000,
	height = FRACUNIT,
	radius = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
	speed = RING_DIST*4/72,
}

//Explode laser on hitting something
//Make rocket deal double damage
addHook("MobjDamage", function(mobj, inf, src, dmg, dmgtype)
	if not inf then return end
	if inf.type == MT_WHISPER_LASER
		//If super, keep the laser going towards a new target
		if src and src.player and src.player.powers[pw_super]
			if inf.threshold <= 1 then return end
			local target = newRocketLook(src.player, inf, nil, ANGLE_MAX, mobj)
			if not target then return end
			
			src.player.whisperlaser = P_SpawnPointMissile(src,
			target.x, target.y, target.z + target.height/2,
			MT_WHISPER_LASER, inf.x, inf.y, inf.z)
			S_StopSoundByID(src.player.whisperlaser, inf.info.seesound)
		end
		
		P_KillMobj(inf)
	elseif inf.type == MT_WHISPER_ROCKET and mobj.health > 1 and dmg <= 1
		P_DamageMobj(mobj, inf, src, dmg*2, dmgtype)
		return true
	end
end)

//Explode on fuse
addHook("MobjFuse", function(mobj)
	P_ExplodeMissile(mobj)
	return true
end, MT_WHISPER_ROCKET)

//Ignore friendly players
addHook("MobjMoveCollide", function(mobj, mo)
	if mo.player and not CV_FindVar("friendlyfire").value
	and (gametyperules & GTR_FRIENDLY or (G_GametypeHasTeams()
	and mobj.target.player and mobj.target.player.ctfteam == mo.player.ctfteam))
		return false
	end
end, MT_WHISPER_ROCKET)

//Don't damage with the missile itself, nor damage friendly players
addHook("ShouldDamage", function(mo, mobj)
	if mobj and mobj.type == MT_WHISPER_ROCKET and mobj.target != mo
	and (not (mobj.flags2 & MF2_EXPLOSION) or (mo.player
	and not CV_FindVar("friendlyfire").value
	and (gametyperules & GTR_FRIENDLY or (G_GametypeHasTeams()
	and mobj.target.player and mobj.target.player.ctfteam == mo.player.ctfteam))))
		return false
	end
end)

//Egg Wall Breaker Function
local eggwallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Egg Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	local killone
	local killtwo
	if not (line and line.valid and mobj and mobj.valid) then return end
	if line.frontsector and line.frontsector.valid then killone = eggwallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = eggwallbreak(mobj, line.backsector) end
	if killone or killtwo then P_ExplodeMissile(mobj) end
end, MT_WHISPER_ROCKET)

//Rocket Thinker
addHook("MobjThinker", function(mobj)
	//MobjSpawn hook
	if not mobj.threshold
		mobj.fuse = TICRATE*4
		mobj.scalespeed = FixedMul($, mobj.scale)
		
		S_StartSound(mobj, mobj.info.painchance)
		
		mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		mobj.blendmode = AST_ADD
		mobj.color = SKINCOLOR_ORANGE
		if mobj.target and mobj.target.player
		and not (gametyperules & (GTR_FRIENDLY | GTR_RACE))
			mobj.color = mobj.target.color
			mobj.colorized = true
		end
		
		local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
		thok.state = S_WHISPER_SHOCK
		
		thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		thok.blendmode = AST_ADD
		thok.color = mobj.color
	end
	mobj.threshold = $ + 1
	
	//When dying
	if not (mobj.flags & MF_MISSILE)
		//Start explosion
		if not mobj.reactiontime
			mobj.movefactor = mobj.scale
			mobj.destscale = INT32_MAX
			mobj.fuse = 0
			
			S_StopSoundByID(mobj, mobj.info.painchance)
			
		//Explosion damage
		elseif mobj.reactiontime == J
			mobj.flags2 = $ | MF2_EXPLOSION
			
			//This is supposed to be A_MineExplode, but somebody thought it'd
			//be funny to make the explosion global, AND also make self-damage
			//earn points in Ringslinger/Battlemod
			A_Scream(mobj)
			mobj.flags = MF_NOGRAVITY|MF_NOCLIP
			
			//Quake
			if (mobj.target and mobj.target.player
			and (mobj.target.player == displayplayer or mobj.target.player == secondarydisplayplayer))
			or (displayplayer and displayplayer.mo
			and P_AproxDistance(mobj.x - displayplayer.mo.x,
			mobj.y - displayplayer.mo.y) < 512*mobj.movefactor)
				P_StartQuake(8*mobj.movefactor, TICRATE/3)
			end

			local dist = 64
			local type = ((mobj.eflags & MFE_UNDERWATER) and MT_UWEXPLODE or MT_SONIC3KBOSSEXPLODE)
			S_StartSound(mobj, ((mobj.eflags & MFE_UNDERWATER) and sfx_s3k57 or sfx_s3k4e))
			local b = P_SpawnMobjFromMobj(mobj, 0,0,0, type)
			b.scale = mobj.movefactor
			for i = 0, 15
				b = P_SpawnMobjFromMobj(mobj, P_RandomRange(-dist, dist)*FRACUNIT,
					P_RandomRange(-dist, dist)*FRACUNIT,
					P_RandomRange(((mobj.eflags & MFE_UNDERWATER) and -dist or 0), dist)*FRACUNIT,
					type)
				b.scale = mobj.movefactor
				local dx = b.x - mobj.x local dy = b.y - mobj.y local dz = b.z - mobj.z
				local dm = P_AproxDistance(dz, P_AproxDistance(dy, dx))
				b.momx = FixedDiv(dx, dm)*3
				b.momy = FixedDiv(dy, dm)*3
				b.momz = FixedDiv(dz, dm)*3
				if ((mobj.watertop == INT32_MAX) or (b.z + b.height > mobj.watertop))
					b.flags = $ &~ MF_NOGRAVITY
				end
			end

			if (mobj.watertop != INT32_MAX)
				P_SpawnMobj(mobj.x, mobj.y, mobj.watertop, (mobj.eflags & MFE_TOUCHLAVA) and MT_LAVASPLISH or MT_SPLISH)
			end
				
			A_Pain(mobj)
			S_StopSoundByID(mobj.target, mobj.info.attacksound)
			
			A_CanarivoreGas(mobj, MT_TNTDUST)
			mobj.scalespeed = $*2
			
			//P_RadiusAttack is not doing me any favors...
			local maxdist = 192*mobj.scale
			searchBlockmap("objects",function(refmobj,mo)
				if mo and mo.valid and mo.health
				and (mo.flags & MF_SHOOTABLE or mo.type == MT_METALSONIC_BATTLE
				or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
				or mo.type == MT_SALOONDOORCENTER or mo.flags & MF_PUSHABLE)
				and P_AproxDistance(P_AproxDistance(mobj.x - mo.x, mobj.y - mo.y), mobj.z - mo.z) < maxdist
					if mo.type == MT_SALOONDOORCENTER
						WhisperCircle(mo, MT_WOODDEBRIS, 8, 16*mobj.scale, mo.info.height/2, mobj.scale, 1)
					end
					
					//Barrel code, more or less truncated PIT_TNTExplode
					if mo.type == MT_TNTBARREL and mo.state == mo.info.spawnstate
						local explodethrust = 32*FRACUNIT
						local dx = mo.x - mobj.x
						local dy = mo.y - mobj.y
						local dz = mo.z - mobj.z + (mo.height - mobj.height/2)/2
						local dm = P_AproxDistance(P_AproxDistance(dx, dy), dz)
						
						if (mo.info.attacksound)
							S_StartSound(mo, mo.info.attacksound)
						end
						mo.momx = FixedMul(FixedDiv(dx, dm), explodethrust)
						mo.momy = FixedMul(FixedDiv(dy, dm), explodethrust)
						mo.momz = FixedMul(FixedDiv(dz, dm), explodethrust)
						
						//This action lets us to set MF_NOBLOCKMAP without issues
						A_SetObjectFlags(mo, MF_NOBLOCKMAP|MF_MISSILE)
						mo.state = mo.info.missilestate
						
					//Ugh, Metal
					elseif mo.type == MT_METALSONIC_BATTLE
					and not (mo.flags2 & MF2_CLASSICPUSH) and mo.state == mo.info.spawnstate
						mo.flags2 = $ | MF2_CLASSICPUSH
					
					//Hurt damagable objects
					elseif mo.flags & MF_SHOOTABLE
						/*
						If we can't damage this object, chances are we're
						trying to damage ourselves or something friendly.
						Try again but this time without a target so
						we can't gain points off of self-damage.
						*/
						if not P_DamageMobj(mo, mobj, mobj.target, 1)
							P_DamageMobj(mo, mobj, mobj, 1)
						end
						
					//Blast pushables around
					elseif mo.flags & MF_PUSHABLE
						mo.z = $ + P_MobjFlip(mo)
						P_InstaThrust(mo, R_PointToAngle2(mobj.x, mobj.y, mo.x, mo.y), 30*mobj.scale)
						P_SetObjectMomZ(mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
						
					//Guess you'll die!
					else
						P_KillMobj(mo, mobj, mobj.target)
					end
				end
			end,mobj,mobj.x-maxdist,mobj.x+maxdist,mobj.y-maxdist,mobj.y+maxdist)
		end
		mobj.reactiontime = $ + 1
		return
	elseif not mobj.health
		P_ExplodeMissile(mobj)
		return
	else
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		ghost.blendmode = AST_ADD
		ghost.frame = 0
		ghost.sprite = SPR_WSPT
		ghost.scale = $/2
		ghost.z = mobj.z + mobj.height/2
	end
	
	//Gain speed over time
	local oldspeed = FixedHypot(FixedHypot(mobj.momx, mobj.momy), mobj.momz)
	local newspeed = mobj.info.raisestate*mobj.scale
	if oldspeed < newspeed
		newspeed = FixedDiv(min(oldspeed*9/8, $), mobj.scale)
		
		local vangle = R_PointToAngle2(0,0, FixedHypot(mobj.momx, mobj.momy), mobj.momz)
		P_InstaThrust(mobj, R_PointToAngle2(0,0, mobj.momx, mobj.momy),
		FixedMul(FixedMul(newspeed, cos(vangle)), mobj.scale))
		mobj.momz = FixedMul(FixedMul(newspeed, sin(vangle)), mobj.scale)
	end
	
	//Find a target and chase it
	if mobj.tracer
		//Targetting effect
		local player = mobj.target and mobj.target.player
		local lockon = mobj.tracer
		local target = P_SpawnMobjFromMobj(lockon,0,0,FixedDiv(lockon.height/2,lockon.scale),MT_WHISPER_TARGET)
		
		if player != displayplayer and player != secondarydisplayplayer
		and (displayplayer and displayplayer.valid and lockon != displayplayer.mo)
			target.flags2 = $|MF2_DONTDRAW
		elseif mobj.lockontime == TICRATE/4
			S_StartSound(lockon, sfx_wslock)
		end
	
		//The actual homing
		mobj.info.speed = newspeed
		local oldmomx = mobj.momx
		local oldmomy = mobj.momy
		local oldmomz = mobj.momz
		//Home in on the targetting effect since it's in the center of the enemy
		if P_HomingAttack(mobj, target)
			mobj.momx = oldmomx*16/17 + $/17
			mobj.momy = oldmomy*16/17 + $/17
			mobj.momz = oldmomz*16/17 + $/17
		end
		mobj.info.speed = STARTINGSPEED
		
		//Change the targetting effect size
		target.scale = $*2
		if mobj.lockontime
			target.scale = $+mobj.lockontime*$/2
			mobj.lockontime = $ - 1
		end
	elseif mobj.target and mobj.target.player
		mobj.tracer = newRocketLook(mobj.target.player, mobj)
		mobj.lockontime = TICRATE/4
	end
	
end, MT_WHISPER_ROCKET)