//Air spin ability - Spike Saw Blade

sfxinfo[freeslot("sfx_wssaw1")].caption = "Moving saw"
sfxinfo[freeslot("sfx_wssaw2")].caption = "Sliced"
sfxinfo[freeslot("sfx_wssaw3")].caption = "Saw fire"
sfxinfo[freeslot("sfx_wssaw4")].caption = "Saw return"

//The saw
freeslot("SPR_WSAW", "S_WHISPER_SAW", "MT_WHISPER_SAW")
states[S_WHISPER_SAW] = {SPR_WSAW, FF_PAPERSPRITE, -1, nil, 0, 0, S_WHISPER_SAW}
mobjinfo[MT_WHISPER_SAW] = {
	spawnstate = S_WHISPER_SAW,
	deathstate = S_WHISPER_SAW,
	spawnhealth = 1000,
	seesound = sfx_wssaw3,
	attacksound = sfx_wssaw1,
	painsound = sfx_wssaw2,
	deathsound = sfx_wssaw4,
	speed = 48*FRACUNIT,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	damage = 1,
	mass = DMG_SPIKE,
	flags = 0,
}

//Saw thinker
addHook("MobjThinker", function(mobj)
	local mo = mobj.target
	local player = mo and mo.player
	
	//You're super dead
	if mobj.sawdie and not mobj.fuse then return end
	
	//MobjSpawn
	if not mobj.threshold
		mobj.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		mobj.blendmode = AST_ADD
		
		mobj.fuse = TICRATE*4
		mobj.cusval = 5
	elseif mobj.threshold == 1
		local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
		thok.state = S_WHISPER_SHOCK
		
		thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		thok.blendmode = AST_ADD
		thok.color = SKINCOLOR_SUPERSPIKE5
	end
	mobj.threshold = $ + 1
	
	//Player junk
	if player and player.whispersaw == mobj
		player.weapondelay = max($, 2)
		player.drawangle = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y)
		
		//Remove double saw tech
		if not P_IsObjectOnGround(mo) and mobj.health
			player.glidetime = 69
		end
	end
	
	//Our color
	mobj.color = SKINCOLOR_SUPERSPIKE1 + abs( ( (mobj.threshold >> 1) % 9) - 4)
	
	//Extra following objects
	for i = 0, (player and 3 or 2)
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.renderflags = mobj.renderflags
		ghost.blendmode = mobj.blendmode
		ghost.spritexoffset = mobj.spritexoffset
		ghost.spriteyoffset = mobj.spriteyoffset
		
		//Stuff that aren't regular ghosts
		if i
			ghost.fuse = 2
			ghost.type = MT_RAY
			ghost.frame = $ &~ FF_TRANSMASK
			
			//Connector
			if i == 3
				local xdist = mobj.x - (mo.x - P_ReturnThrustX(mo, player.drawangle, mobj.radius))
				local ydist = mobj.y - (mo.y - P_ReturnThrustY(mo, player.drawangle, mobj.radius))
				local hdist = FixedHypot(xdist, ydist)
				local zdist = (mobj.z + mobj.height/2 + FixedMul(mobj.spriteyoffset, mobj.scale)*P_MobjFlip(mobj)) - (mo.z + mo.height/2)
				
				ghost.rollangle = 0
				ghost.spritexoffset = 0
				ghost.spriteyoffset = 0
				ghost.scale = mo.scale
		
				ghost.frame = Z + 1 + ((mobj.threshold >> 1) % 3)
				ghost.spriteyscale = FixedDiv(hdist, ghost.scale)/144
				
				ghost.height = ghost.scale
				P_TeleportMove(ghost, mo.x + xdist/2, mo.y + ydist/2,
				mo.z + mo.height/2 + zdist/2)
				ghost.z = $ + 4*ghost.scale*P_MobjFlip(mo)
				
				ghost.renderflags = $ | RF_NOSPLATBILLBOARD | RF_FLOORSPRITE | RF_SLOPESPLAT
				P_CreateFloorSpriteSlope(ghost)

				ghost.floorspriteslope.o = {x = ghost.x, y = ghost.y, z = ghost.z}
				ghost.angle = player.drawangle
				ghost.floorspriteslope.xydirection = ghost.angle
				
				local zangle = R_PointToAngle2(0,0, hdist, zdist)
				if zangle == ANGLE_90 or zangle == ANGLE_270 then zangle = $ + ANG1 end
				ghost.floorspriteslope.zangle = zangle
			
			//3D saw
			else
				local diff = ANGLE_11hh
				if i & 1 then diff = -$ end
				ghost.angle = mobj.angle + diff
			end
		end
	end
	mobj.flags2 = $ | MF2_DONTDRAW
	
	//Distance variables
	local newx local newy local newz
	local angle = mobj.angle + ANGLE_180
	local thrust = mobj.height*2
	if mo
		newx = mobj.x + P_ReturnThrustX(mo, angle, thrust) - mo.x
		newy = mobj.y + P_ReturnThrustY(mo, angle, thrust) - mo.y
		newz = (mobj.z + mobj.height/2) - (mo.z + mo.height/2)
		thrust = mo.height*2
	end

	//You're dead
	if not mobj.health
		if not mobj.sawdie
			mobj.sawdie = true
			A_Scream(mobj)
			
			mobj.fuse = TICRATE/2
			mobj.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOCLIPTHING
			
			mobj.scalespeed = FixedMul($, mobj.scale/8)
			mobj.destscale = 1
			
			if mo and not (player
			and (WhisperCantMove(player) or player.powers[pw_carry]))
				if not mobj.extravalue1
					mo.momx = mobj.momx
					mo.momy = mobj.momy
				end
				mo.momz = mobj.momz
				P_RailThinker(mo)
			end
			A_ForceStop(mobj)
		end
		
		if mo
			P_TeleportMove(mobj, mobj.x + (mo.x + P_ReturnThrustX(mo, player.drawangle, mo.height) - mobj.x)/mobj.fuse,
			mobj.y + (mo.y + P_ReturnThrustY(mo, player.drawangle, mo.height) - mobj.y)/mobj.fuse,
			mobj.z + ((mo.z + mo.height/2) - (mobj.z + mobj.height/2))/mobj.fuse)
		end
		
		if mobj.fuse == 1
			local thok = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
			thok.state = S_WHISPER_SHOCK
			
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_SUPERSPIKE5
		end
		return
		
	//You should be dead
	elseif player
	and ((not (player.pflags & PF_SPINDOWN or player.cmd.buttons & BT_SPIN) and mobj.threshold > TICRATE/2)
	or WhisperCantMove(player) or player.secondjump or player.powers[pw_carry]
	or FixedHypot(FixedHypot(newx - mo.momx - mobj.momx, newy - mo.momy - mobj.momy),
	(newz - mo.momz - mobj.momz)*2) > mobj.height*4)
		P_KillMobj(mobj)
		return
	end
	
	//Pull around our target
	if mo
		P_TryMove(mo, mo.x + newx/4, mo.y + newy/4, true)
		if FixedHypot(newx, newy) > thrust
			mo.momx = $ + mobj.momx/16
			mo.momy = $ + mobj.momy/16
		end
		
		mo.z = min(max($ + newz/4, mo.floorz), mo.ceilingz)
		if abs(newz) > thrust
			mo.momz = $ + mobj.momz/16
		end
		if not P_IsObjectOnGround(mo)
			mo.momz = $ - P_GetMobjGravity(mo)
		end
		
		if not P_IsObjectOnGround(mo)
			if mo.state == S_PLAY_STND or mo.state == S_PLAY_SKID
				mo.state = S_PLAY_FALL
				player.skidtime = 0
			end
		elseif mo.state == S_PLAY_STND or (mo.state == S_PLAY_WALK
		and (not player or not (player.cmd.forwardmove or player.cmd.sidemove)))
			mo.state = S_PLAY_SKID
			mo.tics = 8
			player.skidtime = mo.tics
		end
		
		mobj.scale = mo.scale
		if player and player.powers[pw_super]
			mobj.scale = $*2
			mobj.fuse = $ + 1
		end
	end
	
	//Speed junk
	P_ButteredSlope(mobj)
	local speed = FixedHypot(mobj.momx, mobj.momy)
	local infospeed = mobj.info.speed
	if mobj.eflags & MFE_UNDERWATER
		infospeed = $/2
	end
	mobj.friction = FRACUNIT
	mobj.rollangle = $ + FixedMul(FixedDiv(speed, mobj.scale), ANG1/2)
	
	//Ground movement
	if P_IsObjectOnGround(mobj) or mobj.extravalue1
	
		//On wall
		if mobj.extravalue1
			P_TryMove(mobj, mobj.x + P_ReturnThrustX(mobj, mobj.angle, mobj.scale),
			mobj.y + P_ReturnThrustY(mobj, mobj.angle, mobj.scale), true)
			
			mobj.extravalue1 = $ - 1
			if not mobj.extravalue1
				mobj.flags = $ &~ MF_NOGRAVITY
			end
			speed = abs(mobj.momz*4)
			
			if not (player and player.powers[pw_super])
				if mobj.eflags & MFE_UNDERWATER
					mobj.fuse = max($ - 1, 1)
				else
					mobj.fuse = max($ - 3, 1)
				end
			end
			P_InstaThrust(mobj, R_PointToAngle2(0,0, mobj.momx, mobj.momy), mobj.radius/2)
		end
		
		if mobj.reactiontime > mobj.radius*3
			mobj.spriteyoffset = $ - FixedDiv(speed, mobj.scale)/12
		else
			mobj.spriteyoffset = $ + FixedDiv(speed, mobj.scale)/12
		end
		
		mobj.reactiontime = $ + speed
		if mobj.cusval >= 5 or mobj.reactiontime > mobj.radius*6
			mobj.reactiontime = 0
			mobj.cusval = 0
			mobj.spriteyoffset = 0
			
			WhisperCircle(mobj, MT_MINECARTSPARK, 6, 4*mobj.scale, 0, mobj.scale/4, false, 0, true, mobj.angle)
			P_SpawnMobjFromMobj(mobj, 0,0,0, MT_DUST)
		
			S_StopSoundByID(mobj, mobj.info.attacksound)
			S_StartSound(mobj, mobj.info.attacksound)
		end
		
		if P_IsObjectOnGround(mobj)
			P_InstaThrust(mobj, mobj.angle, min(speed*9/8 or mobj.scale, FixedMul(infospeed, mobj.scale)))
		else
			mobj.momz = min(speed*9/8 or mobj.scale, FixedMul(infospeed, mobj.scale))/4*P_MobjFlip(mobj)
		end
		
	//Air momentum
	else
		if mobj.momz*P_MobjFlip(mobj) < 0
		and speed > FixedMul(infospeed, mobj.scale*2/3)
			mobj.momz = 0
			mobj.momx = $*23/24
			mobj.momy = $*23/24
		else
			mobj.momz = $ + P_GetMobjGravity(mobj)
		end
		mobj.cusval = $ + 1
	end
end, MT_WHISPER_SAW)

//Die
addHook("MobjFuse", function(mobj)
	if mobj.health
		P_KillMobj(mobj)
	else
		if mobj.target and mobj.target.player
			mobj.target.player.whispersaw = nil
		end
		mobj.state = S_BIGMINE_BLAST5
	end
	return true
end, MT_WHISPER_SAW)

//Run up a wall when we hit one
addHook("MobjMoveBlocked", function(mobj, thing, line)
	if line and (line.flags & ML_NOCLIMB or line.special == 41
	or (line.backsector and line.backsector.ceilingpic == "F_SKY1"
	and line.frontsector and line.frontsector.ceilingpic == "F_SKY1"
	and (mobj.z >= line.frontsector.ceilingheight
	or mobj.z >= line.backsector.ceilingheight)))
		return
	end
	
	if not mobj.extravalue1
		mobj.momz = FixedHypot(mobj.momx, mobj.momy)/4*P_MobjFlip(mobj)
	end
	mobj.extravalue1 = 2
	mobj.flags = $ | MF_NOGRAVITY
	
	return true
end, MT_WHISPER_SAW)

//This is the most useless damage collision in existence
addHook("MobjMoveCollide", function(mo, target)
	if mo and mo.valid and mo.health and target and target.valid
	and (target.flags & MF_SHOOTABLE or target.type == MT_EGGSHIELD)
	and target.health and not (target.flags2 & MF2_FRET)
	and target.z - target.scale <= mo.z + mo.height
	and target.z + target.height + target.scale >= mo.z
	and not (CBW_Battle and CBW_Battle.GuardTrigger(target, mo.target, mo.target, mo.info.damage, mo.info.mass))
		if target.type == MT_EGGSHIELD
			P_KillMobj(target, mo, mo.target)
		else
			P_DamageMobj(target, mo, mo.target, mo.info.damage, mo.info.mass)
		end
	end
end, MT_WHISPER_SAW)

//Sliced enemies
local SLICESPRITES = {
	[MT_ROBOHOOD] = {B,C},
	[MT_GOLDBUZZ] = D,
	[MT_CACOLANTERN] = E,
	[MT_BANPYURA] = F,
	[MT_CRUSHSTACEAN] = G,
	[MT_EGGSHIELD] = {H,I},
	[MT_HANGSTER] = J,
	[MT_JETTBOMBER] = K,
	[MT_JETTGUNNER] = L,
	[MT_JETJAW] = M,
	[MT_MINUS] = N,
	[MT_PENGUINATOR] = O,
	[MT_POPHAT] = P,
	[MT_BLUECRAWLA] = Q,
	[MT_PYREFLY] = R,
	[MT_REDBUZZ] = S,
	[MT_SPINCUSHION] = T,
	[MT_REDCRAWLA] = U,
	[MT_EGGGUARD] = V,
	[MT_SPRINGSHELL] = W,
	[MT_YELLOWSHELL] = X,
	[MT_UNIDUS] = Y,
	[MT_VULTURE] = Z,
}

function A_WhisperSliced(mobj, var1, var2)
	mobj.flags = $ | MF_BOUNCE &~ MF_NOGRAVITY &~ MF_NOCLIP &~ MF_NOCLIPHEIGHT &~ MF_SCENERY
	mobj.frame = mobj.sliceframe or $
	mobj.rollangle = $ - FixedAngle(FixedHypot(R_PointToDist2(0,0, mobj.momx, mobj.momy), mobj.momz))*2
	
	if P_IsObjectOnGround(mobj) and mobj.fuse
		mobj.fuse = 0
		mobj.rollangle = 0
		A_ForceStop(mobj)
		
		mobj.state = S_SONIC3KBOSSEXPLOSION1
		S_StartSound(mobj, sfx_cybdth)
		
	elseif mobj.eflags & MFE_UNDERWATER
		mobj.momz = $ - P_GetMobjGravity(mobj)*5/4
		mobj.momx = $*63/64
		mobj.momy = $*63/64
	end
	
	if not mobj.fuse
		mobj.fuse = TICRATE*4
	elseif ((mobj.frame & FF_TRANSMASK) >> FF_TRANSSHIFT) <= (NUMTRANSMAPS-1) - mobj.fuse / 2
		mobj.tics = -1
	elseif mobj.fuse & 1
		P_SpawnGhostMobj(mobj)
	end
end

freeslot("S_WHISPER_SLICE")
states[S_WHISPER_SLICE] = {SPR_WSAW, A, 1, A_WhisperSliced, 0, 0, S_WHISPER_SLICE}

addHook("MobjDeath", function(mobj, inflictor)
	if inflictor and inflictor.type == MT_WHISPER_SAW
		S_StartSound(inflictor, inflictor.info.painsound)
		
		WhisperCircle(mobj, MT_MINECARTSPARK, 6, 4*mobj.scale, 0, mobj.scale/4, false, 0, true, mobj.angle)
		P_SpawnMobjFromMobj(mobj, 0,0,0, MT_DUST)
		
		local slicesprite = SLICESPRITES[mobj.type]
		if not slicesprite then return end
		
		mobj.flags2 = $ | MF2_DONTDRAW
		for i = 1, 2
			local slice = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_THOK)
			if type(slicesprite) == "table"
				slice.sliceframe = slicesprite[i]
			else
				slice.sliceframe = slicesprite
			end
			
			local thrust = 8*mobj.scale
			if i & 1 then slice.mirrored = true thrust = -$ end
			
			P_InstaThrust(slice, mobj.angle + ANGLE_90, thrust)
			P_SetObjectMomZ(slice, 8*FRACUNIT, false)
			
			slice.state = S_WHISPER_SLICE
		end
		
		if mobj.type == MT_EGGSHIELD
			P_RemoveMobj(mobj)
			return true
		end
	end
end)