if not srb2p return end

freeslot("SPR_WLCR", "sfx_wlbm", "SPR_WLFR", "sfx_gbrk", "sfx_dvst", "sfx_wsbz", "sfx_csaw", "sfx_hexpl", "sfx_hexpl2", "sfx_hfire", "sfx_hchrg", "sfx_vrgmtv")

for i = 1, 9
	freeslot("S_WWALL"..i)
end

for i = 1, 7
	freeslot("S_WMINE"..i)
end

states[S_WWALL1] = {SPR_CARD, J|FF_FULLBRIGHT|TR_TRANS90|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL2}
states[S_WWALL2] = {SPR_CARD, J|FF_FULLBRIGHT|TR_TRANS70|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL3}
states[S_WWALL3] = {SPR_CARD, J|FF_FULLBRIGHT|TR_TRANS50|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL4}
states[S_WWALL4] = {SPR_CARD, J|FF_FULLBRIGHT|TR_TRANS30|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL5}
states[S_WWALL5] = {SPR_CARD, J|FF_FULLBRIGHT|TR_TRANS10|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL5}
states[S_WWALL6] = {SPR_WLFR, A|FF_FULLBRIGHT|TR_TRANS30|FF_PAPERSPRITE, 20, nil, 0, 0, S_WWALL7}
states[S_WWALL7] = {SPR_WLFR, A|FF_FULLBRIGHT|TR_TRANS50|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL8}
states[S_WWALL8] = {SPR_WLFR, A|FF_FULLBRIGHT|TR_TRANS70|FF_PAPERSPRITE, 2, nil, 0, 0, S_WWALL9}
states[S_WWALL9] = {SPR_WLFR, A|FF_FULLBRIGHT|TR_TRANS90|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}

states[S_WMINE1] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS90, 2, nil, 0, 0, S_WMINE2}
states[S_WMINE2] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS60, 2, nil, 0, 0, S_WMINE3}
states[S_WMINE3] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS30, 2, nil, 0, 0, S_WMINE4}
states[S_WMINE4] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS10, 30, nil, 0, 0, S_WMINE5}
states[S_WMINE5] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS30, 2, nil, 0, 0, S_WMINE6}
states[S_WMINE6] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS60, 2, nil, 0, 0, S_WMINE7}
states[S_WMINE7] = {SPR_KRBM, A|FF_FULLBRIGHT|TR_TRANS90, 2, nil, 0, 0, S_NULL}

//Main Definitions

personaList["psyche-whisper"] = {
	-- GENERAL
	name = "Psyche",
	arcana = ARCANA_HIEROPHANT,

	-- STATS (@ lv10)

	sprite = SPR_PSYC,
	anim_idle = 	{SPR_PSYC, A, B, C, B, 8},
	anim_atk = 		{SPR_PSYC, D, E, F, G, H, I, J, K, L, L, L, L, L, 3},
	startframe = 0,

	strength = 6,
	magic = 12,
	endurance = 6,
	luck = 4,
	agility = 9,
	resist = ATK_PSY,
	weak = ATK_BLESS|ATK_FIRE,
	skills = {
				{"psi", 1}, {"wispon amp 1", 1}, {"snap", 5},
				{"wispon support 1", 9}, {"mapsi", 13}, {"assault shot", 16, "snap"},
				{"psio", 19, "psi"}, {"wispon passive 1", 22}, {"wispon ability 1", 26},
				{"psy boost", 30}, {"wispon amp 2", 33, "wispon amp 1"}, 
				{"mapsio", 37, "mapsi"}, {"heavy shot", 41, "assault shot"},
				{"wispon passive 2", 45, "wispon passive 1"},
				{"wispon support aoe", 48, "wispon support 1"}, {"wispon support strong", 51, "psy boost"},
				{"psiodyne", 55, "psio"}, {"wispon ability 2", 58, "wispon ability 1"},
				{"wispon passive 3", 61, "wispon passive 2"}, {"mapsiodyne", 66, "mapsio"},
				{"wispon amp 3", 71, "wispon amp 2"}, {"psycho force", 77, "psiodyne"}
			},
}


charStats["whisper"] = {
	name = "Whisper",			-- This is only for bots / enemies
	basehp = 40,			-- base HP for level 1
	basesp = 60,
	persona = "psyche-whisper",
	melee_natk = "whisper_atkl",	-- normal melee attack

	supercolor_start = SKINCOLOR_SUPERTAN1,

	wep = "whisper_01",
	weptype = WPT_LIMITERS,

	atk = 20,
	acc = 100,
	crit = 2,

	-- ANIMS
	-- Anims are built like this:
	-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
	anim_stand_bored =	{SPR_PLAY, A, B, C, D, E, F, G, H, 8, "SPR2_WAIT"},	-- standing (rare anim)
	anim_guard = 		{SPR_PLAY, B, 1, "SPR2_WALK"},		-- guarding
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
	anim_run =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_RUN_"},
	anim_atk =			{SPR_PLAY, A, 1, "SPR2_FIRE"},	-- attacking
	anim_aoa_end =		{SPR_PLAY, A, B, 4, "SPR2_FALL"},	-- jumping out of all-out attack
	anim_hurt =			{SPR_PLAY, A, B, A, B, A, B, 4, "SPR2_SKID"},		-- taking damage
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_CNT1"},		-- is down
	anim_getup =		{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},		-- gets up from down
	anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
	anim_revive =       {SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},        -- gets revived
	anim_evoker =		{SPR_PLAY, A, 1, "SPR2_FIRE"},	-- uses evoker
	anim_evoker_shoot = {SPR_PLAY, A, 1, "SPR2_FIRE"},
	anim_special1 =     {SPR_PLAY, A, 1, "SPR2_SPNG"},
	anim_special2 =     {SPR_PLAY, A, B, 4, "SPR2_SPIN"},
	anim_special3 =  	{SPR_PLAY, A, B, 4, "SPR2_GLID"},
	anim_special4 =		{SPR_PLAY, A, B, C, D, 2, "SPR2_TRNS"},
	anim_special5 = 	{SPR_PLAY, A, B, 4, "SPR2_BNCE"},
	anim_special6 = 	{SPR_PLAY, A, A, B, C, D, 2, "SPR2_MLEE"},
	anim_special7 = 	{SPR_PLAY, C, D, 2, "SPR2_MLEE"},


	icon = "ICO_WHSP",	-- icon for net select and other menus
	hudbust = "WHSP_H",			-- patch to draw on the stat hud
	hudbustlayer = "",		-- transparent patch to draw for status conditions
	hudaoa = "H_WHSPAOA",	-- patch for all out attack hud
	hudcutin = "WHSP_A",	-- cut in
	hudspr = "WHSP",	-- sprite prefix since hud can't retrieve it. yikes
	aoa_quote = "...",

	tip = "A frail fighter with a variable moveset. While her own ability is limited to just Psychic and Pierce attacks, her Variable Wispon allows her to change her skills on the fly, as well as augmenting her own abilities using her crew of Wisps.",
}

weaponsList["whisper_01"] = {
	name = "Hyper-Go-On Resistor",
	type = WPT_LIMITERS,
	atk = 300,
	desc = "A customization to the Wispon, allowing it to effectively harness\nthe wisps' powers without damaging the weapon.",
	rarity = 1,
	slot = "freifi aura",
}

//Custom Attacks

//Placeholder Attacks - Serve no functional use other than to provide a description.

attackDefs["wispon amp 1"] = {
	name = "Wispon Amplifier",
	type = ATK_ALMIGHTY,
	costtype = CST_SP,
	cost = 0,
	desc = "Use your equipped wisp's power\nto unleash a special attack!\nWisp tires after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon amp 2"] = {
	name = "Wispon Amplifier Mk.II",
	type = ATK_ALMIGHTY,
	costtype = CST_SP,
	cost = 0,
	desc = "The more energy efficient framework\nallows the Wispon to exert even \nmore power! Wisp tires after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon amp 3"] = {
	name = "Wispon Amplifier Mk.III",
	type = ATK_ALMIGHTY,
	costtype = CST_SP,
	cost = 0,
	desc = "Smithy's finest work. Allows the Wispon\n to draw out the equipped Wisp's full\npower! Wisp tires after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon support 1"] = {
	name = "Field Support",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 0,
	desc = "Uses the equipped Wisp's energy\nto cast an assortment of\nsupport skills.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon support aoe"] = {
	name = "Field Support B",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 0,
	desc = "Uses the equipped Wisp's energy\nto cast an assortment of\nAoE support skills.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon support strong"] = {
	name = "Field Support R",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 0,
	desc = "Uses the equipped Wisp's energy\ncast an assortment of\nstrong support skills.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon ability 1"] = {
	name = "Color Guard",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 0,
	desc = "Uses the equipped Wisp's\nabilities to give the user\nan advantage.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon ability 2"] = {
	name = "Color Guard II",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 0,
	desc = "Uses the equipped Wisp's full\nabilities to give the user\na strong advantage.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon passive 1"] = {
	name = "Camouflage",
	type = ATK_PASSIVE,
	costtype = CST_SP,
	cost = 0,
	desc = "Applies the equipped Wisp's\nattributes to alter your own.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon passive 2"] = {
	name = "Adaptability",
	type = ATK_PASSIVE,
	costtype = CST_SP,
	cost = 0,
	desc = "Applies the equipped Wisp's\nattributes to alter your own.\nEffect is amplified.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

attackDefs["wispon passive 3"] = {
	name = "Full Cross",
	type = ATK_PASSIVE,
	costtype = CST_SP,
	cost = 0,
	desc = "Applies the equipped Wisp's\nattributes to alter your own.\nEffect is greatly amplified.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		return true
	end,
}

//Basic Attacks

attackDefs["whisper_atkl"] = {
	name = "Cyan Laser",
	type = ATK_PIERCE,
	power = 35,
	accuracy = 95,
	critical = 7,
	target = TGT_ENEMY,
	cost = CST_HP,
	cost = 0,
	desc = "Fire a laser at the target.",
	anim_norepel = true,
	physical = true,
	anim = 	function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
		elseif timer == 10
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
			local  speed = 35*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_wschg1)
		elseif timer == 11
			damageObject(target)
			playSound(mo.battlen, sfx_wslsr3)
			P_KillMobj(mo.th)
		elseif timer == 40
			mo.th = nil
			return true
		end
	end,
}

attackDefs["whisper_atkr"] = {
	name = "Orange Rocket",
	type = ATK_PIERCE,
	power = 50,
	accuracy = 95,
	critical = 3,
	target = TGT_ENEMY,
	cost = CST_HP,
	cost = 0,
	desc = "Fire a rocket at the target.",
	anim_norepel = true,
	physical = true,
	anim = 	function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
		elseif timer == 10
			playSound(mo.battlen, sfx_wschg2)
			local thok = P_SpawnMobj(mo.x + P_ReturnThrustX(mo, mo.angle, mo.radius*2),
			mo.y + P_ReturnThrustY(mo, mo.angle, mo.radius*2), mo.z + mo.height*2/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_RUST
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = mo.scale/2
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
		elseif timer == 20
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_ROCKET)
			local  speed = FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_wsrck4)
		elseif timer == 55
			playSound(mo.battlen, sfx_wsrck3)
			P_KillMobj(mo.th)
		elseif timer == 65
			damageObject(target)
		elseif timer == 85
			mo.th = nil
			return true
		end
	end,
}

attackDefs["whisper_atkh"] = {
	name = "Green Plasma",
	type = ATK_PSY,
	power = 50,
	accuracy = 95,
	target = TGT_ENEMY,
	cost = CST_SP,
	cost = 0,
	desc = "Fire a ball of plasma at the target.",
	anim_norepel = true,
	physical = true,
	anim = 	function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker)
		elseif timer == 10
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + mo.height, MT_THOK)
			mo.th.sprite = SPR_WSPT
			mo.th.frame = A|FF_FULLBRIGHT|TR_TRANS20
			mo.th.scale = 3*FRACUNIT/4
			mo.th.tics = 41
			mo.th.flags = MF_NOGRAVITY
			mo.th.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local speed = R_PointToDist2(mo.x, mo.y, target.x, target.y)/30
			P_InstaThrust(mo.th, mo.th.angle, speed)
			playSound(mo.battlen, sfx_hfire)
		elseif timer == 40
			local thok = P_SpawnMobjFromMobj(mo.th, 0,0,
			0, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.sprite = SPR_NTHK
			thok.frame = B|TR_TRANS20
			thok.momz = FRACUNIT*16
			thok.scalespeed = FixedMul($, FRACUNIT*4)
			thok.destscale = INT32_MAX
			
			playSound(mo.battlen, sfx_hexpl)
			P_KillMobj(mo.th)
			damageObject(target)
		elseif timer >= 44 and timer <= 52 and timer%4 == 0
			local thok = P_SpawnMobjFromMobj(target, 0,0,
			target.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			thok.scale = 1
			thok.angle = cam.angle + ANGLE_90
			thok.momz = FRACUNIT*4
			thok.scalespeed = FixedMul($, FRACUNIT)
			thok.destscale = INT32_MAX
		end
		
		if mo.th and mo.th.valid
			if timer%4 == 0
				local thok = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				thok.sprite = SPR_NTHK
				thok.frame = A|FF_FULLBRIGHT|TR_TRANS60
				thok.color = SKINCOLOR_SUPERHOVER3
				thok.scale = FRACUNIT/4
				thok.tics = 5
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/32
				thok.flags = MF_NOGRAVITY
				thok.momx = P_RandomRange(-10,10)*FRACUNIT
				thok.momy = P_RandomRange(-10,10)*FRACUNIT
				thok.momz = P_RandomRange(-10,10)*FRACUNIT
			end
			
			if timer%2 == 0
				local l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KLIT1 + P_RandomRange(0, 5)
				l.angle = P_RandomRange(0, 359)*ANG1
				l.fuse = P_RandomRange(10, 40)
				l.scale = FRACUNIT/8
				l.color = SKINCOLOR_SUPERHOVER3
				l.rollangle = P_RandomRange(1, 359)*ANG1

				-- alsos spawn a spark...
				l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KSPK1
				l.tics = P_RandomRange(2, 10)
				l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				l.destscale = 1
				l.scale = FRACUNIT/4
				l.scalespeed = l.scale/24
				l.color = SKINCOLOR_SUPERHOVER3
			end
			
			mo.th.color = SKINCOLOR_SUPERHOVER1 + abs((timer)%9 - 4)
		end
		
		if timer == 80
			mo.th = nil
			return true
		end
	end,
}

attackDefs["whisper_atkc"] = {
	name = "Blue Hammer",
	type = ATK_STRIKE,
	power = 55,
	accuracy = 85,
	critical = 6,
	target = TGT_ENEMY,
	cost = CST_HP,
	cost = 0,
	desc = "Hit the enemy with a hammer.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	anim = 	function(mo, targets, hittargets, timer)
		local target = targets[1]
		if timer == 1
			ANIM_set(mo, mo.anim_special1, true)	-- hammer hit prep

			-- fake A_LobShot:
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / TICRATE

			mo.momx = FixedMul(horizontal, cos(mo.angle))
			mo.momy = FixedMul(horizontal, sin(mo.angle))
			local vertical = FixedMul(3*(gravity*TICRATE)/4, mo.scale)
			mo.momz = vertical
			playSound(mo.battlen, sfx_s220)


			-- move camera to an interresting spot

			local an = target.angle + 45*ANG1

			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
			--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)

		elseif timer == TICRATE - 7
			ANIM_set(mo, mo.anim_special6)

		elseif timer == TICRATE
			local speed = max(FixedHypot(mo.momx, mo.momy)*2, 16*mo.scale)
			mo.momx = 0
			mo.momy = 0
			mo.momz = -speed*P_MobjFlip(mo)*2

			playSound(mo.battlen, sfx_wscub3)
			
			mo.whisperhammer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
			mo.whisperhammer.target = mo
			
			mo.whisperhammer.state = S_INVISIBLE
			mo.whisperhammer.sprite = SPR_WSHM
			mo.whisperhammer.tics = 2
			
			mo.whisperhammer.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			mo.whisperhammer.blendmode = AST_ADD
			
			A_CapeChase(mo.whisperhammer)

		elseif timer == TICRATE*2
			target.done = nil
			return true
		end
		
		if mo.whisperhammer and mo.whisperhammer.valid
			mo.whisperhammer.frame = mo.frame
			
			if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
				mo.whisperhammer.frame = mo.frame + 3
			end
			mo.whisperhammer.tics = $ + 1
			
			local ghost = P_SpawnGhostMobj(mo.whisperhammer)
			ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			ghost.blendmode = AST_ADD
			
			ghost.scalespeed = FixedMul($, ghost.scale)
			ghost.destscale = INT32_MAX
			
			ghost.flags2 = $ | MF2_BOSSNOTRAP
			ghost.frame = $ &~ FF_TRANSMASK
		end
		
		if timer >= TICRATE and P_IsObjectOnGround(mo) and not target.done
			target.done = true
			playSound(mo.battlen, sfx_wscub2)
			
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_SLATE
				dust.scale = FRACUNIT*2
			end
			
			//Circle/Cube effect
			local dust = P_SpawnMobjFromMobj(mo,
			P_ReturnThrustX(nil, mo.angle, mo.height),
			P_ReturnThrustY(nil, mo.angle, mo.height),
			0, MT_DUST)
			
			dust.state = S_INVISIBLE
			dust.tics = 1
			
			dust.radius = mo.radius
			dust.height = mo.radius
			dust.flags = $ &~ MF_NOCLIPHEIGHT
			dust.z = $
			
			WhisperCircle(dust, MT_GHOST, 16, mo.scale, 0,
			mo.scale/2, 1, SKINCOLOR_BLUE)
			
			WhisperCircle(dust, MT_GHOST, 16, 16*mo.scale, 0,
			mo.scale/4, 1, SKINCOLOR_BLUE)
			
			for i = 1, 2
				local thok = P_SpawnMobj(dust.x, dust.y, dust.z, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_COBALT
				
				thok.scale = dust.scale*i
				thok.height = thok.scale
				thok.z = $ + 4*thok.scale*P_MobjFlip(mo)
				thok.state = S_WHISPER_CIRCLE
				thok.scalespeed = FixedMul($, thok.scale*2)
				thok.destscale = INT32_MAX
			end
			
			localquake(mo.battlen, FRACUNIT*30, 8)
			damageObject(hittargets[1])
		end
	end,
}

attackDefs["whisper_atks"] = {
	name = "Pink Saw",
	type = ATK_SLASH,
	power = 40,
	accuracy = 95,
	critical = 4,
	target = TGT_ENEMY,
	cost = CST_HP,
	cost = 0,
	desc = "Fire a sawblade at the target.",
	anim_norepel = true,
	physical = true,
	anim = 	function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
		elseif timer == 10
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_THOK)
			local  speed = 50*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.state = S_WHISPER_SAW
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
			mo.th.frame = $|FF_FULLBRIGHT
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.fuse = 60
			mo.th.angle = ang
			playSound(mo.battlen, sfx_wssaw3)
		elseif timer == 20
			damageObject(target)
			playSound(mo.battlen, sfx_wssaw2)
		elseif timer == 40
			mo.th = nil
			return true
		end
		
		if mo.th and mo.th.valid
			for i = 0, 3
				local ghost = P_SpawnGhostMobj(mo.th)
				ghost.renderflags = mo.th.renderflags
				ghost.blendmode = mo.th.blendmode
				ghost.spritexoffset = mo.th.spritexoffset
				ghost.spriteyoffset = mo.th.spriteyoffset
				
				if i
					ghost.fuse = 2
					ghost.type = MT_RAY
					ghost.frame = $ &~ FF_TRANSMASK
				end
			end
			
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
		end
	end,
}

// Laser Skills

attackDefs["tracer round 1"] = {
	name = "Tracer Round",
	type = ATK_ELEC,
	power = 60,
	accuracy = 100,
	costtype = CST_SP,
	critical = 5,
	cost = 10,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Cyan is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Light Elec dmg to one enemy.\nAverage critical rate.\nTires Cyan after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer > 30 and timer < 80
			if timer <= 70
				local gunx = mo.x + 20*cos(mo.angle)
				local guny = mo.y + 20*sin(mo.angle)
				if not mo.charge or not mo.charge.valid
					local charge = P_SpawnMobj(gunx, guny, mo.z + mo.height*2, MT_THOK)
					charge.sprite = SPR_WSPT
					charge.tics = 50
					charge.frame = A|FF_FULLBRIGHT
					charge.scale = 1
					charge.destscale = 3*FRACUNIT/2
					charge.scalespeed = FRACUNIT/48
					mo.charge = charge
					playSound(mo.battlen, sfx_zio4)
				end
				
				local spark = P_SpawnMobj(gunx + P_RandomRange(20, 40)*(P_RandomRange(0,1) and -1 or 1)*FRACUNIT,
					guny + P_RandomRange(20, 40)*(P_RandomRange(0,1) and -1 or 1)*FRACUNIT,
					mo.z + mo.height + P_RandomRange(20, 40)*(P_RandomRange(0,1) and -1 or 1)*FRACUNIT, MT_THOK)
				spark.sprite = SPR_NTHK
				spark.frame = A|FF_FULLBRIGHT
				spark.tics = 5
				spark.color = SKINCOLOR_SUPERLASER1 + abs((timer)%8 - 4)
				spark.scale = FRACUNIT/4
				spark.momx = (gunx - spark.x)/8
				spark.momy = (guny - spark.y)/8
				spark.momz = (mo.z + mo.height - spark.z)/8
				
				mo.charge.color = SKINCOLOR_SUPERLASER1 + abs((timer)%8 - 4)
			end
			
			if not (leveltime%2)
				local elec = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
				elec.sprite = SPR_DELK
				elec.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				elec.destscale = FRACUNIT*4
				elec.scalespeed = FRACUNIT/4
				elec.tics = TICRATE/8
				elec.color = SKINCOLOR_CYAN
			end
		elseif timer == 80
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
			local  speed = 20*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.scale = 3*FRACUNIT/2
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_s3k54)
			localquake(mo.battlen, 4*FRACUNIT, 10)
		elseif timer == 85
			damageObject(target)
		end
		
		if timer == 120
			playSound(mo.battlen, sfx_wslsr3)
			P_KillMobj(mo.th)
			mo.th = nil
			mo.charge = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
		
		if mo.th and mo.th.valid
			local l = mo.th
			local smoke = P_SpawnMobj(l.x, l.y, l.z, MT_SMOLDERING)
			smoke.fuse = 40
		end
	end,
}

attackDefs["tracer round 2"] = {
	name = "Ion Beam",
	type = ATK_ELEC,
	power = 140,
	accuracy = 110,
	costtype = CST_SP,
	critical = 10,
	cost = 20,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Cyan is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Elec dmg to one enemy.\nHigh critical rate.\nTires Cyan after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 10
			ANIM_set(mo, mo.anim_getup, true)
			CAM_goto(cam, cam.x - 100*cos(cam.angle), cam.y - 100*cos(cam.angle), cam.z, 10*FRACUNIT) -- camera goes woosh
		elseif timer == 20
			local crystal = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			crystal.sprite = SPR_WLCR
			crystal.frame = A|FF_FULLBRIGHT
			crystal.flags = MF_NOCLIP
			crystal.tics = 42
			crystal.rollfactor = 60
			crystal.momx = (target.x - crystal.x)/42
			crystal.momy = (target.y - crystal.y)/42
			crystal.momz = 20*FRACUNIT
			mo.crystal = crystal
			playSound(mo.battlen, sfx_thok)
			
			ANIM_set(mo, mo.anim_evoker)
		elseif timer > 30 and timer < 60
			if timer == 31
				playSound(mo.battlen, sfx_jump)
			end
			ANIM_set(mo, mo.anim_special1)
			mo.momz = FRACUNIT*15
			local ghost = P_SpawnGhostMobj(mo)
			ghost.tics = 2
			cam.z = $ + FRACUNIT*10
		elseif timer == 60
			mo.momz = $/4
			ANIM_set(mo, mo.anim_special5)
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
			local  speed = 20*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, mo.crystal.x, mo.crystal.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.scale = 3*FRACUNIT/2
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_s3k54)
		elseif timer == 61
			mo.th.momx = (target.x - mo.th.x)/32
			mo.th.momy = (target.y - mo.th.y)/32
			mo.th.momz = -FRACUNIT*19
			mo.th.scale = $*4/3
			playSound(mo.battlen, sfx_shattr)
		elseif timer == 63
			ANIM_set(mo, mo.anim_aoa_end)
			local z1 = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.floorz, MT_DUMMY)
			z1.state, z1.scale, z1.color = S_LZIO11, FRACUNIT*6/4, SKINCOLOR_CYAN
			playSound(mo.battlen, sfx_wslsr3)
			P_KillMobj(mo.th)
			localquake(mo.battlen, 6*FRACUNIT, 10)
			damageObject(target)
		elseif timer > 80 and timer < 110
			cam.z = $ - 10*FRACUNIT
		elseif timer == 110
			CAM_goto(cam, cam.x + 100*cos(cam.angle), cam.y + 100*cos(cam.angle), cam.z, 10*FRACUNIT) -- camera goes woosh
		end
		
		if timer >= 20 and timer <= 50 and timer%2 == 0
			local elec = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
			elec.sprite = SPR_DELK
			elec.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			elec.destscale = FRACUNIT*4
			elec.scalespeed = FRACUNIT/4
			elec.tics = TICRATE/8
			elec.color = SKINCOLOR_CYAN
		end
		
		if timer >= 63 and P_IsObjectOnGround(mo)
			ANIM_set(mo, mo.anim_stand)
		end
		
		if mo.crystal and mo.crystal.valid
			local v = mo.crystal
			local ghost = P_SpawnGhostMobj(v)
			ghost.tics = 4
			v.rollangle = $+(ANG1*v.rollfactor)
		end
		
		if timer == 140
			mo.th = nil
			mo.crystal = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
	end,
}

attackDefs["tracer round 3"] = {
	name = "Gamma Ray",
	type = ATK_ELEC,
	power = 350,
	accuracy = 120,
	costtype = CST_SP,
	critical = 20,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Cyan is too tired to use this!")
						return true
					end
				end,
	cost = 40,
	norepel = true,
	desc = "Heavy Elec dmg to one enemy.\nVery high critical rate.\nTires Cyan after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 1 and mo.name == "\x56\x65\x72\x67\x69\x6C"
			playSound(mo.battlen, sfx_vrgmtv)
		elseif timer == 10
			mo.lasers = {}
			ANIM_set(mo, mo.anim_special3)
		elseif timer > 10 and timer <= 40
			local laser = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)*2, MT_WHISPER_LASER)
			local speed = 2*FRACUNIT
			local ang = P_RandomRange(1, 359)*ANG1
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			laser.scale = FRACUNIT/4
			laser.momx = momx
			laser.momy = momy
			laser.angle = ang
			laser.tics = 10
			laser.momz = 5*FRACUNIT
			if timer%4== 0
				playSound(mo.battlen, sfx_wslsr1)
			end
		elseif timer == 80
			cam.oldx = cam.x
			cam.oldy = cam.y
			cam.oldang = cam.angle
			CAM_goto(cam, target.x + 300*cos(target.angle), target.y + 300*sin(target.angle), cam.z, 40*FRACUNIT)
			CAM_angle(cam, target.angle + ANGLE_180, ANG2)
		elseif timer > 100 and timer < 140
			local ang = target.angle + (P_RandomRange(0,1) and ANG30 or ANG1*255) + P_RandomRange(0,75)*ANG1
			local x = target.x + 420*cos(ang)
			local y = target.y + 420*sin(ang)
			local z = target.z + target.height*2 + P_RandomRange(-25, 25)*FRACUNIT
			local laser = P_SpawnMobj(x, y, z, MT_WHISPER_LASER)
			local speed = 5*FRACUNIT
			ang = R_PointToAngle2(laser.x, laser.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			laser.momx = momx
			laser.momy = momy
			laser.angle = ang
			laser.timer = 7
			laser.scale = FRACUNIT/4
			mo.lasers[#mo.lasers+1] = laser
			
			if timer > 104
				local dir = (timer%2 and 1 or -1)
				local x = target.x + 4*FRACUNIT*dir
				local y = target.y + 4*FRACUNIT*dir
				P_TeleportMove(target, x, y, target.z)
				local elec = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_DUMMY)
				elec.sprite = SPR_DELK
				elec.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				elec.destscale = FRACUNIT*4
				elec.scalespeed = FRACUNIT/4
				elec.tics = TICRATE/8
				elec.color = SKINCOLOR_CYAN
			end
		elseif timer == 140
			CAM_goto(cam, cam.oldx, cam.oldy, cam.z, 40*FRACUNIT)
			CAM_angle(cam, cam.oldang, ANG2)
		end
		
		if timer == 40
			ANIM_set(mo, mo.anim_special2)
			playSound(mo.battlen, sfx_whrl)
			playSound(mo.battlen, sfx_zio4)
			localquake(mo.battlen, FRACUNIT, 80)
		elseif timer > 40 and timer < 180
			local elec = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
			elec.sprite = SPR_DELK
			elec.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			elec.destscale = FRACUNIT*4
			elec.scalespeed = FRACUNIT/4
			elec.tics = TICRATE/8
			elec.color = SKINCOLOR_CYAN
			if timer%20 == 0
				playSound(mo.battlen, sfx_zio1)
				local l = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				l.state = S_KLIT1 + P_RandomRange(0, 5)
				l.angle = P_RandomRange(0, 359)*ANG1
				l.fuse = P_RandomRange(10, 40)
				l.scale = mo.scale
				l.color = SKINCOLOR_CYAN

				l = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				l.state = S_KSPK1
				l.tics = P_RandomRange(2, 10)
				l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				l.destscale = 1
				l.scale = FRACUNIT
				l.scalespeed = l.scale/24
				l.color = SKINCOLOR_CYAN
			end
			
			if timer%2 == 0
				local hang = cam.angle + ANGLE_90
				local ang = timer*ANG10
				local x = mo.x + 10*cos(mo.angle) + 30*FixedMul(cos(hang), cos(ang))
				local y = mo.y + 10*sin(mo.angle) + 30*FixedMul(sin(hang), sin(ang))
				local z = mo.z + mo.height
				for i = 1, 2
					local orb = P_SpawnMobj(x, y, z + 20*FixedMul(sin(ANGLE_270), sin((i - 1) and ang or (ang+ANGLE_180))), MT_THOK)
					orb.tics = 1
					orb.sprite = SPR_NTHK
					orb.frame = A|FF_FULLBRIGHT
					orb.color = SKINCOLOR_SUPERLASER1 + abs((timer/2)%8 - 4)
					orb.scale = (timer-40)*FRACUNIT/80
				end
			end
		elseif timer == 180
			localquake(mo.battlen, 7*FRACUNIT, 60)
			playSound(mo.battlen, sfx_wlbm)
			local boom = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_THOK)
			boom.color = SKINCOLOR_CYAN
			boom.state = S_BIGMINE_BLAST5
			boom.scale = FRACUNIT*3
			for i = 1, #server.playerlist[mo.battlen]
				if server.playerlist[mo.battlen][i]
					P_FlashPal(server.playerlist[mo.battlen][i], 1, 5)
				end
			end
			damageObject(target)
		elseif timer > 180 and timer <= 240 and timer%2 == 0
			local orb = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_THOK)
			orb.sprite = SPR_WSPT
			orb.frame = A|FF_FULLBRIGHT|TR_TRANS50
			orb.color = SKINCOLOR_SUPERLASER1 + abs((timer/2)%8 - 4)
			orb.scale = FRACUNIT*3
			orb.angle = R_PointToAngle2(orb.x, orb.y, target.x, target.y)
			orb.tics = 30
			P_InstaThrust(orb, orb.angle, FRACUNIT*30)
			for i = 1,2
				local hang = cam.angle + ANGLE_90
				local ang = timer*ANG10
				local x = mo.x + 150*FixedMul(cos(hang), cos(ang))
				local y = mo.y + 150*FixedMul(sin(hang), sin(ang))
				local z = mo.z + mo.height
				local orb = P_SpawnMobj(x, y, z + 150*FixedMul(sin(ANGLE_270), sin((i - 1) and ang or (ang+ANGLE_180))), MT_THOK)
				orb.sprite = SPR_NTHK
				orb.frame = A|FF_FULLBRIGHT|TR_TRANS30
				orb.color = SKINCOLOR_SUPERLASER1 + abs((timer)%8 - 4)
				orb.scale = FRACUNIT
				orb.angle = R_PointToAngle2(orb.x, orb.y, target.x, target.y)
				orb.tics = 30
				P_InstaThrust(orb, orb.angle, 30*FRACUNIT)
			end
			
			local elec = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
			elec.sprite = SPR_DELK
			elec.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			elec.destscale = FRACUNIT*4
			elec.scalespeed = FRACUNIT/4
			elec.tics = TICRATE/8
			elec.color = SKINCOLOR_CYAN
			P_InstaThrust(mo, mo.angle + ANGLE_180, 2*FRACUNIT)
		end
		
		if mo.lasers
			for i = 1, #mo.lasers
				local v = mo.lasers[i]
				if not v or not v.valid continue end
				
				if v.timer
					v.timer = $ - 1
					if v.timer <= 0
						P_KillMobj(v)
					end
				end
			end
		end
		
		if timer == 260
			mo.lasers = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
	end,
}

attackDefs["w-tankbreaker"] = {
	name = "Tankbreaker",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 24,
	desc = "Lower all of an enemy's \nresistances for 3 turns.",
	target = TGT_ENEMY,
	debuff = true,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local bioelements
		local elements = {
		{ATK_SLASH, SKINCOLOR_ORANGE},
		{ATK_STRIKE, SKINCOLOR_ORANGE},
		{ATK_PIERCE, SKINCOLOR_ORANGE},
		{ATK_FIRE, SKINCOLOR_RED},
		{ATK_ICE, SKINCOLOR_CYAN},
		{ATK_WIND, SKINCOLOR_GREEN},
		{ATK_ELEC, SKINCOLOR_YELLOW},
		{ATK_NUCLEAR, SKINCOLOR_TEAL},
		{ATK_PSY, SKINCOLOR_ROSY},
		{ATK_BLESS, SKINCOLOR_TAN},
		{ATK_CURSE, SKINCOLOR_CRIMSON}}
		if bionis
			bioelements = {
			{ATK_WATER, SKINCOLOR_AQUA},
			{ATK_EARTH, SKINCOLOR_BROWN},
			{ATK_FOREST, SKINCOLOR_EMERALD},
			{ATK_METAL, SKINCOLOR_SILVER},
			{ATK_POISON, SKINCOLOR_NEON},
			{ATK_GRAVITY, SKINCOLOR_PASTEL}}
		end
		
		
		if timer == 1
			local types = {target.resist, target.block, target.drain, target.repel}
			
			target.walls = {}
			target.barriers = {}
			for i = 1, #elements
				for j = 1, #types
					if (types[j] and types[j] & elements[i][1])
						target.walls[#target.walls+1] = elements[i][2]
						buffStat(target, elements[i][1], -1)
						BTL_logMessage(targets[1].battlen, "Scanning...") // yeah, it's a cheap cover-up but it works
					end
				end
			end
			
			if bionis
				for i = 1, #bioelements
					for j = 1, #types
						if (types[j] and types[j] & bioelements[i][1])
							target.walls[#target.walls+1] = bioelements[i][2]
							buffStat(target, bioelements[i][1], -1)
							BTL_logMessage(targets[1].battlen, "Scanning...")
						end
					end
				end
			end
			
			if not target.walls[1]
				target.walls[1] = SKINCOLOR_WHITE
			end
		elseif timer >= 20 and timer <= (15 + 5*#target.walls) and timer %5 == 0
			if not mo.wall
				mo.wall = 1
			end

			local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
			
			local wall = P_SpawnMobj(target.x + 20*mo.wall*cos(ang), target.y + 20*mo.wall*sin(ang), mo.z, MT_THOK)
			wall.state = S_WWALL1
			wall.colorized = true
			wall.angle = ang + ANGLE_90
			wall.color = target.walls[mo.wall]
			target.barriers[#target.barriers+1] = wall
			mo.wall = $ + 1
		elseif timer == (60 + 5*#target.walls)
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
			local  speed = 20*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_wslsr1)
			localquake(mo.battlen, 4*FRACUNIT, 10)
		elseif timer == (62 + 5*#target.walls)
			local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y) - ANG1*24
			
			for r = 1, #target.walls
				for i = 1, 4
					local tiles = ((i == 1 or i == 4) and 8 or 6)
					for j = 1, tiles
						local tile = P_SpawnMobj(target.x + 20*r*cos(ang + ANG1*12*i), target.y + 20*r*sin(ang + ANG1*12*i), target.z + 24*FRACUNIT*(j-1), MT_THOK)
						tile.state = S_WWALL6
						tile.colorized = true
						tile.flags = MF_NOBLOCKMAP
						tile.color = target.walls[r]
						tile.momx = P_RandomRange(-30, 30)*FRACUNIT
						tile.momy = P_RandomRange(-30, 30)*FRACUNIT
						tile.momz = P_RandomRange(0, 15)*FRACUNIT
						tile.angle = ang + ANG1*24 + ANGLE_90
					end
				end
			end
			
			playSound(mo.battlen, sfx_gbrk)
			target.resdown = 3
			BTL_logMessage(targets[1].battlen, "Enemy resistances down!")
			
			for i = 1, #target.barriers
				P_KillMobj(target.barriers[i])
			end
		elseif timer == (64 + 5*#target.walls)
			P_KillMobj(mo.th)
		end
		
		if timer == (90 + 5*#target.walls)
			mo.th = nil
			mo.wall = nil
			target.barriers = nil
			target.walls = nil
			return true
		end
	end,
}

attackDefs["w-devastate"] = {
	name = "Devastate",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 48,
	desc = "Makes an enemy weak to every\naffinity for 2 turns.",
	target = TGT_ENEMY,
	debuff = true,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local bioelements
		local elements = {
		{ATK_SLASH, SKINCOLOR_ORANGE},
		{ATK_STRIKE, SKINCOLOR_ORANGE},
		{ATK_PIERCE, SKINCOLOR_ORANGE},
		{ATK_FIRE, SKINCOLOR_RED},
		{ATK_ICE, SKINCOLOR_CYAN},
		{ATK_WIND, SKINCOLOR_GREEN},
		{ATK_ELEC, SKINCOLOR_YELLOW},
		{ATK_NUCLEAR, SKINCOLOR_TEAL},
		{ATK_PSY, SKINCOLOR_ROSY},
		{ATK_BLESS, SKINCOLOR_TAN},
		{ATK_CURSE, SKINCOLOR_CRIMSON}}
		if bionis
			bioelements = {
			{ATK_WATER, SKINCOLOR_AQUA},
			{ATK_EARTH, SKINCOLOR_BROWN},
			{ATK_FOREST, SKINCOLOR_EMERALD},
			{ATK_METAL, SKINCOLOR_SILVER},
			{ATK_POISON, SKINCOLOR_NEON},
			{ATK_GRAVITY, SKINCOLOR_PASTEL}}
		end
		
		
		if timer == 1
			local types = {target.resist, target.block, target.drain, target.repel}
			
			if not mo.devastated
				target.oldweak = target.weak
			end
			target.walls = {}
			target.barriers = {}
			for i = 1, #elements
				for j = 1, #types
					if (types[j] and types[j] & elements[i][1])
						target.walls[#target.walls+1] = elements[i][2]
						buffStat(target, elements[i][1], -1)
						BTL_logMessage(targets[1].battlen, "Scanning...") // yeah, it's a cheap cover-up but it works
					end
				end
			end
			
			if bionis
				for i = 1, #bioelements
					for j = 1, #types
						if (types[j] and types[j] & bioelements[i][1])
							target.walls[#target.walls+1] = bioelements[i][2]
							buffStat(target, bioelements[i][1], -1)
							BTL_logMessage(targets[1].battlen, "Scanning...")
						end
					end
				end
			end
			
			if not target.walls[1]
				target.walls[1] = SKINCOLOR_WHITE
			end
		elseif timer >= 20 and timer <= (15 + 5*#target.walls) and timer %5 == 0
			if not mo.wall
				mo.wall = 1
			end

			local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
			
			local wall = P_SpawnMobj(target.x + 20*mo.wall*cos(ang), target.y + 20*mo.wall*sin(ang), mo.z, MT_THOK)
			wall.state = S_WWALL1
			wall.colorized = true
			wall.angle = ang + ANGLE_90
			wall.color = target.walls[mo.wall]
			target.barriers[#target.barriers+1] = wall
			mo.wall = $ + 1
		elseif timer == (60 + 5*#target.walls)
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
			local  speed = 20*FRACUNIT
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.angle = ang
			playSound(mo.battlen, sfx_wslsr1)
			localquake(mo.battlen, 4*FRACUNIT, 10)
		elseif timer == (62 + 5*#target.walls)
			local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y) - ANG1*24
			
			for r = 1, #target.walls
				for i = 1, 4
					local tiles = ((i == 1 or i == 4) and 8 or 6)
					for j = 1, tiles
						local tile = P_SpawnMobj(target.x + 20*r*cos(ang + ANG1*12*i), target.y + 20*r*sin(ang + ANG1*12*i), target.z + 24*FRACUNIT*(j-1), MT_THOK)
						tile.state = S_WWALL6
						tile.colorized = true
						tile.flags = MF_NOBLOCKMAP
						tile.color = target.walls[r]
						tile.momx = P_RandomRange(-30, 30)*FRACUNIT
						tile.momy = P_RandomRange(-30, 30)*FRACUNIT
						tile.momz = P_RandomRange(0, 15)*FRACUNIT
						tile.angle = ang + ANG1*24 + ANGLE_90
					end
				end
			end
			
			playSound(mo.battlen, sfx_gbrk)
			
			for i = 1, #target.barriers
				P_KillMobj(target.barriers[i])
			end
		elseif timer == (64 + 5*#target.walls)
			P_KillMobj(mo.th)
			
		elseif (timer == 90 + 5*#target.walls)
			playSound(mo.battlen, sfx_dvst)
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_BLACK
				dust.scale = FRACUNIT*2
			end
			
			target.resdown = 3
			target.devastated = 2
			target.weak = ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_ELEC|ATK_WIND|ATK_NUCLEAR|ATK_PSY|ATK_BLESS|ATK_CURSE
			if bionis
				target.weak = $|ATK_WATER|ATK_EARTH|ATK_FOREST|ATK_POISON|ATK_METAL|ATK_GRAVITY
			end
			BTL_logMessage(targets[1].battlen, "Enemy defenses crippled!")
		elseif (timer > 90 + 5*#target.walls) and (timer < 110 + 5*#target.walls)
			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(100, 150)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT*-1
					thok.color = SKINCOLOR_BLACK
					thok.tics = 5
					thok.scale = FRACUNIT*3/2
					thok.flags = MF_NOGRAVITY|MF_NOBLOCKMAP
				end
			end

			for i = 1, 8
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(100, 150)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT*-1
				thok.color = elements[P_RandomRange(1, #elements)][2]
				thok.tics = 5
				thok.flags = MF_NOGRAVITY|MF_NOBLOCKMAP
			end
		end
		
		if timer == (130 + 5*#target.walls)
			mo.th = nil
			mo.wall = nil
			target.barriers = nil
			target.walls = nil
			return true
		end
	end,
}

attackDefs["w-equalize"] = {
	name = "Equalize",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 48,
	desc = "Lower all enemies' \nresistances for 3 turns.",
	target = TGT_ALLENEMIES,
	debuff = true,
	anim = function(mo, targets, hittargets, timer)
		for d = 1, #hittargets
			local target = hittargets[d]
			local bioelements
			local elements = {
			{ATK_SLASH, SKINCOLOR_ORANGE},
			{ATK_STRIKE, SKINCOLOR_ORANGE},
			{ATK_PIERCE, SKINCOLOR_ORANGE},
			{ATK_FIRE, SKINCOLOR_RED},
			{ATK_ICE, SKINCOLOR_CYAN},
			{ATK_WIND, SKINCOLOR_GREEN},
			{ATK_ELEC, SKINCOLOR_YELLOW},
			{ATK_NUCLEAR, SKINCOLOR_TEAL},
			{ATK_PSY, SKINCOLOR_ROSY},
			{ATK_BLESS, SKINCOLOR_TAN},
			{ATK_CURSE, SKINCOLOR_CRIMSON}}
			if bionis
				bioelements = {
				{ATK_WATER, SKINCOLOR_AQUA},
				{ATK_EARTH, SKINCOLOR_BROWN},
				{ATK_FOREST, SKINCOLOR_EMERALD},
				{ATK_METAL, SKINCOLOR_SILVER},
				{ATK_POISON, SKINCOLOR_NEON},
				{ATK_GRAVITY, SKINCOLOR_PASTEL}}
			end
			
			
			if timer == 1
				local types = {target.resist, target.block, target.drain, target.repel}
				
				target.walls = {}
				target.barriers = {}
				for i = 1, #elements
					for j = 1, #types
						if (types[j] and types[j] & elements[i][1])
							target.walls[#target.walls+1] = elements[i][2]
							buffStat(target, elements[i][1], -1)
							BTL_logMessage(targets[1].battlen, "Scanning...") // yeah, it's a cheap cover-up but it works
						end
					end
				end
				
				if bionis
					for i = 1, #bioelements
						for j = 1, #types
							if (types[j] and types[j] & bioelements[i][1])
								target.walls[#target.walls+1] = bioelements[i][2]
								buffStat(target, bioelements[i][1], -1)
								BTL_logMessage(targets[1].battlen, "Scanning...")
							end
						end
					end
				end
				
				if not target.walls[1]
					target.walls[1] = SKINCOLOR_WHITE
				end
			elseif timer >= 20 and timer <= (15 + 5*#target.walls) and timer %5 == 0
				if not target.wall
					target.wall = 1
				end

				local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
				
				local wall = P_SpawnMobj(target.x + 20*target.wall*cos(ang), target.y + 20*target.wall*sin(ang), target.z, MT_THOK)
				wall.state = S_WWALL1
				wall.colorized = true
				wall.angle = ang + ANGLE_90
				wall.color = target.walls[target.wall]
				target.barriers[#target.barriers+1] = wall
				target.wall = $ + 1
			elseif timer == (60 + 5*#target.walls)
				target.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_LASER)
				local  speed = 20*FRACUNIT
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				local momx = FixedMul(speed, cos(ang))
				local momy = FixedMul(speed, sin(ang))
				momx = FixedMul($, mo.scale)
				momy = FixedMul($, mo.scale)
				target.th.momx = momx
				target.th.momy = momy
				target.th.angle = ang
				playSound(mo.battlen, sfx_wslsr1)
				localquake(mo.battlen, 4*FRACUNIT, 10)
			elseif timer == (62 + 5*#target.walls)
				local ang = R_PointToAngle2(target.x, target.y, mo.x, mo.y) - ANG1*24
				
				for r = 1, #target.walls
					for i = 1, 4
						local tiles = ((i == 1 or i == 4) and 8 or 6)
						for j = 1, tiles
							local tile = P_SpawnMobj(target.x + 20*r*cos(ang + ANG1*12*i), target.y + 20*r*sin(ang + ANG1*12*i), target.z + 24*FRACUNIT*(j-1), MT_THOK)
							tile.state = S_WWALL6
							tile.colorized = true
							tile.flags = MF_NOBLOCKMAP
							tile.color = target.walls[r]
							tile.momx = P_RandomRange(-30, 30)*FRACUNIT
							tile.momy = P_RandomRange(-30, 30)*FRACUNIT
							tile.momz = P_RandomRange(0, 15)*FRACUNIT
							tile.angle = ang + ANG1*24 + ANGLE_90
						end
					end
				end
				
				playSound(mo.battlen, sfx_gbrk)
				target.resdown = 3
				BTL_logMessage(targets[1].battlen, "Enemy resistances down!")
				
				for i = 1, #target.barriers
					P_KillMobj(target.barriers[i])
				end
			elseif timer == (64 + 5*#target.walls)
				P_KillMobj(target.th)
			end
			
		end
		
		if timer == 175
			for i = 1, #hittargets
				local target = hittargets[i]
				target.th = nil
				target.wall = nil
				target.barriers = nil
				target.walls = nil
			end
			return true
		end
	end,
}

attackDefs["w-miranda"] = {
	name = "Miranda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	desc = "Lower an enemy's crit rate \nby 1 stage.",
	target = TGT_ENEMY,
	debuff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["crit"][1] <= -75
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			orb.sprite = SPR_DBUF
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*2
			orb.scalespeed = FRACUNIT/32
			orb.destscale = FRACUNIT/6
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_SKY

		elseif timer == 5+2*TICRATE
			buffStat(target, "crit", -BUFFSTEP)	-- negative values lower a stat
			playSound(mo.battlen, sfx_s3k8c)
			local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
			dbuff.state = S_DBUFF1
			dbuff.color = SKINCOLOR_SKY
			dbuff.scale = FRACUNIT*5/2

		elseif timer == TICRATE*3
			return true
		end
	end,
}

attackDefs["w-mamiranda"] = {
	name = "Mamiranda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Lower enemies' crit rate \nby 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		end
		
		for i = 1, #targets do

			local target = targets[i]

			if timer == 20 + 8*(i-1)
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_DBUF
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_SKY

			elseif timer == 5+2*TICRATE + 8*(i-1)
				buffStat(target, "crit", -BUFFSTEP)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_SKY
				dbuff.scale = FRACUNIT*5/2
			end
		end

		if timer == TICRATE*3 + 8*(#targets-1)
			return true
		end
	end,
}

// Rocket Skills

attackDefs["big bang 1"] = {
	name = "Big Bang",
	type = ATK_FIRE,
	power = 160,
	accuracy = 95,
	costtype = CST_SP,
	cost = 20,
	status = COND_BURN,
	statuschance = 4,
	desc = "Medium Fire dmg to all enemies. \nMay inflict burn.\nTires Orange after use.",
	target = TGT_ALLENEMIES,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Orange is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
		elseif timer == 10
			playSound(mo.battlen, sfx_wschg2)
			local thok = P_SpawnMobj(mo.x + P_ReturnThrustX(mo, mo.angle, mo.radius*2),
			mo.y + P_ReturnThrustY(mo, mo.angle, mo.radius*2), mo.z + mo.height*2/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_RUST
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = mo.scale/2
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
			playSound(mo.battlen, sfx_zio5)
		elseif timer >= 15 and timer <= 65 and timer%5 == 0
			local ghost = P_SpawnGhostMobj(mo)
			ghost.destscale = FRACUNIT*2
			ghost.colorized = true
			ghost.color = SKINCOLOR_SUPERROCKET3
		elseif timer == 70
			mo.th = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_ROCKET)
			local  speed = FRACUNIT*2
			local ang = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			mo.th.momz = -FRACUNIT/16
			mo.th.angle = ang
		elseif timer == 105
			playSound(mo.battlen, sfx_fire2)
			localquake(mo.battlen, FRACUNIT*5, 20)
			P_KillMobj(mo.th)
			local megicolors = {SKINCOLOR_WHITE, SKINCOLOR_AETHER, SKINCOLOR_SALMON, SKINCOLOR_BUBBLEGUM}
			
			for i = 1,32
				local dust = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOKE)
				dust.angle = ANGLE_90 + ANG1* (11*(i-1))
				dust.destscale = FRACUNIT*10
				P_InstaThrust(dust, dust.angle, 50*FRACUNIT)
			end
			for i = 1,16

				local dust = P_SpawnMobj(avgx+P_RandomRange(-30, 30)*FRACUNIT, avgy+P_RandomRange(-30, 30)*FRACUNIT, mo.z+P_RandomRange(0, 30)*FRACUNIT, MT_SMOKE)
				dust.destscale = FRACUNIT*10
				dust.tics = 30
				dust.momz = P_RandomRange(3, 7)*FRACUNIT
			end

			-- explosion particles...?
			for i = 1, 16
				local truc = P_SpawnMobj(avgx+P_RandomRange(-20, 20)*FRACUNIT, avgy+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, 60)*FRACUNIT, MT_BOOMPARTICLE)
				truc.scale = FRACUNIT
				if attackDefs["big bang 1"].type == ATK_ALMIGHTY
					truc.colorized = true
					truc.color = megicolors[P_RandomRange(1,#megicolors)]
				end
				truc.destscale = FRACUNIT*5
				truc.momx = P_RandomRange(-50, 50)*FRACUNIT
				truc.momy = P_RandomRange(-50, 50)*FRACUNIT
				truc.momz = P_RandomRange(10, 30)*FRACUNIT
				truc.tics = TICRATE*5
			end

			-- spawn the actual explosion
			for i =1,32
				local truc = P_SpawnMobj(avgx+P_RandomRange(-20, 20)*FRACUNIT, avgy+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, 40)*FRACUNIT, MT_BOSSEXPLODE)
				truc.scale = FRACUNIT*2
				truc.destscale = FRACUNIT*6
				if attackDefs["big bang 1"].type == ATK_ALMIGHTY
					truc.state = S_CQUICKBOOM1
					truc.color = megicolors[P_RandomRange(1,#megicolors)]
				else
					truc.state = S_LESS_QUICKBOOM1
				end
				truc.color = megicolors[P_RandomRange(1, #megicolors)]
				truc.momx = P_RandomRange(-40, 40)*FRACUNIT
				truc.momy = P_RandomRange(-40, 40)*FRACUNIT
				truc.momz = FRACUNIT*2
				if i < 2	-- cool sound effect
					local mobj = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					mobj.state = S_INVISIBLE
					mobj.tics = TICRATE*10
					S_StartSound(mobj, sfx_bgxpld)
				end
			end
		elseif timer == 115
			for i = 1, #hittargets
				damageObject(hittargets[i])
			end
		elseif timer == 135
			mo.th = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
			mo.zenmindset = false
			return true
		end
	end,
}

attackDefs["big bang 2"] = {
	name = "Hell's Missile",
	type = ATK_FIRE,
	power = 380,
	accuracy = 100,
	costtype = CST_SP,
	cost = 30,
	status = COND_BURN,
	statuschance = 8,
	desc = "Heavy Fire dmg to all enemies. \nMay inflict burn.\nTires Orange after use.",
	target = TGT_ALLENEMIES,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Orange is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		local cam = server.P_BattleStatus[mo.battlen].cam
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			mo.rockets = {}
			mo.flames = {}
		elseif timer == 10
			playSound(mo.battlen, sfx_wschg2)
			local thok = P_SpawnMobj(mo.x + P_ReturnThrustX(mo, mo.angle, mo.radius*2),
			mo.y + P_ReturnThrustY(mo, mo.angle, mo.radius*2), mo.z + mo.height*2/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_RUST
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = mo.scale/2
			thok.scalespeed = FixedMul($, thok.scale)
			thok.destscale = INT32_MAX
			playSound(mo.battlen, sfx_zio5)
		elseif timer == 15
			ANIM_set(mo, mo.anim_special3)
		elseif timer >= 20 and timer <= 65 and timer%5 == 0
			local ghost = P_SpawnGhostMobj(mo)
			ghost.destscale = FRACUNIT*2
			ghost.colorized = true
			ghost.color = SKINCOLOR_SUPERROCKET3
		elseif timer >= 70 and timer <= 84 and timer%7 == 0
			local angles = {0, -20, 20}
			local rocket = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_ROCKET)
			local speed = FRACUNIT*2
			local ang = R_PointToAngle2(mo.x, mo.y, avgx, avgy) + (angles[(timer - 60)/10])*ANG1
			rocket.speed = 1
			rocket.dist = 0
			rocket.length = (R_PointToDist2(mo.x, mo.y, avgx, avgy))/FRACUNIT
			rocket.angle = ang
			mo.rockets[#mo.rockets + 1] = rocket
		elseif timer == 90
			ANIM_set(mo, mo.anim_stand)
		end
		
		if mo.rockets
			for i = 1, #mo.rockets
				local r = mo.rockets[i]
				if not r or not r.valid
					continue
				end
				
				if r.z > r.floorz
					r.speed = $ + 1
					r.dist = $ + r.speed
					local x = mo.x + r.dist*cos(r.angle)
					local y = mo.y + r.dist*sin(r.angle)
					local z = mo.z + ((-800*(r.dist^2))/(r.length^2) + (800*r.dist)/r.length)*FRACUNIT + mo.height
					
					P_TeleportMove(r, x, y, z)
				elseif r.z <= r.floorz
					if not mo.rtrigger
						mo.rtrigger = 12
					end
					P_TeleportMove(r, r.x, r.y, r.floorz)
				end
			end
		end
		
		if mo.rtrigger
			if mo.rtrigger >= 16
				if mo.rtrigger%16 == 0
					playSound(mo.battlen, sfx_s3k4e)
					localquake(mo.battlen, FRACUNIT*5, 16)
				elseif mo.rtrigger%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end
		
				for i = 1, 16
					local boom = P_SpawnMobj(avgx + P_RandomRange(-128, 128)*FRACUNIT, avgy + P_RandomRange(-128, 128)*FRACUNIT, mo.z, MT_DUMMY)
					if attackDefs["big bang 2"].type == ATK_ALMIGHTY
						local megicolors = {SKINCOLOR_WHITE, SKINCOLOR_AETHER, SKINCOLOR_SALMON, SKINCOLOR_BUBBLEGUM}
						boom.state = S_CQUICKBOOM1
						boom.color = megicolors[P_RandomRange(1,#megicolors)]
					else
						boom.state = S_QUICKBOOM1
					end
					boom.momz = P_RandomRange(0, 64)*FRACUNIT
					boom.scale = FRACUNIT*2
					boom.mom = FRACUNIT
					boom.angle = R_PointToAngle2(avgx, avgy, boom.x, boom.y)
					mo.flames[#mo.flames + 1] = boom
				end
				
				local v = #mo.flames
				while v
					local m = mo.flames[v]
					if not m or not m.valid
						v = $-1
						continue
					end
					
					m.angle = $ + ANG10
					P_InstaThrust(m, m.angle, FRACUNIT*30)
					v = $-1
				end
				
				if mo.rtrigger == 80
					for i = 1, #hittargets
						local target = hittargets[i]
						damageObject(target)
					end
				end
			
				if mo.rtrigger == 100
					mo.rtrigger = nil
					mo.rockets = nil
					mo.flames = nil
					mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
					mo.zenmindset = false
					return true
				end
			end
			
			mo.rtrigger = $ + 1
		end
	end,
}

attackDefs["big bang 3"] = {
	name = "Nova Flare",
	type = ATK_FIRE,
	power = 700,
	accuracy = 100,
	costtype = CST_SP,
	cost = 45,
	hits = 2,
	status = COND_BURN,
	statuschance = 16,
	desc = "Severe Fire dmg to all enemies 2x. \nMay inflict burn.\nTires Orange after use.",
	target = TGT_ALLENEMIES,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Orange is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		local cam = server.P_BattleStatus[mo.battlen].cam
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1 and mo.name == "\x56\x65\x72\x67\x69\x6C"
			playSound(mo.battlen, sfx_vrgmtv)
		elseif timer == 10
			playSound(mo.battlen, sfx_s3k53)
			local thok = P_SpawnMobj(mo.x,
			mo.y, mo.z-mo.height/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_RUST
			
			thok.state = S_ARMF1
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = 3*mo.scale/2
			thok.momz = FRACUNIT
			thok.fuse = 60
			localquake(mo.battlen, 4*FRACUNIT, 60)
		end
		
		if timer == 15
			ANIM_set(mo, mo.anim_aoa_end)
			mo.flags = $|MF_NOGRAVITY
			mo.momz = FRACUNIT
		elseif timer >= 20 and timer <= 85 and timer%5 == 0
			local ghost = P_SpawnGhostMobj(mo)
			ghost.destscale = FRACUNIT*2
			ghost.colorized = true
			ghost.color = SKINCOLOR_SUPERROCKET3
			if timer == 65
				ANIM_set(mo, mo.anim_special3)
			end
		elseif timer == 90
			local rocket = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height)/2, MT_WHISPER_ROCKET)
			local ang = R_PointToAngle2(mo.x, mo.y, avgx, avgy)
			rocket.scale = FRACUNIT*2
			rocket.speed = 1
			rocket.dist = 0
			rocket.length = (R_PointToDist2(mo.x, mo.y, avgx, avgy))/FRACUNIT
			rocket.angle = ang
			mo.rocket = rocket
			mo.flags = $ & ~MF_NOGRAVITY
		elseif timer == 110
			ANIM_set(mo, mo.anim_stand)
		end
		
		if mo.rocket and mo.rocket.valid
			local r = mo.rocket

			if r.z > r.floorz
				if timer%4 == 0
					r.speed = $ + 1
				end
				r.dist = $ + r.speed
				local x = mo.x + r.dist*cos(r.angle)
				local y = mo.y + r.dist*sin(r.angle)
				local z = mo.z + ((-1600*(r.dist^2))/(r.length^2) + (1600*r.dist)/r.length)*FRACUNIT + mo.height
				
				P_TeleportMove(r, x, y, z)
			elseif r.z <= r.floorz
				if not mo.rtrigger
					mo.rtrigger = 1
				end
				P_TeleportMove(r, r.x, r.y, r.floorz)
			end
		end
		
		if mo.rtrigger
			if mo.rtrigger == 10
				local megicolors = {SKINCOLOR_WHITE, SKINCOLOR_AETHER, SKINCOLOR_SALMON, SKINCOLOR_BUBBLEGUM}
				-- explosion particles...?
				for i = 1, 16
					local truc = P_SpawnMobj(avgx+P_RandomRange(-20, 20)*FRACUNIT, avgy+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, 60)*FRACUNIT, MT_BOOMPARTICLE)
					truc.scale = FRACUNIT
					if attackDefs["big bang 3"].type == ATK_ALMIGHTY
						truc.colorized = true
						truc.color = megicolors[P_RandomRange(1,#megicolors)]
					end
					truc.destscale = FRACUNIT*5
					truc.momx = P_RandomRange(-50, 50)*FRACUNIT
					truc.momy = P_RandomRange(-50, 50)*FRACUNIT
					truc.momz = P_RandomRange(10, 30)*FRACUNIT
					truc.tics = TICRATE*5
				end

				-- spawn the actual explosion
				for i =1,32
					local truc = P_SpawnMobj(avgx+P_RandomRange(-20, 20)*FRACUNIT, avgy+P_RandomRange(-20, 20)*FRACUNIT, mo.z+P_RandomRange(0, 40)*FRACUNIT, MT_BOSSEXPLODE)
					truc.scale = FRACUNIT*2
					truc.destscale = FRACUNIT*6
					if attackDefs["big bang 1"].type == ATK_ALMIGHTY
						truc.state = S_CQUICKBOOM1
						truc.color = megicolors[P_RandomRange(1,#megicolors)]
						local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
						thok.state = S_MEGITHOK
						thok.fuse = 40
						thok.momx = P_RandomRange(-20, 20)*FRACUNIT
						thok.momy = P_RandomRange(-20, 20)*FRACUNIT
						thok.momz = P_RandomRange(3, 7)*FRACUNIT
					else
						truc.state = S_LESS_QUICKBOOM1
					end
					truc.angle = ANGLE_11hh*i
					P_InstaThrust(truc, truc.angle, FRACUNIT*20)
					truc.momz = FRACUNIT/4
					if i < 2	-- cool sound effect
						local mobj = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
						mobj.state = S_INVISIBLE
						mobj.tics = TICRATE*10
						S_StartSound(mobj, sfx_bgxpld)
					end
				end
				
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			elseif mo.rtrigger >= 12 and mo.rtrigger < 100 and mo.rtrigger%3 == 0
				local sus = P_SpawnMobj(avgx, avgy, mo.z + 100*FRACUNIT, MT_THOK)
				sus.sprite = SPR_WSPT
				sus.tics = 1
				sus.frame = A|FF_FULLBRIGHT
				sus.color = SKINCOLOR_SUPERROCKET1 + abs((timer)%8 - 4)
				sus.scale = FRACUNIT + (FRACUNIT/64)*(mo.rtrigger)
				
				for i = 1, 2
					local smoke = P_SpawnMobj(sus.x, sus.y, sus.z, MT_SMOKE)
					smoke.tics = 20
					smoke.flags = MF_NOGRAVITY
					smoke.scale = (P_RandomRange(7,10)*FRACUNIT)
					smoke.momx = P_RandomRange(-12, 12)*FRACUNIT
					smoke.momy = P_RandomRange(-12, 12)*FRACUNIT
					smoke.momz = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif mo.rtrigger >= 100 and mo.rtrigger <= 120
				local sus = P_SpawnMobj(avgx, avgy, mo.z + 100*FRACUNIT, MT_THOK)
				sus.sprite = SPR_NTHK
				sus.tics = 40
				sus.frame = A|FF_FULLBRIGHT|TR_TRANS30
				if attackDefs["big bang 3"].type == ATK_ALMIGHTY
					sus.color = SKINCOLOR_WHITE
					sus.blendmode = AST_SUBTRACT
				else
					sus.color = SKINCOLOR_SUPERROCKET1 + abs((timer)%8 - 4)
				end
				sus.scale = FRACUNIT + (FRACUNIT/64)*(mo.rtrigger)
				sus.destscale = FRACUNIT*32
				sus.scalespeed = FRACUNIT*2
				sus.momz = FRACUNIT*40
				if mo.rtrigger == 100
					localquake(mo.battlen, 10*FRACUNIT, 40)
					for i = 1, 3
						playSound(mo.battlen, sfx_s3k4e)
					end
				end
			elseif mo.rtrigger == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-500, 500)*FRACUNIT, avgy + P_RandomRange(-500, 500)*FRACUNIT, mo.z, MT_SMOLDERING)
					smoke.fuse = 60
					smoke.scale = 3*FRACUNIT/2
				end
			elseif mo.rtrigger == 180
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			elseif mo.rtrigger == 220
				mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
				mo.rtrigger = nil
				mo.zenmindset = false
				return true
			end
			
			mo.rtrigger = $ + 1
		end
	end,
	hudfunc = function(v, mo, timer)
		if mo.rtrigger
			if mo.rtrigger >= 100 and mo.rtrigger <= 118
				v.fadeScreen(0, (mo.rtrigger - 98)/2)
			elseif mo.rtrigger > 118 and mo.rtrigger <= 161
				v.fadeScreen(0, 10)
			elseif mo.rtrigger > 161 and mo.rtrigger <= 180
				v.fadeScreen(0, ((mo.rtrigger - 182)/2)*(-1))
			end
		end
	end,
}

attackDefs["w-deep breath"] = {
	name = "Deep Breath",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 20,
	desc = "Damage x2.5 next turn.",
	target = TGT_CASTER,
	powercharge = true,
	mindcharge = true,	-- used to know that we shouldn't remove mindcharge after using this skill.
	superbuff = true,	-- powerful buff
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.mindcharge and target.powercharge
						BTL_logMessage(targets[1].battlen, "Already in effect")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 20
			playSound(mo.battlen, sfx_buff2)
			target.powercharge = true
			target.mindcharge = true
			BTL_logMessage(targets[1].battlen, target.name.." took a deep breath...")
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_FLAME
				dust.scale = FRACUNIT*2
			end

		elseif timer > 20 and timer <= 50

			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_FLAME
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end
			end

			for i = 1, 8
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT
				thok.color = SKINCOLOR_FLAME
				thok.tics = P_RandomRange(10, 35)
			end
		elseif timer == 60
			return true
		end
	end,
}

attackDefs["w-zen mindset"] = {
	name = "Zen Mindset",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 30,
	desc = "Damage x2.5 next turn.\nUpgrades Rocket attacks to Almighty.",
	target = TGT_CASTER,
	powercharge = true,
	mindcharge = true,	-- used to know that we shouldn't remove mindcharge after using this skill.
	superbuff = true,	-- powerful buff
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.mindcharge and target.powercharge
						BTL_logMessage(targets[1].battlen, "Already in effect")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 20
			playSound(mo.battlen, sfx_buff2)
			target.powercharge = true
			target.mindcharge = true
			target.zenmindset = true
			BTL_logMessage(targets[1].battlen, target.name.."'s mind is fully focused.")
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_PURPLE
				dust.scale = FRACUNIT*2
			end

		elseif timer > 20 and timer <= 50

			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_PURPLE
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end
			end

			for i = 1, 8
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT
				thok.color = SKINCOLOR_PURPLE
				thok.tics = P_RandomRange(10, 35)
			end
		elseif timer == 60
			return true
		end
	end,
}

attackDefs["w-makanda"] = {
	name = "Makanda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	desc = "Lower an enemy's magic\nattack by 1 stage.",
	target = TGT_ENEMY,
	debuff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["mag"][1] <= -75
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			orb.sprite = SPR_DBUF
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*2
			orb.scalespeed = FRACUNIT/32
			orb.destscale = FRACUNIT/6
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_ORANGE

		elseif timer == 5+2*TICRATE
			buffStat(target, "mag", -BUFFSTEP)	-- negative values lower a stat
			playSound(mo.battlen, sfx_s3k8c)
			local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
			dbuff.state = S_DBUFF1
			dbuff.color = SKINCOLOR_ORANGE
			dbuff.scale = FRACUNIT*5/2

		elseif timer == TICRATE*3
			return true
		end
	end,
}

attackDefs["w-mamakanda"] = {
	name = "Mamakanda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Lower enemies' magic\nattack by 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		end
		
		for i = 1, #targets do

			local target = targets[i]

			if timer == 20 + 8*(i-1)
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_DBUF
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_ORANGE

			elseif timer == 5+2*TICRATE + 8*(i-1)
				buffStat(target, "mag", -BUFFSTEP)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_ORANGE
				dbuff.scale = FRACUNIT*5/2
			end
		end

		if timer == TICRATE*3 + 8*(#targets-1)
			return true
		end
	end,
}

attackDefs["w-debilitate"] = {
	name = "Debilitate",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 24,
	desc = "Lower all of an enemy's stats \nby 1 stage.",
	target = TGT_ENEMY,
	norepel = true,
	superdebuff = true,	-- powerful debuff
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local colors = {SKINCOLOR_ORANGE, SKINCOLOR_TEAL, SKINCOLOR_LAVENDER, SKINCOLOR_EMERALD}
		local strs = {"atk", "mag", "def", "agi"}
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			orb.sprite = SPR_DBUF
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*2
			orb.scalespeed = FRACUNIT/32
			orb.destscale = FRACUNIT/6
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_ORANGE

		elseif timer == 5+2*TICRATE
			for i = 1, 4
				buffStat(target, strs[i], -25)	-- negative values lower a stat
			end
			BTL_logMessage(targets[1].battlen, "All stats down!")
			playSound(mo.battlen, sfx_s3k8c)
			local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
			dbuff.state = S_DBUFF1
			dbuff.color = SKINCOLOR_ORANGE
			dbuff.scale = FRACUNIT*5/2
			for i = 1, 32
				local orb = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				orb.scale = FRACUNIT/4
				orb.tics = 30
				orb.frame = A|TR_TRANS30
				orb.color = colors[P_RandomRange(1, #colors)]
				orb.momx = P_RandomRange(-12, 12)*FRACUNIT
				orb.momy = P_RandomRange(-12, 12)*FRACUNIT
				orb.momz = P_RandomRange(0, 12)*FRACUNIT
				orb.flags = MF_NOCLIP
			end
		end

		if timer == TICRATE*4
			return true
		end
	end,
}

// Hover Skills

attackDefs["plasma burst 1"] = {
	name = "Plasma Burst",
	type = ATK_PSY,
	power = 60,
	accuracy = 100,
	costtype = CST_SP,
	cost = 10,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Green is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Light Psy dmg to one enemy.\nLowers target's agility.\nTires Green after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker)
			playSound(mo.battlen, sfx_hchrg)
		elseif timer >= 8 and timer <= 16 and timer%4 == 0
			local thok = P_SpawnMobjFromMobj(mo, 0,0,
			mo.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			thok.scale = 1
			thok.angle = cam.angle + ANGLE_90
			thok.momz = FRACUNIT*4
			thok.scalespeed = FixedMul($, FRACUNIT)
			thok.destscale = INT32_MAX
		elseif timer == 20
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + mo.height, MT_THOK)
			mo.th.sprite = SPR_WSPT
			mo.th.frame = A|FF_FULLBRIGHT|TR_TRANS20
			mo.th.scale = FRACUNIT
			mo.th.tics = 41
			mo.th.flags = MF_NOGRAVITY
			mo.th.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local speed = R_PointToDist2(mo.x, mo.y, target.x, target.y)/20
			P_InstaThrust(mo.th, mo.th.angle, speed)
			playSound(mo.battlen, sfx_hfire)
		elseif timer == 40
			local thok = P_SpawnMobjFromMobj(mo.th, 0,0,
			0, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.sprite = SPR_NTHK
			thok.frame = B|TR_TRANS20
			thok.momz = FRACUNIT*16
			thok.scalespeed = FixedMul($, FRACUNIT*4)
			thok.destscale = INT32_MAX
			
			playSound(mo.battlen, sfx_hexpl)
			P_KillMobj(mo.th)
			
			if (target.flags & MF_NOGRAVITY)
				target.flags = $ & ~MF_NOGRAVITY
				target.grav = true
			end
			
			target.momz = FRACUNIT*10
		elseif timer >= 44 and timer <= 52 and timer%4 == 0
			local thok = P_SpawnMobjFromMobj(target, 0,0,
			target.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			thok.scale = 1
			thok.angle = cam.angle + ANGLE_90
			thok.scalespeed = FixedMul($, FRACUNIT)
			thok.destscale = INT32_MAX
			playSound(mo.battlen, sfx_s3kc3s)
		end
		
		if not target.done
			if timer >= 52 and P_IsObjectOnGround(target)
				damageObject(target)
				buffStat(target, "agi", -25)
				target.done = true
				playSound(mo.battlen, sfx_doord2)
				for i = 1,32
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (11*(i-1))
					dust.destscale = FRACUNIT*10
					dust.state = S_AOADUST1
					dust.frame = A|FF_FULLBRIGHT
					P_InstaThrust(dust, dust.angle, 20*FRACUNIT)
				end
			elseif timer == 90
				damageObject(target)
				buffStat(target, "agi", -25)
				playSound(mo.battlen, sfx_psi)
				target.done = true
			end
		end
		
		if mo.th and mo.th.valid
			if timer%4 == 0
				local thok = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				thok.sprite = SPR_NTHK
				thok.frame = A|FF_FULLBRIGHT|TR_TRANS60
				thok.color = SKINCOLOR_SUPERHOVER3
				thok.scale = FRACUNIT/2
				thok.tics = 5
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/32
				thok.flags = MF_NOGRAVITY
				thok.momx = P_RandomRange(-10,10)*FRACUNIT
				thok.momy = P_RandomRange(-10,10)*FRACUNIT
				thok.momz = P_RandomRange(-10,10)*FRACUNIT
			end
			
			if timer%2 == 0
				local l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KLIT1 + P_RandomRange(0, 5)
				l.angle = P_RandomRange(0, 359)*ANG1
				l.fuse = P_RandomRange(10, 40)
				l.scale = FRACUNIT/4
				l.color = SKINCOLOR_SUPERHOVER3
				l.rollangle = P_RandomRange(1, 359)*ANG1

				-- alsos spawn a spark...
				l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KSPK1
				l.tics = P_RandomRange(2, 10)
				l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				l.destscale = 1
				l.scale = FRACUNIT/2
				l.scalespeed = l.scale/24
				l.color = SKINCOLOR_SUPERHOVER3
			end
			
			mo.th.color = SKINCOLOR_SUPERHOVER1 + abs((timer)%9 - 4)
		end
		
		if timer == 110
			if target.grav
				target.grav = nil
				target.flags = $|MF_NOGRAVITY
			end
			
			mo.th = nil
			target.done = false
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
	end,
}

attackDefs["plasma burst 2"] = {
	name = "Force Shot",
	type = ATK_PSY,
	power = 140,
	accuracy = 100,
	costtype = CST_SP,
	cost = 20,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Green is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Psy dmg to one enemy.\nLowers target's agility sharply.\nTires Green after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker)
			playSound(mo.battlen, sfx_hchrg)
		elseif timer >= 8 and timer <= 16 and timer%4 == 0
			local thok = P_SpawnMobjFromMobj(mo, 0,0,
			mo.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $ &~ MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			thok.scale = 1
			thok.angle = cam.angle + ANGLE_90
			thok.momz = FRACUNIT*4
			thok.scalespeed = FixedMul($, FRACUNIT)
			thok.destscale = INT32_MAX
		elseif timer == 20
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + mo.height, MT_THOK)
			mo.th.sprite = SPR_WLCR
			mo.th.frame = C|FF_FULLBRIGHT|TR_TRANS20|FF_PAPERSPRITE
			mo.th.scale = FRACUNIT*3
			mo.th.color = SKINCOLOR_SUPERHOVER1
			mo.th.colorized = true
			mo.th.tics = 41
			mo.th.flags = MF_NOGRAVITY
			mo.th.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local speed = R_PointToDist2(mo.x, mo.y, target.x, target.y)/20
			P_InstaThrust(mo.th, mo.th.angle, speed)
			playSound(mo.battlen, sfx_hfire)
		elseif timer == 35
			playSound(mo.battlen, sfx_hexpl2)
		elseif timer == 40
			for i = 1, 3
				local thok = P_SpawnMobjFromMobj(mo.th, 0,0,
				(i-1)*target.height/2, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_EMERALD
				
				thok.flags = $ &~ MF_NOGRAVITY
				
				thok.sprite = SPR_NTHK
				thok.frame = B|TR_TRANS20
				thok.momz = FRACUNIT*16
				thok.scalespeed = FixedMul($, FRACUNIT*4)
				thok.destscale = INT32_MAX
			end
			
			damageObject(target)
			buffStat(target, "agi", -50)
			P_KillMobj(mo.th)
			
			if (target.flags & MF_NOGRAVITY)
				target.flags = $ & ~MF_NOGRAVITY
				target.grav = true
			end
			
			target.oldx = target.x
			target.oldy = target.y
			target.oldz = target.z
			
			target.momz = FRACUNIT*10
			
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			P_InstaThrust(target, ang, FRACUNIT*32)
		elseif timer >= 41 and timer <= 55
			local l = P_SpawnMobj(target.oldx, target.oldy, target.oldz + target.height/2, MT_THOK)
			l.state = S_KLIT1 + P_RandomRange(0, 5)
			l.angle = P_RandomRange(0, 359)*ANG1
			l.fuse = P_RandomRange(10, 40)
			l.scale = FRACUNIT/4
			l.color = SKINCOLOR_SUPERHOVER3

			-- alsos spawn a spark...
			l = P_SpawnMobj(target.oldx, target.oldy, target.oldz + target.height/2, MT_THOK)
			l.state = S_KSPK1
			l.tics = P_RandomRange(2, 10)
			l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			l.destscale = 1
			l.scale = FRACUNIT/2
			l.scalespeed = l.scale/24
			l.color = SKINCOLOR_SUPERHOVER3
		end
		
		
		if mo.th and mo.th.valid
			P_SpawnGhostMobj(mo.th)
			
			if timer%4 == 0
				local thok = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				thok.sprite = SPR_NTHK
				thok.frame = A|FF_FULLBRIGHT|TR_TRANS60
				thok.color = SKINCOLOR_SUPERHOVER3
				thok.scale = FRACUNIT/2
				thok.tics = 5
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/32
				thok.flags = MF_NOGRAVITY
				thok.momx = P_RandomRange(-10,10)*FRACUNIT
				thok.momy = P_RandomRange(-10,10)*FRACUNIT
				thok.momz = P_RandomRange(-10,10)*FRACUNIT
			end
			
			if timer%2 == 0
				local l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KLIT1 + P_RandomRange(0, 5)
				l.angle = P_RandomRange(0, 359)*ANG1
				l.fuse = P_RandomRange(10, 40)
				l.scale = FRACUNIT/4
				l.color = SKINCOLOR_SUPERHOVER3
				l.rollangle = P_RandomRange(1, 359)*ANG1

				-- alsos spawn a spark...
				l = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				l.state = S_KSPK1
				l.tics = P_RandomRange(2, 10)
				l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				l.destscale = 1
				l.scale = FRACUNIT/2
				l.scalespeed = l.scale/24
				l.color = SKINCOLOR_SUPERHOVER3
			end
			
			mo.th.color = SKINCOLOR_SUPERHOVER1 + abs((timer)%9 - 4)
		end
		
		if timer == 110
			if target.grav
				target.grav = nil
				target.flags = $|MF_NOGRAVITY
			end
			
			target.oldx = nil
			target.oldy = nil
			target.oldz = nil
			
			mo.th = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
	end,
}

attackDefs["plasma burst 3"] = {
	name = "Gravity Wave",
	type = ATK_PSY,
	power = 180,
	accuracy = 100,
	costtype = CST_SP,
	cost = 30,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Green is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Psy dmg to all enemies.\nLowers targets' agility sharply.\nTires Green after use.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			if mo.name == "\x56\x65\x72\x67\x69\x6C"
				playSound(mo.battlen, sfx_vrgmtv)
			end
			
			playSound(mo.battlen, sfx_hchrg)
		elseif timer >= 8 and timer <= 16 and timer%4 == 0
			local thok = P_SpawnMobj(mo.x + P_ReturnThrustX(mo, mo.angle, mo.radius*2),
			mo.y + P_ReturnThrustY(mo, mo.angle, mo.radius*2), mo.z + mo.height*2/3, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.state = S_WHISPER_CIRCLE
			thok.angle = mo.angle + ANGLE_90
			
			thok.scale = FRACUNIT*2
			thok.destscale = 1
		elseif timer == 20
			ANIM_set(mo, mo.anim_getup, true)
			mo.momz = 10*FRACUNIT
			playSound(mo.battlen, sfx_jump)
		elseif timer == 40
			ANIM_set(mo, mo.anim_special4)
			
			mo.flags = $|MF_NOGRAVITY
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
		elseif timer == 44
			playSound(mo.battlen, sfx_supert)
		elseif timer >= 48 and timer <= 80
			if timer%2 == 0
				local ghost = P_SpawnGhostMobj(mo)
				ghost.tics = 4
				ghost.colorized = true
				ghost.color = SKINCOLOR_SUPERHOVER3
				ghost.destscale = mo.scale*2
			end
			
			if timer%4 == 0
				local thok = P_SpawnMobjFromMobj(mo, 0,0,
				mo.height, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_EMERALD
				
				thok.flags = $ &~ MF_NOGRAVITY
				
				thok.state = S_WHISPER_CIRCLE
				thok.scale = 1
				thok.scalespeed = FixedMul($, FRACUNIT)
				thok.destscale = INT32_MAX
			end
			
			if timer%16 == 0
				playSound(mo.battlen, sfx_wsflt1)
				playSound(mo.battlen, sfx_wsflt2)
				playSound(mo.battlen, sfx_litng2)
				
				localquake(mo.battlen, FRACUNIT*8, 12)
				
				for i = 1, 4
					local thok = P_SpawnMobj(mo.x, mo.y, mo.z - mo.height*(i-4), MT_THOK)
					
					thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
					thok.blendmode = AST_ADD
					thok.color = SKINCOLOR_EMERALD
					
					thok.state = S_WHISPER_CIRCLE
					thok.angle = mo.angle + ANGLE_90
					
					thok.scale = FRACUNIT*3
					thok.scalespeed = FixedMul($, FRACUNIT*2)
					thok.destscale = FRACUNIT*128
					thok.momz = FRACUNIT*3
				end
				
				for i = 1, 16
					local laser = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
					laser.scale = FRACUNIT*2
					laser.tics = 10
					laser.flags = MF_NOGRAVITY
					laser.angle = (i-1)*ANGLE_22h
					local speed = FRACUNIT*20
					P_InstaThrust(laser, laser.angle, speed)
				end
			end
			
			local l = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
			l.sprite = SPR_DELK
			l.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			l.destscale = FRACUNIT*4
			l.scalespeed = FRACUNIT/4
			l.tics = TICRATE/8
			l.color = SKINCOLOR_EMERALD

			-- alsos spawn a spark...
			l = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			l.state = S_KSPK1
			l.tics = P_RandomRange(2, 10)
			l.flags = MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			l.destscale = 1
			l.scale = FRACUNIT/2
			l.scalespeed = l.scale/24
			l.color = SKINCOLOR_SUPERHOVER3
			
			if timer == 64
				playSound(sfx_mspogo)
				for i = 1, #hittargets
					local target = hittargets[i]
					
					local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(target, ang, FRACUNIT*30)
					target.momz = 15*FRACUNIT
					damageObject(target)
					buffStat(target, "agi", -50)
				end
			end
		elseif timer == 100
			mo.flags = $ & ~MF_NOGRAVITY
			ANIM_set(mo, mo.anim_aoa_end)
		elseif timer == 140
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
		
		if timer >= 100 and P_IsObjectOnGround(mo)
			ANIM_set(mo, mo.anim_stand)
		end
			
	end,
}

attackDefs["w-airlift"] = {
	name = "Airlift",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 16,
	desc = "Suspends a target in the air,\nhalving their agility.",
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.lifted
						BTL_logMessage(targets[1].battlen, "Target already in the air.")
						return true
					end
				end,

	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 10
			local thok = P_SpawnMobjFromMobj(mo, 0,0,
			mo.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $|MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			
			thok.scale = FRACUNIT*3
			thok.scalespeed = FixedMul($, FRACUNIT*2)
			thok.destscale = FRACUNIT*128
			thok.momz = FRACUNIT*3
			playSound(mo.battlen, sfx_hexpl)
		elseif timer == 24
			target.momz = FRACUNIT*6
			BTL_logMessage(mo.battlen, "Enemy is lifted!")
			target.lifted = 3
			playSound(mo.battlen, sfx_s3k73)
		end

		if timer == 80
			return true
		end
	end,
}

attackDefs["w-abduction"] = {
	name = "Abduction",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 32,
	desc = "Suspends all targets in the air,\nhalving their agility.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
			playSound(mo.battlen, sfx_hexpl2)
		elseif timer == 10
			local thok = P_SpawnMobjFromMobj(mo, 0,0,
			mo.height, MT_THOK)
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
			thok.blendmode = AST_ADD
			thok.color = SKINCOLOR_EMERALD
			
			thok.flags = $|MF_NOGRAVITY
			
			thok.state = S_WHISPER_CIRCLE
			
			thok.scale = FRACUNIT*3
			thok.scalespeed = FixedMul($, FRACUNIT*2)
			thok.destscale = FRACUNIT*128
			thok.momz = FRACUNIT*3
		elseif timer == 24
			for i = 1, #hittargets
				local target = hittargets[i]
				
				target.momz = FRACUNIT*6
				BTL_logMessage(mo.battlen, "Enemies are lifted!")
				target.lifted = 3
			end
			playSound(mo.battlen, sfx_s3k73)
		end

		if timer == 80
			return true
		end
	end,
}

attackDefs["w-sukunda"] = {
	name = "Sukunda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	desc = "Lower an enemy's agility \nby 1 stage.",
	target = TGT_ENEMY,
	debuff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][1] <= -75
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			orb.sprite = SPR_DBUF
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*2
			orb.scalespeed = FRACUNIT/32
			orb.destscale = FRACUNIT/6
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_EMERALD

		elseif timer == 5+2*TICRATE
			buffStat(target, "agi", -BUFFSTEP)	-- negative values lower a stat
			playSound(mo.battlen, sfx_s3k8c)
			local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
			dbuff.state = S_DBUFF1
			dbuff.color = SKINCOLOR_EMERALD
			dbuff.scale = FRACUNIT*5/2

		elseif timer == TICRATE*3
			return true
		end
	end,
}

attackDefs["w-masukunda"] = {
	name = "Masukunda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Lower enemies' agility \nby 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)

		for i = 1, #targets do

			local target = targets[i]
			
			if timer == 1
				ANIM_set(mo, mo.anim_special3)
			elseif timer == 20 + 8*(i-1)
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_DBUF
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_EMERALD

			elseif timer == 5+2*TICRATE + 8*(i-1)
				buffStat(target, "agi", -BUFFSTEP)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_EMERALD
				dbuff.scale = FRACUNIT*5/2
			end
		end

		if timer == TICRATE*3 + 8*(#targets-1)
			return true
		end
	end,
}

attackDefs["w-accelerate"] = {
	name = "Accelerate",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Raise own agility \nby 2 stages.",
	target = TGT_CASTER,
	buff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 15
			playSound(mo.battlen, sfx_zio5)
		elseif timer >= 20

			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 70
			for i = 0, 16
				local angle = baseangle + i*6*ANG1
				local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_SUPERHOVER3
				aura.momz = P_RandomRange(2, 8)*FRACUNIT
				aura.scale = FRACUNIT*2
				aura.destscale = FRACUNIT*5
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
			end
		end
		
		if timer == 70
			playSound(mo.battlen, sfx_buff)
			buffStat(target, "agi", 50)
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_SUPERHOVER3
				dust.scale = FRACUNIT*2
			end

		elseif timer > 70 and timer <= 100

			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_SUPERHOVER3
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end
			end

			local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
			thok.sprite = SPR_SUMN
			thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
			thok.momz = P_RandomRange(6, 16)*FRACUNIT
			thok.color = SKINCOLOR_SUPERHOVER3
			thok.tics = P_RandomRange(10, 35)
		elseif timer == 110
			return true
		end
	end,
}

//Cube Skills

attackDefs["blunt force 1"] = {
	name = "Blunt Force",
	type = ATK_STRIKE,
	power = 140,
	accuracy = 100,
	costtype = CST_HPPERCENT,
	critical = 3,
	cost = 5,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Blue is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Strike dmg to one enemy.\nTires Blue after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
			
		if timer >= 10 and timer < 40
			if timer == 10
				playSound(mo.battlen, sfx_s3kaba)
				ANIM_set(mo, mo.anim_guard)
			end
			
			for i = 1,2
				local spark = P_SpawnMobj(mo.x + 30*cos(P_RandomRange(1,359)*ANG1), mo.y + 30*cos(P_RandomRange(1,359)*ANG1), mo.z, MT_THOK)
				spark.state = S_BUFUDYNE_AURA1
				spark.color = SKINCOLOR_BLUE
				spark.momz = P_RandomRange(2, 9)*FRACUNIT
				spark.scale = FRACUNIT/2
				spark.destscale = FRACUNIT*3/2
				spark.angle = cam.angle + ANGLE_90
			end
		elseif timer == 40
			ANIM_set(mo, mo.anim_special1, true)	-- hammer hit prep

			-- fake A_LobShot:
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / TICRATE

			mo.momx = FixedMul(horizontal, cos(mo.angle))
			mo.momy = FixedMul(horizontal, sin(mo.angle))
			local vertical = FixedMul((gravity*TICRATE), mo.scale)
			mo.momz = vertical
			playSound(mo.battlen, sfx_beflap)


			-- move camera to an interresting spot

			local an = target.angle + 45*ANG1

			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
			--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)
		elseif timer > 40 and timer < 75
			if timer == 68
				ANIM_set(mo, mo.anim_special6)
			end

			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_BLUE
		elseif timer == 75
			local speed = max(FixedHypot(mo.momx, mo.momy)*2, 16*mo.scale)
			mo.momx = 0
			mo.momy = 0
			mo.momz = -speed*P_MobjFlip(mo)*2

			playSound(mo.battlen, sfx_wscub3)
			
			mo.whisperhammer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
			mo.whisperhammer.target = mo
			
			mo.whisperhammer.state = S_INVISIBLE
			mo.whisperhammer.scale = 3*mo.scale/2
			mo.whisperhammer.sprite = SPR_WSHM
			mo.whisperhammer.tics = 2
			
			mo.whisperhammer.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			mo.whisperhammer.blendmode = AST_ADD
			
			A_CapeChase(mo.whisperhammer)

		elseif timer == 105
			mo.whisperhammer = nil
			target.done = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
			return true
		end
		
		if mo.whisperhammer and mo.whisperhammer.valid
			mo.whisperhammer.frame = mo.frame
			
			if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
				mo.whisperhammer.frame = mo.frame + 3
			end
			mo.whisperhammer.tics = $ + 1
			
			local ghost = P_SpawnGhostMobj(mo.whisperhammer)
			ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			ghost.blendmode = AST_ADD
			
			ghost.scalespeed = FixedMul($, ghost.scale)
			ghost.destscale = INT32_MAX
			
			ghost.flags2 = $ | MF2_BOSSNOTRAP
			ghost.frame = $ &~ FF_TRANSMASK
		end
		
		if timer >= 75 and P_IsObjectOnGround(mo) and not target.done
			target.done = true
			playSound(mo.battlen, sfx_pstop)
			
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_SLATE
				dust.scale = FRACUNIT*2
			end
			
			//Circle/Cube effect
			local dust = P_SpawnMobjFromMobj(mo,
			P_ReturnThrustX(nil, mo.angle, mo.height),
			P_ReturnThrustY(nil, mo.angle, mo.height),
			0, MT_DUST)
			
			dust.state = S_INVISIBLE
			dust.tics = 1
			
			dust.radius = mo.radius
			dust.height = mo.radius
			dust.flags = $ &~ MF_NOCLIPHEIGHT
			dust.z = $
			
			WhisperCircle(dust, MT_GHOST, 16, mo.scale, 0,
			mo.scale, 1, SKINCOLOR_BLUE)
			
			WhisperCircle(dust, MT_GHOST, 16, 16*mo.scale, 0,
			mo.scale/2, 1, SKINCOLOR_BLUE)
			
			for i = 1, 2
				local thok = P_SpawnMobj(dust.x, dust.y, dust.z, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_COBALT
				
				thok.scale = dust.scale*i
				thok.height = thok.scale
				thok.z = $ + 4*thok.scale*P_MobjFlip(mo)
				thok.state = S_WHISPER_CIRCLE
				thok.scalespeed = FixedMul($, thok.scale*2)
				thok.destscale = INT32_MAX
			end
			
			playSound(mo.battlen, sfx_wsfrz2)
			for i = 1, 3
				local coin = P_SpawnMobj(target.x, target.y, target.z, MT_WHISPER_RING)
				coin.fuse = 30
				coin.scale = FRACUNIT*2
				coin.momx = P_RandomRange(-20, 20)*FRACUNIT
				coin.momy = P_RandomRange(-20, 20)*FRACUNIT
				coin.momz = P_RandomRange(0, 10)*FRACUNIT
			end
			
			localquake(mo.battlen, FRACUNIT*30, 8)
			damageObject(hittargets[1])
		end
	end,
}

attackDefs["blunt force 2"] = {
	name = "Spinning Top",
	type = ATK_STRIKE,
	power = 140,
	accuracy = 100,
	costtype = CST_HPPERCENT,
	critical = 5,
	hits = 3,
	cost = 10,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Blue is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Strike dmg to one enemy.\nHits three times.\nTires Blue after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
		local cam = server.P_BattleStatus[mo.battlen].cam
			
		if timer >= 10 and timer < 60
			if timer == 10
				playSound(mo.battlen, sfx_s3kaba)
				mo.speen = true
				ANIM_set(mo, mo.anim_special7)
				mo.oldang = mo.angle
				mo.angspd = 0
				mo.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				
				mo.whisperhammer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
				mo.whisperhammer.target = mo
				
				mo.whisperhammer.state = S_INVISIBLE
				mo.whisperhammer.scale = 3*mo.scale/2
				mo.whisperhammer.sprite = SPR_WSHM
				mo.whisperhammer.tics = 2
				
				mo.whisperhammer.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				mo.whisperhammer.blendmode = AST_ADD
				
				A_CapeChase(mo.whisperhammer)
			end
			
			mo.angspd = $ + 1
		elseif timer == 60
			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / 45

			mo.momx = FixedMul(horizontal, cos(ang))
			mo.momy = FixedMul(horizontal, sin(ang))
			playSound(mo.battlen, sfx_cdfm01)


			-- move camera to an interresting spot

			local an = target.angle + 45*ANG1

			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
			--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)
		elseif timer == 105
			mo.momx = 0
			mo.momy = 0
			mo.flags = $ & ~MF_NOCLIPHEIGHT
			P_InstaThrust(mo, target.angle + ANGLE_45, FRACUNIT*20)
			
			damageObject(target)
			
			playSound(mo.battlen, sfx_wsfrz2)
			for i = 1, 3
				local coin = P_SpawnMobj(target.x, target.y, target.z, MT_WHISPER_RING)
				coin.fuse = 30
				coin.scale = FRACUNIT*2
				coin.momx = P_RandomRange(-20, 20)*FRACUNIT
				coin.momy = P_RandomRange(-20, 20)*FRACUNIT
				coin.momz = P_RandomRange(0, 10)*FRACUNIT
			end

			playSound(mo.battlen, sfx_wscub3)
		elseif timer == 140
			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / 20
			mo.flags = $|MF_NOCLIPHEIGHT

			mo.momx = FixedMul(horizontal, cos(ang))
			mo.momy = FixedMul(horizontal, sin(ang))
			playSound(mo.battlen, sfx_cdfm01)
		elseif timer == 160
			mo.momx = 0
			mo.momy = 0
			mo.flags = $ & ~MF_NOCLIPHEIGHT
			P_InstaThrust(mo, target.angle - ANGLE_45, FRACUNIT*20)
			
			damageObject(target)
			
			playSound(mo.battlen, sfx_wsfrz2)
			for i = 1, 3
				local coin = P_SpawnMobj(target.x, target.y, target.z, MT_WHISPER_RING)
				coin.fuse = 30
				coin.scale = FRACUNIT*2
				coin.momx = P_RandomRange(-20, 20)*FRACUNIT
				coin.momy = P_RandomRange(-20, 20)*FRACUNIT
				coin.momz = P_RandomRange(0, 10)*FRACUNIT
			end

			playSound(mo.battlen, sfx_wscub3)
		elseif timer == 195
			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / 20
			mo.flags = $|MF_NOCLIPHEIGHT

			mo.momx = FixedMul(horizontal, cos(ang))
			mo.momy = FixedMul(horizontal, sin(ang))
		elseif timer == 215
			mo.momx = 0
			mo.momy = 0
			mo.flags = $ & ~MF_NOCLIPHEIGHT
			P_InstaThrust(mo, target.angle - ANGLE_45, FRACUNIT*20)
			mo.flags = $ & ~MF_NOGRAVITY
			mo.speen = false
			mo.angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
			
			damageObject(target)
			
			playSound(mo.battlen, sfx_wsfrz2)
			for i = 1, 3
				local coin = P_SpawnMobj(target.x, target.y, target.z, MT_WHISPER_RING)
				coin.fuse = 30
				coin.scale = FRACUNIT*2
				coin.momx = P_RandomRange(-20, 20)*FRACUNIT
				coin.momy = P_RandomRange(-20, 20)*FRACUNIT
				coin.momz = P_RandomRange(0, 10)*FRACUNIT
			end

			playSound(mo.battlen, sfx_pstop)
		elseif timer == 240
			mo.whisperhammer = nil
			target.done = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
			mo.oldang = nil
			mo.speen = nil
			mo.angspeed = nil
			return true
		end
		
		if mo.whisperhammer and mo.whisperhammer.valid
			mo.whisperhammer.frame = mo.frame
			
			if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
				mo.whisperhammer.frame = mo.frame + 3
			end
			mo.whisperhammer.tics = $ + 1
			
			local ghost = P_SpawnGhostMobj(mo.whisperhammer)
			ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			ghost.blendmode = AST_ADD
			
			ghost.scalespeed = FixedMul($, ghost.scale)
			ghost.destscale = INT32_MAX
			
			ghost.flags2 = $ | MF2_BOSSNOTRAP
			ghost.frame = $ &~ FF_TRANSMASK
		end
		
		if mo.speen
			mo.angle = $ + ANG1*mo.angspd
			
			if timer == 10
			or timer == 25
			or (timer >= 36 and timer%6 == 0)
				playSound(mo.battlen, sfx_wdjump)
			end
			
			for i = 1,2
				local spark = P_SpawnMobj(mo.x + 30*cos(P_RandomRange(1,359)*ANG1), mo.y + 30*cos(P_RandomRange(1,359)*ANG1), mo.z, MT_THOK)
				spark.state = S_BUFUDYNE_AURA1
				spark.color = SKINCOLOR_BLUE
				spark.momz = P_RandomRange(2, 9)*FRACUNIT
				spark.scale = FRACUNIT/2
				spark.destscale = FRACUNIT*3/2
				spark.angle = cam.angle + ANGLE_90
			end
			
			if timer%10 == 0
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SLATE
					dust.scale = FRACUNIT*2
				end
			end
			
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_BLUE
		end
	end,
}

attackDefs["blunt force 3"] = {
	name = "Trauma Cyclone",
	type = ATK_STRIKE,
	power = 140,
	accuracy = 100,
	hits = 6,
	costtype = CST_HPPERCENT,
	critical = 3,
	cost = 5,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Blue is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Strike dmg to one enemy.\nHits six times.\nTires Blue after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local cam = server.P_BattleStatus[mo.battlen].cam
		
		if timer == 1 and mo.name == "\x56\x65\x72\x67\x69\x6C"
			playSound(mo.battlen, sfx_vrgmtv)
		elseif timer >= 10 and timer < 40
			if timer == 10
				playSound(mo.battlen, sfx_s3kaba)
				ANIM_set(mo, mo.anim_guard)
			end
			
			for i = 1,2
				local spark = P_SpawnMobj(mo.x + 30*cos(P_RandomRange(1,359)*ANG1), mo.y + 30*cos(P_RandomRange(1,359)*ANG1), mo.z, MT_THOK)
				spark.state = S_BUFUDYNE_AURA1
				spark.color = SKINCOLOR_BLUE
				spark.momz = P_RandomRange(2, 9)*FRACUNIT
				spark.scale = FRACUNIT/2
				spark.destscale = FRACUNIT*3/2
				spark.angle = cam.angle + ANGLE_90
			end
		elseif timer == 40
			ANIM_set(mo, mo.anim_special1, true)	-- hammer hit prep

			-- fake A_LobShot:
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / TICRATE

			mo.momx = FixedMul(horizontal, cos(mo.angle))
			mo.momy = FixedMul(horizontal, sin(mo.angle))
			local vertical = FixedMul(3*(gravity*TICRATE)/4, mo.scale)
			mo.momz = vertical
			playSound(mo.battlen, sfx_beflap)


			-- move camera to an interresting spot

			local an = target.angle + 45*ANG1

			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
			--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)
		elseif timer > 40 and timer < 75
			if timer == 68
				ANIM_set(mo, mo.anim_special7, true)
				mo.speen = true
				mo.angspd = 1
				
				mo.whisperhammer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
				mo.whisperhammer.target = mo
				
				mo.whisperhammer.state = S_INVISIBLE
				mo.whisperhammer.scale = 3*mo.scale/2
				mo.whisperhammer.sprite = SPR_WSHM
				mo.whisperhammer.tics = 2
				
				mo.whisperhammer.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				mo.whisperhammer.blendmode = AST_ADD
				
				playSound(mo.battlen, sfx_wscub3)
				A_CapeChase(mo.whisperhammer)
			end
			
			if mo.angspd
				mo.angspd = $ + 2
			end

			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_BLUE
		elseif timer == 75
			mo.momx = 0
			mo.momy = 0
			mo.flags = $|MF_NOGRAVITY
			mo.momz = -FRACUNIT
			
		elseif timer > 75 and timer < 105
			mo.angspd = $ + 3
		
		elseif timer >= 105 and timer <= 180
			if timer > 160 and timer < 180
				mo.angspd = $ - 5
			elseif timer == 180
				mo.speed = false
				mo.flags = $ & ~MF_NOGRAVITY
			end
			
			if timer%15 == 0
				damageObject(target)
			
				playSound(mo.battlen, sfx_wsfrz2)
				for i = 1, 3
					local coin = P_SpawnMobj(target.x, target.y, target.z, MT_WHISPER_RING)
					coin.fuse = 30
					coin.scale = FRACUNIT*2
					coin.momx = P_RandomRange(-20, 20)*FRACUNIT
					coin.momy = P_RandomRange(-20, 20)*FRACUNIT
					coin.momz = P_RandomRange(0, 10)*FRACUNIT
				end
				
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_SUPERSPARK)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				end

				playSound(mo.battlen, sfx_pstop)
			end

		elseif timer == 220
			mo.whisperhammer = nil
			target.done = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 4
			mo.oldang = nil
			mo.speen = nil
			mo.angspeed = nil
			return true
		end
		
		if mo.whisperhammer and mo.whisperhammer.valid
			mo.whisperhammer.frame = mo.frame
			
			if mo.sprite2 &~ FF_SPR2SUPER == SPR2_MLEL
				mo.whisperhammer.frame = mo.frame + 3
			end
			mo.whisperhammer.tics = $ + 1
			
			local ghost = P_SpawnGhostMobj(mo.whisperhammer)
			ghost.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			ghost.blendmode = AST_ADD
			
			ghost.scalespeed = FixedMul($, ghost.scale)
			ghost.destscale = INT32_MAX
			
			ghost.flags2 = $ | MF2_BOSSNOTRAP
			ghost.frame = $ &~ FF_TRANSMASK
		end
		
		if mo.speen
			mo.angle = $ + ANG1*mo.angspd
			
			if timer%8 == 0
				playSound(mo.battlen, sfx_wdjump)
			end
			
			for i = 1,2
				local spark = P_SpawnMobj(mo.x + 30*cos(P_RandomRange(1,359)*ANG1), mo.y + 30*cos(P_RandomRange(1,359)*ANG1), mo.z, MT_THOK)
				spark.state = S_BUFUDYNE_AURA1
				spark.color = SKINCOLOR_BLUE
				spark.momz = P_RandomRange(2, 9)*FRACUNIT
				spark.scale = FRACUNIT/2
				spark.destscale = FRACUNIT*3/2
				spark.angle = cam.angle + ANGLE_90
			end
			
			if timer%10 == 0
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SLATE
					dust.scale = FRACUNIT*2
				end
			end
			
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_BLUE
		end
	end,
}

attackDefs["w-indigo wall"] = {
	name = "Indigo Wall",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Creates a barrier that highly bolsters\ndefense. Dispels after hit or\nafter three turns.",
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.indigowall
						BTL_logMessage(targets[1].battlen, "Wall already in place.")
						return true
					end
				end,

	target = TGT_ALLY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			local dust = P_SpawnMobjFromMobj(target,
			P_ReturnThrustX(nil, target.angle, target.height),
			P_ReturnThrustY(nil, target.angle, target.height),
			0, MT_DUST)
			
			dust.state = S_INVISIBLE
			dust.tics = 1
			
			dust.radius = target.radius
			dust.height = target.radius
			dust.flags = $ &~ MF_NOCLIPHEIGHT
			dust.z = $
			
			playSound(mo.battlen, sfx_wsfrz1)
			
			WhisperCircle(dust, MT_GHOST, 16, target.scale, 0,
			target.scale, 1, SKINCOLOR_BLUE)
			
			WhisperCircle(dust, MT_GHOST, 16, 16*target.scale, 0,
			target.scale/2, 1, SKINCOLOR_BLUE)
			
			for i = 1, 2
				local thok = P_SpawnMobj(dust.x, dust.y, dust.z, MT_THOK)
				thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
				thok.blendmode = AST_ADD
				thok.color = SKINCOLOR_COBALT
				
				thok.scale = dust.scale*i
				thok.height = thok.scale
				thok.z = $ + 4*thok.scale*P_MobjFlip(target)
				thok.state = S_WHISPER_CIRCLE
				thok.scalespeed = FixedMul($, thok.scale*2)
				thok.destscale = INT32_MAX
			end
		elseif timer > 20 and timer <= 40
			if timer == 24
				playSound(mo.battlen, sfx_mirror)
				BTL_logMessage(targets[1].battlen, "A strong barrier has been erected!")
				target.indigowall = 3
			end
			
			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_BLUE
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end
			end

			for i = 1, 8
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT
				thok.color = SKINCOLOR_BLUE
				thok.tics = P_RandomRange(10, 35)
			end
		end

		if timer == 60
			return true
		end
	end,
}

attackDefs["w-indigo barrier"] = {
	name = "Indigo Barrier",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 24,
	desc = "Creates several barriers that highly\nbolster defense. Dispels after hit\nor after three turns.",
	target = TGT_ALLALLIES,
	anim = function(mo, targets, hittargets, timer)
		for i = 1, #hittargets
			local time = timer - (i-1)*16
			local target = hittargets[i]
			
			if time == 1
				ANIM_set(mo, mo.anim_special3)
			elseif time == 20
				local dust = P_SpawnMobjFromMobj(target,
				P_ReturnThrustX(nil, target.angle, target.height),
				P_ReturnThrustY(nil, target.angle, target.height),
				0, MT_DUST)
				
				dust.state = S_INVISIBLE
				dust.tics = 1
				
				dust.radius = target.radius
				dust.height = target.radius
				dust.flags = $ &~ MF_NOCLIPHEIGHT
				dust.z = $
				
				playSound(mo.battlen, sfx_wsfrz1)
				
				WhisperCircle(dust, MT_GHOST, 16, target.scale, 0,
				target.scale, 1, SKINCOLOR_BLUE)
				
				WhisperCircle(dust, MT_GHOST, 16, 16*target.scale, 0,
				target.scale/2, 1, SKINCOLOR_BLUE)
				
				for i = 1, 2
					local thok = P_SpawnMobj(dust.x, dust.y, dust.z, MT_THOK)
					thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS | RF_FLOORSPRITE
					thok.blendmode = AST_ADD
					thok.color = SKINCOLOR_COBALT
					
					thok.scale = dust.scale*i
					thok.height = thok.scale
					thok.z = $ + 4*thok.scale*P_MobjFlip(target)
					thok.state = S_WHISPER_CIRCLE
					thok.scalespeed = FixedMul($, thok.scale*2)
					thok.destscale = INT32_MAX
				end
			elseif time > 20 and time <= 40
				if time == 24
					playSound(mo.battlen, sfx_mirror)
					BTL_logMessage(targets[1].battlen, "A strong barrier has been erected!")
					target.indigowall = 3
				end
				
				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_BLUE
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_BLUE
					thok.tics = P_RandomRange(10, 35)
				end
			end
		end

		if timer == 60 + (#hittargets-1)*16
			return true
		end
	end,
}

attackDefs["w-rakunda"] = {
	name = "Rakunda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	desc = "Lower an enemy's defence \nby 1 stage.",
	target = TGT_ENEMY,
	debuff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["def"][1] <= -75
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			orb.sprite = SPR_DBUF
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*2
			orb.scalespeed = FRACUNIT/32
			orb.destscale = FRACUNIT/6
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_BLUE

		elseif timer == 5+2*TICRATE
			buffStat(target, "def", -BUFFSTEP)	-- negative values lower a stat
			playSound(mo.battlen, sfx_s3k8c)
			local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
			dbuff.state = S_DBUFF1
			dbuff.color = SKINCOLOR_BLUE
			dbuff.scale = FRACUNIT*5/2

		elseif timer == TICRATE*3
			return true
		end
	end,
}

attackDefs["w-marakunda"] = {
	name = "Marakunda",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Lower enemies' defence \nby 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	norepel = true,
	anim = function(mo, targets, hittargets, timer)

		for i = 1, #targets do

			local target = targets[i]
			
			if timer == 1
				ANIM_set(mo, mo.anim_special3)
			elseif timer == 20 + 8*(i-1)
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_DBUF
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_BLUE

			elseif timer == 5+2*TICRATE + 8*(i-1)
				buffStat(target, "def", -BUFFSTEP)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_BLUE
				dbuff.scale = FRACUNIT*5/2
			end
		end

		if timer == TICRATE*3 + 8*(#targets-1)
			return true
		end
	end,
}

attackDefs["w-fortify"] = {
	name = "Fortify",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Raise own defense \nby 2 stages.",
	target = TGT_CASTER,
	buff = true,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer == 15
			playSound(mo.battlen, sfx_zio5)
		elseif timer >= 20

			local baseangle = P_RandomRange(1, 360)*ANG1
			local dist = 70
			for i = 0, 16
				local angle = baseangle + i*6*ANG1
				local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
				aura.state = S_AURA1
				--if not aura or not aura.valid continue end
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_BLUE
				aura.momz = P_RandomRange(2, 8)*FRACUNIT
				aura.scale = FRACUNIT*2
				aura.destscale = FRACUNIT*5
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
			end
		end
		
		if timer == 70
			playSound(mo.battlen, sfx_buff)
			buffStat(target, "def", 50)
			for i = 1,16
				local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				dust.angle = ANGLE_90 + ANG1* (22*(i-1))
				dust.state = S_CDUST1
				P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
				dust.color = SKINCOLOR_BLUE
				dust.scale = FRACUNIT*2
			end

		elseif timer > 70 and timer <= 100

			if leveltime%2 == 0
				for i = 1,16

					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_BLUE
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end
			end

			local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
			thok.sprite = SPR_SUMN
			thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
			thok.momz = P_RandomRange(6, 16)*FRACUNIT
			thok.color = SKINCOLOR_BLUE
			thok.tics = P_RandomRange(10, 35)
		elseif timer == 110
			return true
		end
	end,
}

// Spike Skills

attackDefs["shrapnel shot 1"] = {
	name = "Shrapnel Shot",
	type = ATK_PIERCE,
	power = 60,
	accuracy = 100,
	costtype = CST_HPPERCENT,
	critical = 2,
	cost = 5,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1] -- heh heh
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Pink is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Light Pierce dmg to one enemy.\nDeals dmg over time.\nTires Pink after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
		elseif timer == 10
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + (mo.height)/2, MT_THOK)
			mo.th.state = S_WHISPER_SAW
			mo.th.scale = 1
			mo.th.destscale = 3*FRACUNIT/2
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
			mo.th.frame = $|FF_FULLBRIGHT
			mo.th.fuse = -1
			mo.th.rollangle = 0
			mo.th.flags = MF_NOGRAVITY
			playSound(mo.battlen, sfx_spin)
			mo.th.angle = ang
		elseif timer == 50
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local speed = 50*FRACUNIT
			local momx = FixedMul(speed, cos(ang))
			local momy = FixedMul(speed, sin(ang))
			momx = FixedMul($, mo.scale)
			momy = FixedMul($, mo.scale)
			mo.th.momx = momx
			mo.th.momy = momy
			playSound(mo.battlen, sfx_wssaw3)
		elseif timer == 75
			playSound(mo.battlen, sfx_wssaw2)
			damageObject(target)
			for i = 1, 32
				local shard = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				shard.state, shard.scale = S_BUFU_PARTICLE_A, mo.scale*3
				shard.colorized = true
				shard.rollangle = P_RandomRange(1,359)*ANG1
				shard.color = SKINCOLOR_SUPERSPIKE3
				shard.fuse = 30
				shard.momx = P_RandomRange(-12, 12)*FRACUNIT
				shard.momy = P_RandomRange(-12, 12)*FRACUNIT
				shard.momz = P_RandomRange(-12, 12)*FRACUNIT
				shard.flags = MF_NOGRAVITY
			end
			
			P_KillMobj(mo.th)
		elseif timer == 80
			playSound(mo.battlen, sfx_spkdth)
			target.w_spikes = 4
		elseif timer == 100
			mo.th = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
		
		if mo.th and mo.th.valid
			for i = 0, 3
				local ghost = P_SpawnGhostMobj(mo.th)
				ghost.renderflags = mo.th.renderflags
				ghost.blendmode = mo.th.blendmode
				ghost.spritexoffset = mo.th.spritexoffset
				ghost.spriteyoffset = mo.th.spriteyoffset
				
				if i
					ghost.fuse = 2
					ghost.type = MT_RAY
					ghost.frame = $ &~ FF_TRANSMASK
				end
			end
			mo.th.rollangle = $ + ANG1*(timer-10)
			
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
		end
	end,
}

attackDefs["shrapnel shot 2"] = {
	name = "Sundering Saws",
	type = ATK_PIERCE,
	power = 140,
	accuracy = 100,
	costtype = CST_HPPERCENT,
	critical = 4,
	cost = 10,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1]
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Pink is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Medium Pierce dmg to one enemy.\nDeals dmg over time.\nTires Pink after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_evoker, true)
			mo.saws = {}
		elseif timer == 10
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + (mo.height)/2, MT_THOK)
			mo.th.state = S_WHISPER_SAW
			mo.th.scale = 1
			mo.th.destscale = 3*FRACUNIT/2
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
			mo.th.frame = $|FF_FULLBRIGHT
			mo.th.fuse = -1
			mo.th.rollangle = 0
			mo.th.flags = MF_NOGRAVITY
			playSound(mo.battlen, sfx_spin)
			mo.th.angle = ang
		elseif timer == 50
			for i = 1, 2
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				local saw = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + (mo.height)/2, MT_THOK)
				saw.state = S_WHISPER_SAW
				saw.scale = 3*FRACUNIT/2
				saw.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
				saw.frame = $|FF_FULLBRIGHT
				saw.fuse = 30
				saw.rollangle = 0
				saw.flags = MF_NOGRAVITY
				playSound(mo.battlen, sfx_spin)
				saw.angle = ang + ((i - 1) and ANGLE_45 or ANGLE_45*(-1))
				mo.saws[#mo.saws+1] = saw
				playSound(mo.battlen, sfx_wsbz)
			end
			
			playSound(mo.battlen, sfx_wssaw1)
			localquake(mo.battlen, FRACUNIT*5, 10)
			playSound(mo.battlen, sfx_wssaw3)
			P_KillMobj(mo.th)
		elseif timer == 80
			playSound(mo.battlen, sfx_wssaw2)
			damageObject(target)
			for i = 1, 48
				local shard = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				shard.state, shard.scale = S_BUFU_PARTICLE_A, mo.scale*3
				shard.colorized = true
				shard.rollangle = P_RandomRange(1,359)*ANG1
				shard.color = SKINCOLOR_SUPERSPIKE3
				shard.fuse = 30
				shard.momx = P_RandomRange(-12, 12)*FRACUNIT
				shard.momy = P_RandomRange(-12, 12)*FRACUNIT
				shard.momz = P_RandomRange(-12, 12)*FRACUNIT
				shard.flags = MF_NOGRAVITY
			end
		elseif timer == 85
			playSound(mo.battlen, sfx_spkdth)
			target.w_spikes = 4
		elseif timer == 100
			mo.th = nil
			mo.saws = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
		
		if mo.th and mo.th.valid
			for i = 0, 3
				local ghost = P_SpawnGhostMobj(mo.th)
				ghost.renderflags = mo.th.renderflags
				ghost.blendmode = mo.th.blendmode
				ghost.spritexoffset = mo.th.spritexoffset
				ghost.spriteyoffset = mo.th.spriteyoffset
				
				if i
					ghost.fuse = 2
					ghost.type = MT_RAY
					ghost.frame = $ &~ FF_TRANSMASK
				end
			end
			mo.th.rollangle = $ + ANG1*(timer-10)
			
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
		end
		
		if mo.saws
			for i = 1, 2
				local s = mo.saws[i]
				if s and s.valid
					for i = 0, 3
						local ghost = P_SpawnGhostMobj(s)
						ghost.renderflags = s.renderflags
						ghost.blendmode = s.blendmode
						ghost.spritexoffset = s.spritexoffset
						ghost.spriteyoffset = s.spriteyoffset
						
						if i
							ghost.fuse = 2
							ghost.type = MT_RAY
							ghost.frame = $ &~ FF_TRANSMASK
						end
					end
					s.rollangle = $ + ANG1*20
					s.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
					
					s.angle = ((i - 1) and ($ - 3*ANG1) or ($ + 3*ANG1))
					local speed = R_PointToDist2(mo.x, mo.y, target.x, target.y)/30
					local momx = FixedMul(speed, cos(s.angle))
					local momy = FixedMul(speed, sin(s.angle))
					momx = FixedMul($, mo.scale)
					momy = FixedMul($, mo.scale)
					s.momx = momx
					s.momy = momy
				end
			end
		end
	end,
}

attackDefs["shrapnel shot 3"] = {
	name = "Heaven's Shredder",
	type = ATK_PIERCE,
	power = 350,
	accuracy = 100,
	costtype = CST_HPPERCENT,
	critical = 6,
	cost = 15,
	nocast = 	function(targets, n)
					local target = targets[n]
					local btl = server.P_BattleStatus[target.battlen]
					local mo = btl.turnorder[1]
					if mo.wispwheel.cooldown[mo.wispwheel.currentwisp]
						BTL_logMessage(mo.battlen, "Pink is too tired to use this!")
						return true
					end
				end,
	norepel = true,
	desc = "Heavy Pierce dmg to one enemy.\nDeals dmg over time.\nTires Pink after use.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			if mo.name == "\x56\x65\x72\x67\x69\x6C"
				playSound(mo.battlen, sfx_vrgmtv)
			end
			
			ANIM_set(mo, mo.anim_evoker, true)
			mo.startx = mo.x
			mo.starty = mo.y
		elseif timer == 10
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			mo.th = P_SpawnMobj(mo.x + 10*cos(mo.angle), mo.y + 10*sin(mo.angle), mo.z + mo.height, MT_THOK)
			mo.th.state = S_WHISPER_SAW
			mo.th.scale = 1
			mo.th.destscale = 2*FRACUNIT
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
			mo.th.frame = $|FF_FULLBRIGHT
			mo.th.fuse = -1
			mo.th.rollangle = 0
			mo.th.flags = MF_NOGRAVITY
			playSound(mo.battlen, sfx_spin)
			mo.th.angle = ang
			mo.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
		elseif timer == 50
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)
			
			local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local speed = dist/21
			mo.th.flags = $|MF_NOCLIPHEIGHT
			P_InstaThrust(mo.th, ang, speed)
			playSound(mo.battlen, sfx_wssaw3)
		elseif timer == 54
			ANIM_set(mo, mo.anim_special5)
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)
			P_InstaThrust(mo, mo.angle, dist/22)
		elseif timer > 50 and timer < 70 and timer%5 == 0
			playSound(mo.battlen, sfx_wssaw1)
		elseif timer == 70
			playSound(mo.battlen, sfx_wssaw2)
			playSound(mo.battlen, sfx_csaw)
			mo.th.momx = 0
			mo.th.momy = 0
			localquake(mo.battlen, FRACUNIT*5, 78)
		elseif timer == 72
			local dist = R_PointToDist2(mo.x, mo.y, mo.startx, mo.starty)
			P_InstaThrust(mo, R_PointToAngle2(mo.x, mo.y, mo.startx, mo.starty), dist/60)
			mo.momz = FRACUNIT*16
			mo.flags = $ & ~MF_NOGRAVITY
			mo.flags = $ & ~MF_NOCLIPHEIGHT
		elseif timer == 74
			ANIM_set(mo, mo.anim_getup, true)
		elseif timer >= 81 and timer <= 120 and timer%6 == 0
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)
			local spike = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			spike.sprite = SPR_WLCR
			spike.tics = 20
			spike.frame = B|FF_PAPERSPRITE|FF_FULLBRIGHT
			spike.color = SKINCOLOR_SUPERSPIKE3
			spike.momz = (target.z - mo.z)/20
			spike.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			spike.scale = FRACUNIT*3
			P_InstaThrust(spike, spike.angle, dist/20)
			playSound(mo.battlen, sfx_thok)
		elseif timer == 148
			for i = 1, 32
				local shard = P_SpawnMobj(mo.th.x, mo.th.y, mo.th.z, MT_THOK)
				shard.state, shard.scale = S_BUFU_PARTICLE_A, mo.scale*3
				shard.colorized = true
				shard.rollangle = P_RandomRange(1,359)*ANG1
				shard.color = SKINCOLOR_SUPERSPIKE3
				shard.fuse = 30
				shard.momx = P_RandomRange(-12, 12)*FRACUNIT
				shard.momy = P_RandomRange(-12, 12)*FRACUNIT
				shard.momz = P_RandomRange(-12, 12)*FRACUNIT
				shard.flags = MF_NOGRAVITY
			end
			damageObject(target)
			playSound(mo.battlen, sfx_wssaw3)
			P_KillMobj(mo.th)
		elseif timer == 150
			playSound(mo.battlen, sfx_cdfm39)
			target.w_spikes = 4
		elseif timer == 170
			mo.th = nil
			mo.wispwheel.cooldown[mo.wispwheel.currentwisp] = 3
			return true
		end
		
		if timer > 100 and P_IsObjectOnGround(mo)
			ANIM_set(mo, mo.anim_stand)
		end
		
		if timer >= 101 and timer <= 140 and timer%6 == 0
			playSound(mo.battlen, sfx_spkdth)
		end
		
		if timer >= 70 and timer <= 140 and timer%10 == 0
			createSplat(mo)
		end
		
		if mo.th and mo.th.valid
			for i = 0, 3
				local ghost = P_SpawnGhostMobj(mo.th)
				ghost.renderflags = mo.th.renderflags
				ghost.blendmode = mo.th.blendmode
				ghost.spritexoffset = mo.th.spritexoffset
				ghost.spriteyoffset = mo.th.spriteyoffset
				
				if i
					ghost.fuse = 2
					ghost.type = MT_RAY
					ghost.frame = $ &~ FF_TRANSMASK
				end
			end
			mo.th.rollangle = min(($ + ANG1*(timer-10)), $ + ANGLE_45)
			
			mo.th.color = SKINCOLOR_SUPERSPIKE1 + abs((timer)%9 - 4)
		end
	end,
}

attackDefs["w-bear trap"] = {
	name = "Bear Trap",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 8,
	desc = "Sets a spike trap on an ally\nthat damages an attacker.",
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.beartrap
						BTL_logMessage(targets[1].battlen, "Spike trap already set.")
						return true
					end
				end,

	target = TGT_ALLY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
			mo.pointy = {}
		elseif timer >= 30 and timer <= 62 and timer%2 == 0
			local ang = target.angle + ((timer - 28)/2)*ANGLE_22h
			local x = target.x + 30*cos(ang)
			local y = target.y + 30*sin(ang)
			
			local spike = P_SpawnMobj(x, y, mo.z, MT_SPIKE)
			spike.fuse = 70 - timer
			spike.colorized = true
			spike.color = SKINCOLOR_SUPERSPIKE3
			spike.flags = MF_NOGRAVITY|MF_NOCLIP
			if timer%4 == 0
				playSound(mo.battlen, sfx_cdfm39)
			end
			mo.pointy[#mo.pointy+1] = spike
		elseif timer == 70
			playSound(mo.battlen, sfx_s236)
			BTL_logMessage(targets[1].battlen, "Spike trap set!")
			target.beartrap = true
		elseif timer == 100
			for i = 1, #mo.pointy
				P_RemoveMobj(mo.pointy[i])
			end
		end

		if timer == 120
			mo.pointy = nil
			return true
		end
	end,
}

attackDefs["w-minefield"] = {
	name = "Minefield",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 8,
	desc = "Sets an explosive trap on all\nallies that damages an attacker.",
	target = TGT_ALLALLIES,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		
		local avgx, avgy = 0, 0
		for i = 1, #btl.turnorder
			avgx = $ + btl.turnorder[i].x/FRACUNIT
			avgy = $ + btl.turnorder[i].y/FRACUNIT
		end
		avgx = ($/#btl.turnorder)	*FRACUNIT
		avgy = ($/#btl.turnorder)	*FRACUNIT
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
		elseif timer >= 30 and timer <= 62 and timer%2 == 0
			local mine = P_SpawnMobj(avgx + P_RandomRange(-300, 300)*FRACUNIT, avgy + P_RandomRange(-300, 300)*FRACUNIT, mo.z, MT_THOK)
			mine.state = S_WMINE1
			mine.scale = FRACUNIT*2
			mine.renderflags = RF_FLOORSPRITE
			playSound(mo.battlen, sfx_s3k9a)
		elseif timer == 70
			BTL_logMessage(targets[1].battlen, "Mine traps set!")
			for i = 1, #hittargets
				hittargets[i].minetrap = true
			end
		end

		if timer == 120
			return true
		end
	end,
}

attackDefs["w-tiger trap"] = {
	name = "Tiger Trap",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 8,
	desc = "Sets a brutal trap on an ally\nthat damages an attacker.",
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.macetrap
						BTL_logMessage(targets[1].battlen, "Trap already set.")
						return true
					end
				end,

	target = TGT_ALLY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1
			ANIM_set(mo, mo.anim_special3)
			mo.pointy = {}
		elseif timer >= 30 and timer <= 62
			if timer%2 == 0
				local ang = target.angle + ((timer - 28)/2)*ANGLE_22h
				local x = target.x + 30*cos(ang)
				local y = target.y + 30*sin(ang)
				
				local spike = P_SpawnMobj(x, y, target.z, MT_SPIKE)
				spike.fuse = 70 - timer
				spike.colorized = true
				spike.color = SKINCOLOR_RED
				spike.flags = MF_NOGRAVITY|MF_NOCLIP
				mo.pointy[#mo.pointy+1] = spike
			end
			
			local ang = target.angle + (timer - 29)*ANGLE_11hh
			local x = target.x + 60*cos(ang)
			local y = target.y + 60*sin(ang)
			
			local spike = P_SpawnMobj(x, y, target.z, MT_SPIKE)
			spike.fuse = 70 - timer
			spike.colorized = true
			spike.color = SKINCOLOR_RED
			spike.flags = MF_NOGRAVITY|MF_NOCLIP
			mo.pointy[#mo.pointy+1] = spike
			
			if timer%4 == 0
				playSound(mo.battlen, sfx_cdfm39)
			end
		elseif timer == 70
			playSound(mo.battlen, sfx_s3k98)
			BTL_logMessage(targets[1].battlen, "Tiger trap set!")
			target.macetrap = true
		elseif timer == 100
			for i = 1, #mo.pointy
				P_RemoveMobj(mo.pointy[i])
			end
		end

		if timer == 120
			mo.pointy = nil
			return true
		end
	end,
}

attackDefs["w-poisma"] = {
	name = "Poisma",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 50,
	statuschance = 50,
	status = COND_POISON,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 5,
	desc = "High chance of inflicting \nPoison on 1 enemy.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				ANIM_set(mo, mo.anim_special3)
			elseif timer == 10
				playSound(mo.battlen, sfx_absorb)
			end

			if timer <= 30
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.state = S_CDUST1
				thok.momz = P_RandomRange(3, 10)*FRACUNIT
				thok.color = SKINCOLOR_PURPLE
				thok.tics = P_RandomRange(10, 35)
				thok.scale = FRACUNIT*3/2
			end

			if timer == 20
				damageObject(target)
			elseif timer == 42
				return true
			end
	end,
}

attackDefs["w-poison mist"] = {
	name = "Poison Mist",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 35,
	statuschance = 35,
	status = COND_POISON,
	costtype = CST_SP,
	luckbased = true,	-- use luck instead of agility
	cost = 12,
	desc = "Low chance of inflicting \nPoison on all enemies.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
			for i = 1, #hittargets
				local target = hittargets[i]

				local t = timer - (i-1)*6

				if t == 1
					ANIM_set(mo, mo.anim_special3)
				elseif t == 10
					playSound(mo.battlen, sfx_absorb)
				end

				if t <= 30
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_CDUST1
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_PURPLE
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT*3/2
				end

				if t == 20
					damageObject(target)
				end
			end

			if timer == 42 + (#hittargets-1)*6
				return true
			end
	end,
}

// Misc Skills

attackDefs["w-disarm"] = {
	name = "Disarm",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 15,
	desc = "Remove enemy traps and walls.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local colors = {SKINCOLOR_BLUE, SKINCOLOR_PINK, SKINCOLOR_BLACK, SKINCOLOR_RED}

		for i = 1, #targets
			local target = targets[i]
			if timer == 20 + (i-1)*10
				playSound(mo.battlen, sfx_status)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				
				target.beartrap = 0
				target.minetrap = 0
				target.macetrap = 0
				
				if target.indigowall
					target.indigowall = 0
					target.endurance = target.truedef
					target.truedef = nil
				end
				
				BTL_logMessage(targets[1].battlen, "Traps and walls nullified.")
			end
		end
		if timer == TICRATE*3/2 + (#targets-1)*10
			return true
		end
	end,
}

attackDefs["w-sweep"] = {
	name = "Sweep",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 15,
	desc = "Remove party spikes and airlifts.",
	target = TGT_ALLALLIES,
	anim = function(mo, targets, hittargets, timer)
		local colors = {SKINCOLOR_GREEN, SKINCOLOR_PINK}

		for i = 1, #targets
			local target = targets[i]
			if timer == 20 + (i-1)*10
				playSound(mo.battlen, sfx_status)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				
				if target.lifted
					target.lifted = 0
					target.agility = target.trueagi
					target.trueagi = nil
				end
				
				target.w_spikes = 0
				
				BTL_logMessage(targets[1].battlen, "Airlifts and spikes nullified.")
			end
		end
		if timer == TICRATE*3/2 + (#targets-1)*10
			return true
		end
	end,
}

// Passive Skills

attackDefs["laser focus 1"] = {
	name = "Laser Focus I",
	type = ATK_PASSIVE|ATK_ELEC,
	desc = "Boost Elec damage by 10%.\n5% increase to attack and defense,\nand 10% increase to speed.",
	power = 10,
	passive = PSV_BOOST,
}

attackDefs["laser focus 2"] = {
	name = "Laser Focus II",
	type = ATK_PASSIVE|ATK_ELEC,
	desc = "Boost Elec damage by 20%.\n10% increase to attack and defense,\nand 20% increase to speed.",
	power = 20,
	passive = PSV_BOOST,
}

attackDefs["laser focus 3"] = {
	name = "Laser Focus III",
	type = ATK_PASSIVE|ATK_ELEC,
	desc = "Boost Elec damage by 40%.\n15% increase to attack and defense,\nand 35% increase to speed.",
	power = 40,
	passive = PSV_BOOST,
}

attackDefs["extra powder 1"] = {
	name = "Extra Powder I",
	type = ATK_PASSIVE|ATK_FIRE,
	desc = "Boost Fire damage by 10%. 20% increase\nto magic attack, and 8% decrease to speed\nand defense. Attacks have recoil.",
	power = 10,
	passive = PSV_BOOST,
}

attackDefs["extra powder 2"] = {
	name = "Extra Powder II",
	type = ATK_PASSIVE|ATK_FIRE,
	desc = "Boost Fire damage by 20%. 40% increase\nto magic attack, and 16% decrease to speed\nand defense. Attacks have recoil.",
	power = 20,
	passive = PSV_BOOST,
}

attackDefs["extra powder 3"] = {
	name = "Extra Powder III",
	type = ATK_PASSIVE|ATK_FIRE,
	desc = "Boost Fire damage by 40%. 60% increase\nto magic attack, and 24% decrease to speed\nand defense. Attacks have recoil.",
	power = 40,
	passive = PSV_BOOST,
}

attackDefs["lightweight boots 1"] = {
	name = "Lightweight Boots I",
	type = ATK_PASSIVE|ATK_PSY,
	desc = "Boost Psychic damage by 10%.\n15% increase to speed,\nand 5% decrease to attack.",
	power = 10,
	passive = PSV_BOOST,
}

attackDefs["lightweight boots 2"] = {
	name = "Lightweight Boots II",
	type = ATK_PASSIVE|ATK_PSY,
	desc = "Boost Psychic damage by 20%.\n30% increase to speed,\nand 15% decrease to attack.",
	power = 20,
	passive = PSV_BOOST,
}

attackDefs["lightweight boots 3"] = {
	name = "Lightweight Boots III",
	type = ATK_PASSIVE|ATK_PSY,
	desc = "Boost Psychic damage by 40%.\n50% increase to speed,\nand 30% decrease to attack.",
	power = 40,
	passive = PSV_BOOST,
}

attackDefs["tank stance 1"] = {
	name = "Tank Stance I",
	type = ATK_PASSIVE|ATK_STRIKE,
	desc = "Boost Strike damage by 10% and trade\n33% of magic attack for physical attack.\nDefense up by 15%, speed down by 5%.",
	power = 10,
	passive = PSV_BOOST,
}

attackDefs["tank stance 2"] = {
	name = "Tank Stance II",
	type = ATK_PASSIVE|ATK_STRIKE,
	desc = "Boost Strike damage by 20% and trade\n66% of magic attack for physical attack.\nDefense up by 30%, speed down by 15%.",
	power = 20,
	passive = PSV_BOOST,
}

attackDefs["tank stance 3"] = {
	name = "Tank Stance III",
	type = ATK_PASSIVE|ATK_STRIKE,
	desc = "Boost Strike damage by 40% and trade\nfull magic attack for physical attack.\nDefense up by 50%, speed down by 30%.",
	power = 40,
	passive = PSV_BOOST,
}

attackDefs["thorned hide 1"] = {
	name = "Thorned Hide I",
	type = ATK_PASSIVE|ATK_PIERCE,
	desc = "Boost Pierce damage by 10%. 15%\nincrease to physical attack, 5% increase\nto speed, and you become thorned.",
	power = 10,
	passive = PSV_BOOST,
}

attackDefs["thorned hide 2"] = {
	name = "Thorned Hide II",
	type = ATK_PASSIVE|ATK_PIERCE,
	desc = "Boost Pierce damage by 20%. 30%\nincrease to physical attack, 10% increase\nto speed, and you become thorned.",
	power = 20,
	passive = PSV_BOOST,
}

attackDefs["thorned hide 3"] = {
	name = "Thorned Hide III",
	type = ATK_PASSIVE|ATK_PIERCE,
	desc = "Boost Pierce damage by 40%. 60%\nincrease to physical attack, 20% increase\nto speed, and you become thorned.",
	power = 40,
	passive = PSV_BOOST,
}

if bionis
	attackDefs["plasma burst 1"].type = ATK_GRAVITY
	attackDefs["plasma burst 2"].type = ATK_GRAVITY
	attackDefs["plasma burst 3"].type = ATK_GRAVITY
	attackDefs["plasma burst 1"].desc = "Light Gravity dmg to one enemy.\nLowers target's agility.\nTires Green after use."
	attackDefs["plasma burst 2"].desc = "Medium Gravity dmg to one enemy.\nLowers target's agility sharply.\nTires Green after use."
	attackDefs["plasma burst 3"].desc = "Medium Gravity dmg to all enemies.\nLowers targets' agility sharply.\nTires Green after use."
	
	personaList["psyche-whisper"].weak = $|ATK_EARTH
	personaList["psyche-whisper"].resist = $|ATK_FOREST|ATK_METAL
end
